; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

SeedRnd MilliSecs()
HidePointer

BtnUpTmr = 125

frmRate = CreateTimer(frameRate)

fntDefault = LoadFont("Garamond", 20, True)

SetFont fntDefault

camDefault = CreateCamera()
CameraProjMode camDefault, 1
MoveEntity camDefault, 0, 25, -65
CameraFogMode camDefault, 1
CameraFogRange camDefault, 150, 350
CameraViewport camDefault, 310, 230, 320, 240

AmbientLight 225, 225, 225

mdlKnight = LoadMD2("models\knight\knight.md2")
EntityTexture mdlKnight, LoadTexture("models\knight\Iron Plate.jpg")
mdlWeapon = LoadMD2("models\knight\axe.md2", mdlKnight)
EntityTexture mdlWeapon, LoadTexture("models\knight\Iron Axe.jpg")

AnimateMD2 mdlKnight, 1, 0.12, 0, 40
AnimateMD2 mdlWeapon, 1, 0.12, 0, 40
TurnEntity mdlKnight, 0, 180, 0

objFloor = CreateTerrain(2)
MoveEntity objFloor, -800, -24, -800
ScaleEntity objFloor, 800, 1, 800
texFloor = LoadTexture("textures\floor_s01.jpg")
ScaleTexture texFloor, 0.0625, 0.0625
EntityTexture objFloor, texFloor
EntityAlpha objFloor, 0.87

mirFloor = CreateMirror()
MoveEntity mirFloor, 0, -24.1, 0

objRoof = CreateTerrain(2)
MoveEntity objRoof, -800, 40, 800
ScaleEntity objRoof, 800, 1, 800
TurnEntity objRoof, 180, 0, 0
texRoof = LoadTexture("textures\wood_s01.jpg")
ScaleTexture texRoof, 0.0625, 0.0625
EntityTexture objRoof, texRoof

Dim objWall(3)
texWall = LoadTexture("textures\wall_s01.jpg")
ScaleTexture texWall, 0.1, 0.25
For count = 1 To 3
	objWall(count) = CreateCube()
	ScaleEntity objWall(count), 200, 33, 1
	MoveEntity objWall(count), 0, 8, 0
	EntityTexture objWall(count), texWall
Next
MoveEntity objWall(1), 0, 0, 200
MoveEntity objWall(2), 200, 0, 0
MoveEntity objWall(3), -200, 0, 0
TurnEntity objWall(2), 0, 90, 0
TurnEntity objWall(3), 0, 90, 0

Dim objWall4(3)
For count = 1 To 3
	objWall4(count) = CreateCube()
	ScaleEntity objWall4(count), 80, 33, 250
	MoveEntity objWall4(count), 0, 8, -200
	EntityTexture objWall4(count), texWall
Next
MoveEntity objWall4(1), -120, 0, -245
MoveEntity objWall4(2), 120, 0, -245
MoveEntity objWall4(3), 0, 60, -0.1
ScaleEntity objWall4(3), 80, 33, 5

Dim objColumns(4)
texColumns = LoadTexture("textures\columns_s01.jpg")
ScaleTexture texColumns, 0.25, 0.25
For count = 1 To 4
	objColumns(count) = CreateCylinder(12)
	ScaleEntity objColumns(count), 12, 33, 12
	MoveEntity objColumns(count), 0, 8, 0
	EntityTexture objColumns(count), texColumns
Next 
MoveEntity objColumns(1), 110, 0, 110
MoveEntity objColumns(2), -110, 0, 110
MoveEntity objColumns(3), 110, 0, -110
MoveEntity objColumns(4), -110, 0, -110

objPicture = CreateCube()
EntityTexture objPicture, LoadTexture("textures\pic_s01.jpg")
ScaleEntity objPicture, 25, 20, 1
MoveEntity objPicture, 199.9, 10, 60
TurnEntity objPicture, 0, 90, 0

imgBackground = LoadImage("images\creation.bmp")
MaskImage imgBackground, 255, 0, 255

imgCursor = LoadImage("images\cursor.bmp")
MaskImage imgCursor, 255, 0, 255

Dim imgBtnUp(3)
Dim imgBtnDn(3)
For x = 0 To 2
	imgBtnUp(x) = LoadImage("images\createb" + (x+1) + "up.jpg")
	MaskImage imgBtnUp(x), 255, 0, 255
	imgBtnDn(x) = LoadImage("images\createb" + (x+1) + "dn.jpg")
	MaskImage imgBtnDn(x), 255, 0, 255
Next

Dim dis$(10)
dis(1) = "Virulant disease"
dis(2) = "Heart problems"
dis(3) = "Alcohol problems"
dis(4) = "Obesity"
dis(5) = "Psychological problems (minor)"
dis(6) = "Psychological problems (mild)"
dis(7) = "Psychological problems (major)"
dis(8) = "Religion"
dis(9) = "Gigantism"
dis(10) = "Dwarfism"

message$ = "None"
Err = 255
focus = 1
screen = 1
reallydone = 0

name$ = "Anonymous"
SeedRnd MilliSecs()
age$ = Str$(Rand(20,70))
father = Rand(1,10)
mother = Rand(1,10)
yngbro = Rand(0,1)
yngsis = Rand(0,1)
oldbro = Rand(0,1)
oldsis = Rand(0,1)
Dim disease(10)
For count = 1 To 10
	disease(count) = Rand(0,4) - 3
	If disease(count) < 0 Then
		disease(count) = 0
	End If
Next
parents = Rand(1,5)
fatherd = Rand(1,7)
motherd = Rand(1,7)
youth = Rand(1,3)
teenage = Rand(1,3)
early = Rand(1,3)
adult = Rand(1,10)
virtue = Rand(1,6)
flaw = Rand(1,6)
quality = Rand(1,3)
possession = Rand(1,3)

temp = 0

Cls
FreeImage imgLoading

skip = False

While Not reallydone

	WaitTimer frmRate

	MoveEntity camDefault, 1, 0, 0
	PointEntity camDefault, mdlKnight

	Gosub Draw2D
	
	mouse = GetMouse()
	key = GetKey()
	If screen = 1
		If mouse = 1
			If MouseArea(110, 50, 280, StringHeight(name$)) And focus <> 1
				If focus = 2 Then
					If Int(age) < 20 Then
						PlaySound sndInvalid
						Err = 0
						message$ = "Age must be between 20 and 70"
						age = "20"
					End If
				End If
				focus = 1
			ElseIf MouseArea(110, 75, 17, 12) And focus <> 2
				If focus = 1 Then
					If Len(name) = 0 Then
						PlaySound sndInvalid
						Err = 0
						message$ = "Name must be longer"
						name = "A"
					End If
				End If
				focus = 2
			Else
				If focus = 2 Then
					If Int(age) < 20 Then
						PlaySound sndInvalid
						Err = 0
						message$ = "Age must be between 20 and 70"
						age = "20"
					End If
				End If
				If focus = 1 Then
					If Len(name) = 0 Then
						PlaySound sndInvalid
						Err = 0
						message$ = "Name must be longer"
						name = "A"
					End If
				End If
				focus = 0
			End If
			If MouseArea(60, 115, 205, 90)
				oldFather = father
				If MouseX() > 163 Then
					father = 6
					temp = 1
				Else
					father = 1
					temp = 0
				End If
				father = father + (MouseY() - 115) / 18
				If temp = 0 Then
					If father > 5
						father = 5
					End If
				ElseIf temp = 1 Then
					If father > 10
						father = 10
					End If
				End If
				If oldFather <> father Then
					PlaySound sndClick
				End If
			End If
			If MouseArea(60, 235, 205, 90)
				oldMother = mother
				If MouseX() > 163 Then
					mother = 6
					temp = 1
				Else
					mother = 1
					temp = 0
				End If
				mother = mother + (MouseY() - 235) / 18
				If temp = 0 Then
					If mother > 5
						mother = 5
					End If
				ElseIf temp = 1 Then
					If mother > 10
						mother = 10
					End If
				End If
				If oldMother <> mother Then
					PlaySound sndClick
				End If
			End If
			If MouseArea(35, 440, 80, 30) ; PREVIOUS
				PlaySound sndInvalid
				Err = 0
				message$ = "You cannot go back from here!"
			End If
			If MouseArea(116, 440, 80, 30) ; NEXT
				If name = "Anonymous" Or name = "A" Then
					PlaySound sndInvalid
					Err = 0
					message$ = "Please enter a name!"
				Else
					PlaySound sndClick
					b2s = 1
					Gosub Draw2D
					UpdateWorld
					RenderWorld
					Delay BtnUpTmr
					b2s = 0
					screen = 2
				End If
			End If
			If MouseArea(197, 440, 80, 30) ; CANCEL
				reallydone = True
				PlaySound sndClick
				skip = True
			End If
			If MouseArea(350, 110, 135, 18)
				PlaySound sndClick
				If yngbro = 0 Then
					yngbro = 1
				Else
					yngbro = 0
				End If
			End If
			If MouseArea(350, 130, 135, 18)
				PlaySound sndClick
				If yngsis = 0 Then
					yngsis = 1
				Else
					yngsis = 0
				End If
			End If
			If MouseArea(350, 150, 135, 18)
				PlaySound sndClick
				If oldbro = 0 Then
					oldbro = 1
				Else
					oldbro = 0
				End If
			End If
			If MouseArea(350, 170, 135, 18)
				PlaySound sndClick
				If oldsis = 0 Then
					oldsis = 1
				Else
					oldsis = 0
				End If
			End If

			FlushMouse 
		End If
		If key > 0
			If focus = 1
				If (key >= 65 And key <= 90) Or (key >= 97 And key <= 122) Or key = 32 Or key = 39 And Len(name) < 20
					If name = "Anonymous" Then
						name = ""
					End If
					name = name + Chr$(key)
					PlaySound sndClick
				Else If key = 8
					If name = "Anonymous" Then
						name = "A"
					End If
					If Len(name) > 0 
						name = Left(name, Len(name) - 1)
						PlaySound sndClick
					Else
						PlaySound sndInvalid
					End If
				ElseIf Len(name) = 20
					Err = 0
					message$ = "Name must be shorter"
					PlaySound sndInvalid
				End If
			End If
			If focus = 2
				If key = 8
					If Len(age) > 0 Then
						age = Left(age, Len(age) - 1)
						PlaySound sndClick
					Else
						PlaySound sndInvalid
					End If
				Else
					If Len(age) = 0 Then
						If (key >= 50 And key <= 55)
							PlaySound sndClick
							age = age + Chr$(key)
						ElseIf (key >= 48 And key <= 57)
							Err = 0
							message$ = "Age must be between 20 and 70"
							PlaySound sndInvalid
						End If
					ElseIf Len(age) = 1 Then
						If age = "7" Then
							If key = 48 Then
								age = age + Chr$(key)
								PlaySound sndClick
							Else
								Err = 0
								message$ = "Age must be between 20 and 70"
								PlaySound sndInvalid
							End If
						Else
							If (key >= 48 And key <= 57)
								PlaySound sndClick
								age = age + Chr$(key)
							End If
						End If
					ElseIf (key >= 48 And key <= 57)
						Err = 0
						message$ = "Age must be between 20 and 70"
						PlaySound sndInvalid
					End If
				End If
			End If
		End If
	ElseIf screen = 2 Then
		If mouse = 1 Then
			If MouseArea(100, 70, 475, 100)
				PlaySound sndClick
				If MouseX() >= 350 Then
					count = Int((MouseY() - 50) / 20) + 5
					If disease(count) = 1 Then
						disease(count) = 0
					Else
						disease(count) = 1
					End If
				Else
					count = Int((MouseY() - 50) / 20)
					If disease(count) = 1 Then
						disease(count) = 0
					Else
						disease(count) = 1
					End If
				End If
			End If
			If MouseArea(100, 200, 150, 99)
				oldParents = parents
				parents = Int((MouseY() - 200) / 20) + 1
				If oldParents <> parents Then
					PlaySound sndClick
				End If
			End If
			If MouseArea(35, 440, 80, 30) ; PREVIOUS
				PlaySound sndClick
				b1s = 1
				Gosub Draw2D
				UpdateWorld
				RenderWorld
				Delay BtnUpTmr
				b1s = 0
				screen = 1
			End If
			If MouseArea(116, 440, 80, 30) ; NEXT
				PlaySound sndClick
				b2s = 1
				Gosub Draw2D
				UpdateWorld
				RenderWorld
				Delay BtnUpTmr
				b2s = 0
				screen = 3
			End If
			If MouseArea(197, 440, 80, 30) ; CANCEL
				reallydone = True
				PlaySound sndClick
				skip = True
			End If
		End If
	ElseIf screen = 3 Then
		If mouse = 1 Then
			If MouseArea(100, 70, 125, 139)
				oldFather = fatherd
				fatherd = Int((MouseY() - 70) / 20) + 1
				If oldFather <> fatherd Then
					PlaySound sndClick
				End If
			End If
			If MouseArea(300, 70, 125, 139)
				oldMother = motherd
				motherd = Int((MouseY() - 70) / 20) + 1
				If oldMother <> motherd
					PlaySound sndClick
				End If
			End If
			If MouseArea(100, 260, 100, 59)
				oldYouth = youth
				youth = Int((MouseY() - 260) / 20) + 1
				If oldYouth <> Youth
					PlaySound sndClick
				End If
			End If
			If MouseArea(35, 440, 80, 30) ; PREVIOUS
				PlaySound sndClick
				b1s = 1
				Gosub Draw2D
				UpdateWorld
				RenderWorld
				Delay BtnUpTmr
				b1s = 0
				screen = 2
			End If
			If MouseArea(116, 440, 80, 30) ; NEXT
				PlaySound sndClick
				b2s = 1
				Gosub Draw2D
				UpdateWorld
				RenderWorld
				Delay BtnUpTmr
				b2s = 0
				screen = 4
			End If
			If MouseArea(197, 440, 80, 30) ; CANCEL
				reallydone = True
				PlaySound sndClick
				skip = True
			End If
		End If
	ElseIf screen = 4 Then
		If mouse = 1 Then
			If MouseArea(100, 70, 100, 59)
				oldYouth = teenage
				teenage = Int((MouseY() - 70) / 20) + 1
				If oldYouth <> teenage Then
					PlaySound sndClick
				End If
			End If
			If MouseArea(100, 160, 100, 59)
				oldYouth = early
				early = Int((MouseY() - 160) / 20) + 1
				If oldYouth <> early Then
					PlaySound sndClick
				End If
			End If
			If MouseArea(70, 270, 200, 99)
				oldYouth = adult
				If MouseX() >= 170 Then
					adult = 5 + Int((MouseY() - 270) / 20) + 1	
				Else
					adult = Int((MouseY() - 270) / 20) + 1	
				End If
				If oldYouth <> adult Then
					PlaySound sndClick
				End If
			End If
			If MouseArea(35, 440, 80, 30) ; PREVIOUS
				PlaySound sndClick
				b1s = 1
				Gosub Draw2D
				UpdateWorld
				RenderWorld
				Delay BtnUpTmr
				b1s = 0
				screen = 3
			End If
			If MouseArea(116, 440, 80, 30) ; NEXT
				PlaySound sndClick
				b2s = 1
				Gosub Draw2D
				UpdateWorld
				RenderWorld
				Delay BtnUpTmr
				b2s = 0
				screen = 5
			End If
			If MouseArea(197, 440, 80, 30) ; CANCEL
				reallydone = True
				PlaySound sndClick
				skip = True
			End If
		End If			
	ElseIf screen = 5 Then
		If mouse = 1 Then
			If MouseArea(100, 70, 100, 119)
				oldVirtue = virtue
				virtue = Int((MouseY() - 70) / 20) + 1
				If oldvirtue <> virtue Then
					PlaySound sndClick
				End If
			End If
			If MouseArea(300, 70, 110, 119)
				oldflaw = flaw
				flaw = Int((MouseY() - 70) / 20) + 1
				If oldflaw <> flaw Then
					PlaySound sndClick
				End If
			End If
			If MouseArea(100, 220, 60, 59)
				oldq = quality
				quality = Int((MouseY() - 220) / 20) + 1
				If oldq <> quality
					PlaySound sndClick
				End If
			End If
			If MouseArea(100, 310, 135, 59)
				oldp = possession
				possession = Int((MouseY() - 310) / 20) + 1
				If oldp <> possession Then
					PlaySound sndClick
				End If
			End If
			If MouseArea(35, 440, 80, 30) ; PREVIOUS
				PlaySound sndClick
				b1s = 1
				Gosub Draw2D
				UpdateWorld
				RenderWorld
				Delay BtnUpTmr
				b1s = 0
				screen = 4
			End If
			If MouseArea(116, 440, 80, 30) ; FINISH
				PlaySound sndClick
				b2s = 1
				Gosub Draw2D
				UpdateWorld
				RenderWorld
				Delay BtnUpTmr
				b2s = 0
				reallydone = True
			End If
			If MouseArea(197, 440, 80, 30) ; CANCEL
				reallydone = True
				PlaySound sndClick
				skip = True
			End If
		End If
	End If

	UpdateWorld
	RenderWorld
	
	DrawImage imgCursor, MouseX(), MouseY()

	Flip

Wend

If Not skip
	AnimateMD2 mdlKnight, 1, 0.12, 40, 46
	AnimateMD2 mdlWeapon, 1, 0.12, 40, 46
	
	sndStep1 = Load3DSound("sounds\foot step1.wav")
	sndStep2 = Load3DSound("sounds\foot step2.wav")
	lstKnight = CreateListener(camDefault, 0.1, 0, 50)
	
	For count = 1 To 300
	
		WaitTimer frmRate
	
		If MD2AnimTime(mdlKnight) > 41 And (Not Step1)
			EmitSound sndStep1, mdlKnight
			Step1 = True
		End If
		If MD2AnimTime(mdlKnight) > 44 And (Not Step2)
			EmitSound sndStep2, mdlKnight
			Step2 = True
		End If
		If MD2AnimTime(mdlKnight) < 41 And Step1
			Step1 = False
			Step2 = False
		End If
			
		MoveEntity mdlKnight, 0, 0, 1.5
		PointEntity camDefault, mdlKnight
	
		Gosub Draw2D
			
		UpdateWorld
		RenderWorld
	
		Flip
	
	Next
End If

FreeSound sndStep1
FreeSound sndStep2

FreeEntity mdlWeapon
FreeEntity mdlKnight
FreeEntity camDefault
camDefault = 0
FreeEntity objPicture
FreeEntity objRoof
FreeEntity objFloor
FreeEntity objColumns(1)
FreeEntity objColumns(2)
FreeEntity objColumns(3)
FreeEntity objColumns(4)
FreeEntity objWall(1)
FreeEntity objWall(2)
FreeEntity objWall(3)
FreeEntity objWall4(1)
FreeEntity objWall4(2)
FreeEntity objWall4(3)
FreeEntity mirFloor
FreeTexture texFloor
FreeTexture texRoof
FreeFont fntDefault
FreeImage imgBackground
FreeImage imgCursor

If Not reallydone
.Draw2D
		DrawImage imgBackground, 0, 0
		If b1s = 0 Then
			DrawImage imgBtnUp(0), 33, 438
		Else
			DrawImage imgBtnDn(0), 33, 438
		End If
		If b2s = 0 Then
			DrawImage imgBtnUp(1), 114, 438
		Else
			DrawImage imgBtnDn(1), 114, 438
		End If
		If b3s = 0 Then
			DrawImage imgBtnUp(2), 195, 438
		Else
			DrawImage imgBtnDn(2), 195, 438
		End If
		
		Color 255, 255, 255
		ShadowText(320, 20, "Character Creation", True, True)
		Color 255, 240, 5
		If screen = 1
			Color 195, 180, 5
			ShadowText(73, 453, "Previous", True, True)
			Color 255, 240, 5
			ShadowText(154, 453, "Next", True, True)
			ShadowText(235, 453, "Cancel", True, True)
		ElseIf screen = 5
			Color 255, 240, 5
			ShadowText(73, 453, "Previous", True, True)
			ShadowText(154, 453, "Finish", True, True)
			ShadowText(235, 453, "Cancel", True, True)
		Else
			Color 255, 240, 5
			ShadowText(73, 453, "Previous", True, True)
			ShadowText(154, 453, "Next", True, True)
			ShadowText(235, 453, "Cancel", True, True)
		End If
		If screen = 1
			Color 255, 255, 255
			ShadowText(35, 390, "Last Error:", False, False)
			Color 255, Int(Err), Int(Err)
			Err = Err + 5
			If Err > 255 Then
				Err = 255
			End If
			ShadowText(40, 405, message, False, False)
			Color 255, 255, 255
			ShadowText(50, 50, "Name: ", False, False)
			ShadowText(50, 70, "Age: ", False, False)
			If focus = 1
				Color 255, 240, 5
				ShadowText(110, 50, name + "|", False, False)
			Else
				Color 5, 205, 5
				ShadowText(110, 50, name, False, False)
			End If
			If focus = 2
				Color 255, 240, 5
				ShadowText(110, 70, age + "|", False, False)
			Else
				Color 5, 205, 5
				ShadowText(110, 70, age, False, False)
			End If
			Color 255, 255, 255
			ShadowText(50, 90, "Your biological father was a(n)...", False, False)
			If father = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(60, 110, "Slave", False, False)
			If father = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(60, 130, "Farmer", False, False)
			If father = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(60, 150, "Rich Merchant", False, False)
			If father = 4 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(60, 170, "Noble", False, False)
			If father = 5 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(60, 190, "Goblin", False, False)
			If father = 6 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(180, 110, "Filthy Thief", False, False)
			If father = 7 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(180, 130, "Scholar", False, False)
			If father = 8 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(180, 150, "Nomad", False, False)
			If father = 9 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(180, 170, "Lord", False, False)
			If father = 10 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(180, 190, "Adventurer", False, False)
			Color 255, 255, 255

			ShadowText(50, 210, "Your biological mother was a(n)...", False, False)
			If mother = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(60, 230, "Peasant", False, False)
			If mother = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(60, 250, "Lady", False, False)
			If mother = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(60, 270, "Lovely Mother", False, False)
			If mother = 4 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(60, 290, "Whore", False, False)
			If mother = 5 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(60, 310, "Merchant", False, False)
			If mother = 6 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(180, 230, "Witch", False, False)
			If mother = 7 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(180, 250, "Ogress", False, False)
			If mother = 8 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(180, 270, "Teacher", False, False)
			If mother = 9 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(180, 290, "Adventuress", False, False)
			If mother = 10 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(180, 310, "Maid", False, False)
			Color 255, 255, 255
			ShadowText(300, 90, "What siblings did you have?", False, False)
			If yngbro = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(350, 110, "Younger brother(s)", False, False)
			If yngsis = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(350, 130, "Younger sister(s)", False, False)
			If oldbro = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(350, 150, "Older brother(s)", False, False)
			If oldsis = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(350, 170, "Older sister(s)", False, False)
		ElseIf screen = 2 Then
			Color 255, 255, 255
			ShadowText(50, 50, "Select any of the followings that apply to one or more member of your family:", False, False)
			For count = 1 To 5
				If disease(count) = 1 Then
					Color 255, 240, 5
				Else
					Color 255, 255, 255
				End If
				ShadowText(100, 50 + count * 20, dis(count), False, False)
			Next
			For count = 6 To 10
				If disease(count) = 1 Then
					Color 255, 240, 5
				Else
					Color 255, 255, 255
				End If
				ShadowText(350, 50 + (count - 5) * 20, dis(count), False, False)
			Next
			Color 255, 255, 255
			ShadowText(50, 180, "What did your parents do to you? They...", False, False)
			If parents = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 200, "abandoned you", False, False)
			If parents = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 220, "educated you", False, False)
			If parents = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 240, "used to beat you up", False, False)
			If parents = 4 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 260, "let you live", False, False)
			If parents = 5 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 280, "made you work", False, False)
		ElseIf screen = 3 Then
			Color 255, 255, 255
			ShadowText(50, 50, "Your father died...", False, False)
			If fatherd = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 70, "of illness", False, False)
			If fatherd = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 90, "of an heart attack", False, False)
			If fatherd = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 110, "executed", False, False)
			If fatherd = 4 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 130, "being killed", False, False)
			If fatherd = 5 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 150, "accidentaly", False, False)
			If fatherd = 6 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 170, "from suicide", False, False)
			If fatherd = 7 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 190, "of nothing", False, False)
			Color 255, 255, 255
			ShadowText(250, 50, "Your mother died...", False, False)
			If motherd = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 70, "of illness", False, False)
			If motherd = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 90, "while giving birth", False, False)
			If motherd = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 110, "executed", False, False)
			If motherd = 4 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 130, "being killed", False, False)
			If motherd = 5 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 150, "accidentaly", False, False)
			If motherd = 6 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 170, "from suicide", False, False)
			If motherd = 7 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 190, "of nothing", False, False)
			Color 255, 255, 255
			ShadowText(50, 220, "During your youth (6-12), you ", False, False)
			ShadowText(50, 240, "frequently...", False, False)
			If youth = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 260, "worked", False, False)
			If youth = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 280, "studied", False, False)
			If youth = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 300, "got beaten up", False, False)
		ElseIf screen = 4 Then
			Color 255, 255, 255
			ShadowText(50, 50, "During your teenage (13-17), you frequently...", False, False)
			If teenage = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 70, "worked", False, False)
			If teenage = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 90, "studied", False, False)
			If teenage = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 110, "got beaten up", False, False)
				
			Color 255, 255, 255
			ShadowText(50, 140, "During your early adulthood (18-20), you frequently...", False, False)
			If early = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 160, "worked", False, False)
			If early = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 180, "studied", False, False)
			If early = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 200, "got beaten up", False, False)
			
			Color 255, 255, 255
			ShadowText(50, 230, "From your early adulthood to now,", False, False)
			ShadowText(50, 250, "you worked as a(n)...", False, False)
			If adult = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(75, 270, "blacksmith", False, False)
			If adult = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(75, 290, "gladiator", False, False)
			If adult = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(75, 310, "robber", False, False)
			If adult = 4 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(75, 330, "tradesman", False, False)
			If adult = 5 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(75, 350, "priest", False, False)
			If adult = 6 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(170, 270, "peasant", False, False)
			If adult = 7 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(170, 290, "fanatic", False, False)
			If adult = 8 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(170, 310, "woodsman", False, False)
			If adult = 9 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(170, 330, "sailor", False, False)
			If adult = 10 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(170, 350, "fisherman", False, False)
		ElseIf screen = 5 Then
			Color 255, 255, 255
			ShadowText(50, 50, "Choose a virtue:", False, False)
			If virtue = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 70, "Muscular", False, False)
			If virtue = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 90, "Tough", False, False)
			If virtue = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 110, "Agile", False, False)
			If virtue = 4 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 130, "Quick", False, False)
			If virtue = 5 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 150, "Perceptive", False, False)
			If virtue = 6 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 170, "Genius", False, False)
			
			Color 255, 255, 255
			ShadowText(250, 50, "Choose a flaw:", False, False)
			If flaw = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 70, "Feeble", False, False)
			If flaw = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 90, "Weak", False, False)
			If flaw = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 110, "Numb", False, False)
			If flaw = 4 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 130, "Slow", False, False)
			If flaw = 5 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 150, "Absent Minded", False, False)
			If flaw = 6 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(300, 170, "Dumb", False, False)
		
			Color 255, 255, 255
			ShadowText(50, 200, "You would qualify yourself best as someone...", False, False)
			If quality = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 220, "fast", False, False)
			If quality = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 240, "leading", False, False)
			If quality = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 260, "healthy", False, False)

			Color 255, 255, 255
			ShadowText(50, 290, "Choose your current possession:", False, False)
			If possession = 1 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 310, "1000 golds", False, False)
			If possession = 2 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 330, "15 potions and 600 golds", False, False)
			If possession = 3 Then
				Color 255, 240, 5
			Else
				Color 255, 255, 255
			End If
			ShadowText(100, 350, "An iron longsword", False, False)

		End If
		
	Return
End If

If Not skip
	If name$ = ""
		name$ = "A"
	End If
	agenum = Int(age)
	
	POW = Rand(47, 55) - ((agenum - 30) / 5) / 2
	RES = Rand(47, 55) - ((agenum - 30) / 5) / 2
	COO = Rand(47, 55) - ((agenum - 30) / 5)
	SPE = Rand(47, 55) - ((agenum - 30) / 5)
	MIN = Rand(47, 55) + ((agenum - 30) / 5) * 2
	AWA = Rand(47, 55) + ((agenum - 30) / 5)
	ALI = (Rand(0, 6) - 3) * 5
	
	Select father
		Case 1
			POW = POW - 5
			RES = RES + 6
			COO = COO + 0
			SPE = SPE + 3
			MIN = MIN - 7
			AWA = AWA + 3
			ALI = ALI - 10
		Case 2
			POW = POW + 4
			RES = RES + 4
			COO = COO - 1
			SPE = SPE - 2
			MIN = MIN - 3
			AWA = AWA - 2
			ALI = ALI + 5
		Case 3
			POW = POW - 6
			RES = RES - 6
			COO = COO + 1
			SPE = SPE + 1
			MIN = MIN + 6
			AWA = AWA + 4
			ALI = ALI - 5
		Case 4
			POW = POW - 0
			RES = RES + 0
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN - 0
			AWA = AWA + 0
			ALI = ALI + 10
		Case 5
			POW = POW - 4
			RES = RES - 3
			COO = COO + 1
			SPE = SPE + 7
			MIN = MIN - 2
			AWA = AWA + 1
			ALI = ALI - 10
		Case 6
			POW = POW - 3
			RES = RES - 3
			COO = COO + 3
			SPE = SPE + 3
			MIN = MIN - 1
			AWA = AWA + 1
			ALI = ALI - 15
		Case 7
			POW = POW - 5
			RES = RES - 5
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 8
			AWA = AWA + 2
			ALI = ALI + 10
		Case 8
			POW = POW + 3
			RES = RES + 2
			COO = COO - 1
			SPE = SPE - 1
			MIN = MIN - 0
			AWA = AWA - 3
			ALI = ALI + 0
		Case 9
			POW = POW - 1
			RES = RES - 2
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 3
			AWA = AWA + 15
			ALI = ALI 
		Case 10
			POW = POW + 2 
			RES = RES + 1
			COO = COO - 2
			SPE = SPE + 0
			MIN = MIN - 2
			AWA = AWA + 1
			ALI = ALI + 0
	End Select
	Select mother
		Case 1
			POW = POW + 2
			RES = RES + 4
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN - 5
			AWA = AWA - 1
			ALI = ALI + 5
		Case 2
			POW = POW - 1
			RES = RES - 1
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 0
			AWA = AWA + 2
			ALI = ALI + 10
		Case 3
			POW = POW + 0
			RES = RES + 0
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 0
			AWA = AWA + 0
			ALI = ALI + 5
		Case 4
			POW = POW - 2
			RES = RES + 1
			COO = COO + 0
			SPE = SPE + 1
			MIN = MIN - 1
			AWA = AWA + 1
			ALI = ALI - 10
		Case 5
			POW = POW - 2
			RES = RES - 3
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 4
			AWA = AWA + 1
			ALI = ALI + 0
		Case 6
			POW = POW - 5
			RES = RES - 4
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 6
			AWA = AWA + 3
			ALI = ALI - 15
		Case 7
			POW = POW + 5
			RES = RES + 6
			COO = COO - 1
			SPE = SPE + 0
			MIN = MIN - 9
			AWA = AWA - 1
			ALI = ALI - 10
		Case 8
			POW = POW - 2
			RES = RES - 1
			COO = COO + 1
			SPE = SPE + 1
			MIN = MIN + 1
			AWA = AWA + 0
			ALI = ALI + 10
		Case 9
			POW = POW + 2
			RES = RES + 1
			COO = COO - 2
			SPE = SPE + 0
			MIN = MIN - 2
			AWA = AWA + 1
			ALI = ALI + 0
		Case 10
			POW = POW + 1
			RES = RES + 1
			COO = COO + 2
			SPE = SPE + 2
			MIN = MIN - 3
			AWA = AWA - 3
			ALI = ALI + 5
	End Select
	If yngbro Then
			POW = POW + 1
			RES = RES - 2
			COO = COO - 2
			SPE = SPE - 2
			MIN = MIN + 1
			AWA = AWA + 4
	End If
	If yngsis Then
			POW = POW + 2
			RES = RES - 1
			COO = COO - 2
			SPE = SPE - 2
			MIN = MIN + 1
			AWA = AWA + 2
	End If
	If oldbro Then
			POW = POW - 2
			RES = RES + 1
			COO = COO + 0
			SPE = SPE + 1
			MIN = MIN - 1
			AWA = AWA + 1
	End If
	If oldsis Then
			POW = POW - 1
			RES = RES - 1
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 2
			AWA = AWA + 0
	End If
	Select fatherd
		Case 1
			POW = POW + 0
			RES = RES - 5
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 2
			AWA = AWA + 3
			ALI = ALI + 10
		Case 2
			POW = POW + 0
			RES = RES - 7
			COO = COO + 0
			SPE = SPE + 4
			MIN = MIN + 1
			AWA = AWA + 2
		Case 3
			POW = POW + 2
			RES = RES + 2
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN - 1
			AWA = AWA - 3
			ALI = ALI - 10
		Case 4
			POW = POW + 1
			RES = RES + 1
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN - 1
			AWA = AWA - 1
		Case 5
			POW = POW + 2
			RES = RES + 1
			COO = COO - 3
			SPE = SPE - 1
			MIN = MIN + 2
			AWA = AWA - 1
		Case 6
			POW = POW + 1
			RES = RES + 1
			COO = COO - 1
			SPE = SPE + 3
			MIN = MIN - 3
			AWA = AWA - 1
			ALI = ALI - 5
		Case 7
			POW = POW + 0
			RES = RES + 0
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 0
			AWA = AWA + 0
			ALI = ALI + 5
	End Select
	Select motherd
		Case 1
			POW = POW + 0
			RES = RES - 3
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 1
			AWA = AWA + 2
			ALI = ALI + 10
		Case 2
			POW = POW - 1
			RES = RES - 1
			COO = COO + 1
			SPE = SPE + 1
			MIN = MIN + 0
			AWA = AWA + 0
		Case 3
			POW = POW + 1
			RES = RES + 1
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 0
			AWA = AWA - 2
			ALI = ALI - 10
		Case 4
			POW = POW + 1
			RES = RES + 1
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN - 1
			AWA = AWA - 1
		Case 5
			POW = POW + 1
			RES = RES + 1
			COO = COO - 2
			SPE = SPE - 1
			MIN = MIN + 2
			AWA = AWA - 1
		Case 6
			POW = POW + 1
			RES = RES + 1
			COO = COO - 1
			SPE = SPE + 1
			MIN = MIN - 1
			AWA = AWA - 1
			ALI = ALI - 5
		Case 7
			POW = POW + 0
			RES = RES + 0
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN + 0
			AWA = AWA + 0
			ALI = ALI + 5
	End Select
	Select youth
		Case 1
			POW = POW + 2
			RES = RES + 2
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN - 2
			AWA = AWA - 2
		Case 2
			POW = POW - 1
			RES = RES - 1
			COO = COO - 1
			SPE = SPE - 1
			MIN = MIN + 2
			AWA = AWA + 2
		Case 3
			POW = POW - 3
			RES = RES + 3
			COO = COO + 0
			SPE = SPE + 2
			MIN = MIN - 3
			AWA = AWA + 1
	End Select
	Select teenage
		Case 1
			POW = POW + 3
			RES = RES + 3
			COO = COO - 1
			SPE = SPE - 1
			MIN = MIN - 2
			AWA = AWA - 2
		Case 2
			POW = POW - 2
			RES = RES - 2
			COO = COO - 2
			SPE = SPE - 2
			MIN = MIN + 4
			AWA = AWA + 4
		Case 3
			POW = POW - 2
			RES = RES + 2
			COO = COO + 0
			SPE = SPE + 1
			MIN = MIN - 1
			AWA = AWA + 0
	End Select
	Select early
		Case 1
			POW = POW + 1
			RES = RES + 1
			COO = COO + 0
			SPE = SPE + 0
			MIN = MIN - 1
			AWA = AWA - 1
		Case 2
			POW = POW - 1
			RES = RES + 0
			COO = COO - 1
			SPE = SPE + 0
			MIN = MIN + 1
			AWA = AWA + 1
		Case 3
			POW = POW - 1
			RES = RES + 1
			COO = COO + 0
			SPE = SPE + 1
			MIN = MIN - 1
			AWA = AWA + 0
	End Select
	Select virtue
		Case 1
			POW = POW + 10
		Case 2
			RES = RES + 10
		Case 3
			COO = COO + 10
		Case 4
			SPE = SPE + 10
		Case 5
			AWA = AWA + 10
		Case 6
			MIN = MIN + 10
	End Select
	Select flaw
		Case 1
			POW = POW - 15
		Case 2
			RES = RES - 15
		Case 3
			COO = COO - 15
		Case 4
			SPE = SPE - 15
		Case 5
			AWA = AWA - 15
		Case 6
			MIN = MIN - 15
	End Select
	MOV = 0
	MOR = 0
	HEA = 0
	CAR = 0
	If disease(1)
		MOV = MOV + 1
		MOR = MOR + 1
		HEA = HEA - 4
		CAR = CAR + 2
	End If
	If disease(2)
		MOV = MOV + 2
		MOR = MOR - 1
		HEA = HEA - 2
		CAR = CAR + 1
	End If
	If disease(3)
		MOV = MOV + 0
		MOR = MOR - 2
		HEA = HEA + 1
		CAR = CAR + 1
	End If
	If disease(4)
		MOV = MOV - 2
		MOR = MOR + 0
		HEA = HEA - 2
		CAR = CAR + 4
	End If
	If disease(5)
		MOV = MOV + 2
		MOR = MOR - 1
		HEA = HEA - 1
		CAR = CAR + 0
	End If
	If disease(6)
		MOV = MOV + 2
		MOR = MOR - 2
		HEA = HEA - 1
		CAR = CAR + 1
		ALI = ALI - 10
	End If
	If disease(7)
		MOV = MOV + 4
		MOR = MOR - 5
		HEA = HEA - 2
		CAR = CAR + 3
		ALI = ALI - 15
	End If
	If disease(8)
		MOV = MOV - 1
		MOR = MOR + 2
		HEA = HEA + 2
		CAR = CAR - 3
		ALI = ALI + 25
	End If
	If disease(9)
		MOV = MOV + 3
		MOR = MOR + 1
		HEA = HEA - 6
		CAR = CAR + 2
	End If
	If disease(10)
		MOV = MOV - 3
		MOR = MOR - 1
		HEA = HEA - 1
		CAR = CAR + 5
	End If
	
	Select parents
		Case 1
			MOV = MOV + 2
			MOR = MOR - 2
			HEA = HEA - 1
			CAR = CAR + 1
		Case 2
			MOV = MOV - 1
			MOR = MOR + 1
			HEA = HEA + 1
			CAR = CAR - 1
		Case 3
			MOV = MOV + 1
			MOR = MOR - 1
			HEA = HEA - 1
			CAR = CAR + 1
		Case 4
			MOV = MOV + 2
			MOR = MOR + 1
			HEA = HEA - 1
			CAR = CAR - 2
		Case 5
			MOV = MOV + 1
			MOR = MOR - 1
			HEA = HEA - 1
			CAR = CAR + 1
	End Select
	
	Select  adult
		Case 1
			ST = 1
			DE = 1
			ME = 1
			ALI = ALI + 5
		Case 2
			ST = 1
			DE = 2
			ME = 0
			ALI = ALI - 5
		Case 3
			ST = 0
			DE = 2
			ME = 1
			ALI = ALI - 15
		Case 4
			ST = 0
			DE = 0
			ME = 3
		Case 5
			ST = 1
			DE = 0
			ME = 2
			ALI = ALI + 20
		Case 6
			ST = 2
			DE = 2
			ME = -1
			ALI = ALI + 5
		Case 7
			ST = 3
			DE = 2
			ME = -2
			ALI = ALI - 10
		Case 8
			ST = 2
			DE = 1
			ME = 0
		Case 9
			ST = 0
			DE = 1
			ME = 2
		Case 10
			ST = -1
			DE = 2
			ME = 2
	End Select
	ST = ST * ((agenum - 15) / 5)
	DE = DE * ((agenum - 15) / 5)
	ME = ME * ((agenum - 15) / 5)
	
	Select quality
		Case 1
			MOV = MOV + 20
			DE = DE + 5
		Case 2
			MOR = MOR + 20
			ME = ME + 5
		Case 3
			HEA = HEA + 10
			CAR = CAR + 10
			ST = ST + 5
	End Select
	
	MOV = MOV + SPE * 2 + COO
	MOR = MOR + AWA * 2 + MIN
	HEA = HEA + RES * 5 / 3 + POW / 4
	CAR = CAR + POW * 3 / 4 + RES / 3
	If MOV < DStatMin Then
		MOV = DStatMin
	End If
	If MOR < DStatMin Then
		MOR = DStatMin
	End If
	If HEA < DStatMin Then
		HEA = DStatMin
	End If
	If CAR < DStatMin Then
		CAR = DStatMin
	End If
	
	ST = ST + POW + RES / 2
	DE = DE + COO + SPE / 2
	ME = ME + MIN + AWA / 2
	
	GOL = ME * 2 / 3
	POT = AWA / 8
	WEA$ = "Iron Axe"
	ARM$ = "Iron Plate"
	WTY = 2
	WME = 1
	AME = 1
	
	Select possession
		Case 1
			GOL = GOL + 1000
		Case 2
			POT = POT + 15
			GOL = GOL + 600
		Case 3
			WEA = "Iron Longsword"
			WTY = 7
	End Select
	
	DAM = WTY + WME + ST / 5
	AB = AME + RES / 5
	HEAT = HEA
	CART = CAR
	MORT = MOR
	MOVT = MOV
	
	STRA = 5
	DERA = 5
	MERA = 5
	
	; SET THE TIME
	year = 1263
	day = 263
	hour = 11
	minute# = 52
	Repeat
		birthDay = Rand(1, 365)
	Until birthDay <> day
	SetLog("Birthday", birthDay + "th day")
	minu$ = Int(minute)
	If Int(minu) < 10 Then
		minu = "0" + minu
	End If
	If minu = "60" Then
		minu = "00"
	End If
	hr$ = Int(hour)
	If hr = "24" Then
		hr = "0"
	End If
	dayS$ = Int(day)
	If dayS = "366" Then
		dayS = "1"
	End If
	SetLog("Date and Time", hr+":"+minu+" on day "+dayS+" of the year "+year)
	
	; GENERATE FIRST ZONE
	zx = Rand(0, 99)
	zy = Rand(0, 99)
	zones.Zone(zx, zy) = New Zone
	zones(zx, zy)\terrain = Rand(1, maxTerrains)
	zones(zx, zy)\texture = Rand(1, maxTerTex)
	ex = Rand(25 + zoneDepth, 225 - zoneDepth)
	zones(zx, zy)\exit1 = "N" + ex
	ex = Rand(25 + zoneDepth, 225 - zoneDepth)
	zones(zx, zy)\exit2 = "E" + ex
	ex = Rand(25 + zoneDepth, 225 - zoneDepth)
	zones(zx, zy)\exit3 = "S" + ex
	ex = Rand(25 + zoneDepth, 225 - zoneDepth)
	zones(zx, zy)\exit4 = "W" + ex
	zones(zx, zy)\exit5 = ""
	FirstZone = False
	EntryPosX = 1280
	EntryPosY = 1280
	EntryAngle = Rand(0, 360)
	For I = 1 To 5
		GenerateQuest(True)
	Next
	
	StartPlay = True
	
	; GENERATE PREDEFINED NPCS
	groups.Group(0) = New Group
	groups(0)\name = "Chaos Minions"
	groups(0)\raceid = 4
	groups(0)\ALI = -1000
	groups(0)\Faction = -1000
	groups(0)\ModelNumber = "05"
	groups(0)\Stats = 3
	
	npcs.NPC = New NPC
	npcs\number = "05"
	npcs\texnumber = "99"
	npcs\x = 1280
	npcs\y = 1280
	npcs\zx = WrapZone(zx + CHAOSZONEOFFSET)
	npcs\zy = WrapZone(zy + CHAOSZONEOFFSET)
	npcs\h = 2
	npcs\w = 2.25
	npcs\name = "Chaos"
	npcs\race = "Daemons"
	npcs\group = 0
	npcs\lastFaction = -1000
	npcs\HEA = 1000
	npcs\HEAT = 1000
	npcs\MOV = 400
	npcs\MOVT = 400
	npcs\MOR = 3000
	npcs\MORT = 3000
	npcs\ST = 400
	npcs\DE = 400
	npcs\ME = 400
	npcs\DAM = 250
	npcs\AB = 50
	npcs\ALI = -1000
	npcs\REA = -1000
	npcs\GOL = 10000

; ORIGINAL STATS (EARLIER THAN 0.2.0)
;	npcs\HEA = 10000
;	npcs\HEAT = 10000
;	npcs\MOV = 500
;	npcs\MOVT = 500
;	npcs\MOR = 15000
;	npcs\MORT = 15000
;	npcs\ST = 500
;	npcs\DE = 500
;	npcs\ME = 500
;	npcs\DAM = 750
;	npcs\AB = 100
;	npcs\ALI = -1000
;	npcs\REA = -1000
;	npcs\GOL = 10000
	
	; GENERATE THE 3 FIRST FACTION GROUPS
	For groupCount = 1 To 3
		groups.Group(groupCount) = New Group
		Repeat
			numPerRace = maxRaceGroup
			groupRace = Rand(0, MaxRaces)
			groups(groupCount)\RaceID = groupRace
			For counter = 0 To groupCount - 1
				If groups(groupCount)\RaceID = groups(counter)\RaceID Then
					numPerRace = numPerRace - 1
				End If
			Next
			alignType = Mid(groupRaces(groupRace), 3, 1)
			groups(groupCount)\ALI = Mid(groupRaces(groupRace), 4, 3)
		Until (numPerRace > 0 And groups(groupCount)\ALI <= 250)
		If Not alignType
			groups(groupCount)\ALI = groups(groupCount)\ALI * -1
		End If
		groups(groupCount)\ModelNumber = Mid(groupRaces(groupRace), 1, 2)
		groups(groupCount)\Stats = Mid(groupRaces(groupRace), 7, 4)
		InitialALI = groups(groupCount)\ALI
		Repeat
			groups(groupCount)\ALI = InitialALI
			pre = Rand(1, 2)
			If pre = 1 Then
				pre = Rand(0, MaxPrefixes)
				alignType = Mid(Prefixes(pre), 1, 1)
				aliChange = Mid(Prefixes(pre), 2, 3)
				If Not alignType
					aliChange = aliChange * -1
				End If
				groups(groupCount)\ALI = groups(groupCount)\ALI + aliChange
				groups(groupCount)\name = Mid(Prefixes(pre), 5) + " " + Mid(groupRaces(groupRace), 11)
			Else
				groups(groupCount)\name = Mid(groupRaces(groupRace), 11)
			End If
			suf = Rand(1, 3)
			If suf < 3 Then
				suf = Rand(0, MaxSuffixes)
				alignType = Mid(Suffixes(suf), 1, 1)
				aliChange = Mid(Suffixes(suf), 2, 3)
				If Not alignType
					aliChange = aliChange * -1
				End If
				groups(groupCount)\ALI = groups(groupCount)\ALI + aliChange
				groups(groupCount)\name = groups(groupCount)\name + " " + Mid(Suffixes(suf), 5)
			End If
			done = True
			For counter = 0 To groupCount - 1
				If groups(groupCount)\name = groups(counter)\name Then
					done = False
				End If
			Next
		Until (done And groups(groupCount)\ALI <= 350)
		groups(groupCount)\Faction = CompREA(ALI, groups(groupCount)\ALI)
		SetLog(groups(groupCount)\Name + " Group Faction", groups(groupCount)\Faction)
	Next
	groupCount = groupCount - 1
	slot = -1
End If