; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

Function MouseArea(x, y, width, height)
	If MouseX() >= x And MouseX() <= x + width
		If MouseY() >= y And MouseY() <= y + height
			Return True
		Else
			Return False
		End If
	Else
		Return False
	End If

End Function

Function ShadowText(x, y, txt$, center_x, center_y)
	r = ColorRed()
	g = ColorGreen()
	b = ColorBlue()
	Color 0, 0, 0
	Text(x+1, y+1, txt$, center_x, center_y)
	Color r, g, b
	Text(x, y, txt$, center_x, center_y)

End Function

Function OutlineText(x, y, txt$, center_x, center_y)
	r = ColorRed()
	g = ColorGreen()
	b = ColorBlue()
	Color 0, 0, 0
	Text(x+1, y, txt$, center_x, center_y)
	Text(x-1, y, txt$, center_x, center_y)
	Text(x, y+1, txt$, center_x, center_y)
	Text(x, y-1, txt$, center_x, center_y)
	Color r, g, b
	Text(x, y, txt$, center_x, center_y)

End Function

Function PointDistance#(x1#, y1#, z1#, x2#, y2#, z2#)
	width# = x1# - x2#
	height# = y1# - y2#
	depth# = z1# - z2#
	Return Sqr#(witdh * width + depth * depth + height * height)

End Function

Function Distance#(x1#, y1#, x2#, y2#)
	width# = x1# - x2#
	height# = y1# - y2#
	dist# = Sqr#(width * width + height * height) 
	Return dist

End Function

Function Reaction$(REA)
	If REA < -550
		Return "Hate"
	ElseIf REA < -300
		Return "Doubt"
	ElseIf REA < -100
		Return "Tolerance"
	ElseIf REA < 100
		Return "Trust"
	Else
		Return "Admiration"
	End If
	
End Function

Function CompREA(ALI, NPCALI)
	REA = ALI - NPCALI
	If NPCALI < -100
		REA = REA * -1
	Else If NPCALI <= 100
		REA = Abs(REA) * -1
	End If
	Return REA

End Function

Function WrapZone(prevZone)
	While prevZone > 99
		prevZone = prevZone - 100
	Wend
	While prevZone < 0
		prevZone = prevZone + 100
	Wend
	Return prevZone
	
End Function

Function Wrap360#(angle#)
	While angle < 0
		angle = angle + 360
	Wend
	While Not(angle < 360)
		angle = angle - 360
	Wend
	Return angle
End Function

Function ALIText$(ALI)
	If ALI < -300 Then
		Return "Satanic"
	ElseIf ALI < -150 Then
		Return "Evil"
	ElseIf ALI < -100 Then
		Return "Mean"
	ElseIf ALI < 100 Then
		Return "Neutral"
	ElseIf ALI < 150 Then
		Return "Polite"
	ElseIf ALI < 300 Then
		Return "Good"
	Else
		Return "Angelic"
	End If
	
End Function

Function PropInWay(x, y, addradius, zonex, zoney)
	inway = False
	For props.Prop = Each Prop
		If props\zx = zonex And props\zy = zoney Then
			If Distance(x, y, props\x, props\y) <= props\radius + addradius Then
				inway = True
			End If
		End If
	Next
	Return inway

End Function

Function NotCompatible(TestVersion$, CurrentVersion$)
	NC = True
	If CurrentVersion$ = TestVersion$ Then
		NC = False
	Else
		If TestVersion$ = "0.2.0 Beta" Then
			NC = False
		End If
		If TestVersion$ = "0.2.1 Beta" Then
			NC = False
		End If
		If TestVersion$ = "0.2.2 Beta" Then
			NC = False
		End If
		If TestVersion$ = "0.3.0 Beta" Then
			NC = False
		End If
	End If
	Return NC
End Function

Function NewBloodEmitter(Typ, Dmg, Mdl)
	BloodEmitters.BloodEmitter = New BloodEmitter
	BloodEmitters\Emt = PW_CreateEmitter()
	PW_SetParticle(BloodEmitters\Emt, objQuad, 0, 0, camDefault, False)
	PW_SetTexture(BloodEmitters\Emt, texBlood, 0, 0, 1)
	PW_SetAlpha(BloodEmitters\Emt, 0.7, 0, 15)
	PW_SetScale(BloodEmitters\Emt, 12, 12, 12, 0, 1)
	PositionEntity BloodEmitters\Emt, EntityX(mdl), EntityY(mdl), EntityZ(mdl)
	If Typ = 1 Then
		PW_SetEmitter(BloodEmitters\Emt, Float(Dmg) / 2, 25, 5, Float(Dmg) / 2, 35, 25)
		PW_SetVelocity(BloodEmitters\Emt, 2, 0.1, 0.99, -0.3)
		RotateEntity BloodEmitters\Emt, 0, EntityYaw(mdl) + 180, 0
	Else
		PW_SetEmitter(BloodEmitters\Emt, Dmg * 2, 25, 5, Float(Dmg) / 5, 35, 35)
		PW_SetVelocity(BloodEmitters\Emt, 4, 0.1, 0.99, -0.3)
		RotateEntity BloodEmitters\Emt, -90, EntityYaw(mdl) + 180, 0
	End If	
	
End Function

Function isOlder(version$, testversion$)
	If version$ = testversion$ Then
		Return False
	Else
		fdv = Mid(version$, 1, 1)
		sdv = Mid(version$, 3, 1)
		tdv = Mid(version$, 5, 1)
		fdt = Mid(testversion$, 1, 1)
		sdt = Mid(testversion$, 3, 1)
		tdt = Mid(testversion$, 5, 1)
		If fdv = fdt Then
			If sdv = sdt Then
				If tdv = tdt Then
					Return False
				ElseIf tdv < tdt Then
					Return True
				Else
					Return False
				End If
			ElseIf sdv < sdt Then
				Return True
			Else
				Return False
			End If
		ElseIf fdv < fdt Then
			Return True
		Else
			Return False
		End If
	End If
End Function