; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

; GENERATE NEW ZONE
If zones(zx, zy) = Null Then
	zones.Zone(zx, zy) = New Zone
; SELECT SOIL
	ChangeType = Rand(1, 7)
	If ChangeType = 1 Then
		TerTex = Rand(1, maxTerTex)
	Else
		TerTex = PreviousZone
	End If
	For Terrains.Terrain = Each Terrain
		If Terrains\ID = TerTex Then
			TerLife# = Terrains\Life#
		End If
	Next
; GENERATE PROPS
	Room = 100.0 * TerLife#
	LowNPC = 5
	HighNPC = 8
	While Room > 0
		NewProp = Rand(1, 1550)
		If NewProp <= 25 Then 
			GenerateStoneHenge()
		ElseIf NewProp <= 55 Then 
			GenerateTreasureChest()
		ElseIf NewProp <= 180 Then 
			GenerateBarrel()
		ElseIf NewProp <= 225 Then 
			GenerateGenStore()
		ElseIf NewProp <= 260 Then 
			GenerateBlackSmith()
		ElseIf NewProp <= 280 Then 
			GenerateTavern()
		ElseIf NewProp <= 300 Then 
			GenerateBlackSmith2()
		ElseIf NewProp <= 320 Then 
			GenerateChurch()
		ElseIf NewProp <= 330 Then 
			GenerateInn()
		ElseIf NewProp <= 350 Then 
			GenerateMage()
		ElseIf NewProp <= 370 Then 
			GenerateTower()
		ElseIf NewProp <= 420 Then 
			GenerateHouses()
		ElseIf NewProp <= 670 Then 
			If TerLife# > 0.10 Then
				GenerateTree()
			End If
		ElseIf NewProp <= 705 Then 
			If TerLife# > 0.30 Then
				GeneratePopulatedArea()
			End If
		ElseIf NewProp <= 745 Then 
			If TerLife# > 0.50 Then
				GenerateVillage()
			End If
		ElseIf NewProp <= 850 Then 
			GenerateNothing()
		ElseIf NewProp <= 900 Then 
			GenerateNPCs()
		ElseIf NewProp <= 950 Then 
			If TerLife# > 0.40 Then
				GenerateWood()
			End If
		ElseIf NewProp <= 975 Then 
			If TerLife# > 0.60 Then
				GenerateForest()
			End If
		ElseIf NewProp <= 1050 Then 
			Room = Room - 5
		ElseIf NewProp <= 1105 Then
			GenerateNPC(0)
		ElseIf NewProp <= 1200 Then
			GenerateQuest()
		ElseIf NewProp <= 1450 Then
			GenerateRock()
		ElseIf NewProp <= 1550 Then
			If TerLife# > 0.30 Then
				GenerateWagon()
			End If
		End If
	Wend

; GENERATE NPCS IN ZONE
	numNPCs = Float(Rand(LowNPC, HighNPC)) * TerLife#
	zoneGroup = Rand(1, groupCount)
	For Counter = 0 To numNPCs
; INITIALISE + ZONE STUFF
		NPCs.NPC = New NPC
		NPCs\zx = zx
		NPCs\zy = zy
; SET TO GROUP
		newZoneGroup = Rand(1, 15)
		If newZoneGroup = 1 Then
			zoneGroup = Rand(1, groupCount)
		End If
		If newZoneGroup = 15 And groupCount < maxGroups - 1 Then
			groupCount = groupCount + 1
			groups.Group(groupCount) = New Group
			Loops = 0
			Repeat
				numPerRace = maxRaceGroup
				groupRace = Rand(0, MaxRaces)
				groups(groupCount)\RaceID = groupRace
				For counter = 0 To groupCount - 1
					If groups(groupCount)\RaceID = groups(counter)\RaceID Then
						numPerRace = numPerRace - 1
					End If
				Next
				If Mid(groupRaces(groupRace), 7, 4) > Float(ST + DE + ME) / 400 And Loops < maxGroups Then
					numPerRace = 0
				End If
				Loops = Loops + 1
			Until numPerRace > 0
			alignType = Mid(groupRaces(groupRace), 3, 1)
			groups(groupCount)\ALI = Mid(groupRaces(groupRace), 4, 3)
			If Not alignType
				groups(groupCount)\ALI = groups(groupCount)\ALI * -1
			End If
			groups(groupCount)\ModelNumber = Mid(groupRaces(groupRace), 1, 2)
			groups(groupCount)\Stats = Mid(groupRaces(groupRace), 7, 4)
			InitialALI = groups(groupCount)\ALI
			Repeat
				groups(groupCount)\ALI = InitialALI
				pre = Rand(1, 2)
				If pre = 1 Then
					pre = Rand(0, MaxPrefixes)
					alignType = Mid(Prefixes(pre), 1, 1)
					aliChange = Mid(Prefixes(pre), 2, 3)
					If Not alignType
						aliChange = aliChange * -1
					End If
					groups(groupCount)\ALI = groups(groupCount)\ALI + aliChange
					groups(groupCount)\name = Mid(Prefixes(pre), 5) + " " + Mid(groupRaces(groupRace), 11)
				Else
					groups(groupCount)\name = Mid(groupRaces(groupRace), 11)
				End If
				suf = Rand(1, 3)
				If suf < 3 Then
					suf = Rand(0, MaxSuffixes)
					alignType = Mid(Suffixes(suf), 1, 1)
					aliChange = Mid(Suffixes(suf), 2, 3)
					If Not alignType
						aliChange = aliChange * -1
					End If
					groups(groupCount)\ALI = groups(groupCount)\ALI + aliChange
					groups(groupCount)\name = groups(groupCount)\name + " " + Mid(Suffixes(suf), 5)
				End If
				done = True
				For counter = 0 To groupCount - 1
					If groups(groupCount)\name = groups(counter)\name Then
						done = False
					End If
				Next
			Until done
			groups(groupCount)\Faction = CompREA(ALI, groups(groupCount)\ALI)
			zoneGroup = groupCount
			SetLog(groups(groupCount)\Name + " Group Faction", groups(groupCount)\Faction)
		End If
		NPCs\group = zoneGroup
		NPCs\lastFaction = groups(NPCs\group)\faction
; SET THE MODEL
		Outer = Rand(1, 30)
		If Outer = 1 Then
			oldGroup = NPCs\group
			NPCs\group = Rand(0, groupCount)
		End If
		NPCs\race = Mid(groupRaces(groups(NPCs\group)\raceID), 11)
		NPCnum$ = groups(NPCs\group)\ModelNumber
		NPCs\number = NPCnum
		Count = 1
; LOAD THE AVAILABLE TEXTURES AND SET ONE
		texTemp = LoadTexture("textures\pic_s01.jpg")
		Repeat
			FreeTexture texTemp
			Numb$ = Count
			If Count < 10 Then
				Numb = "0" + Numb
			End If
			texTemp = LoadTexture("models\npcs\npc" + NPCnum + "-" + numb + ".jpg")
			Count = Count + 1
		Until texTemp = 0
		MaxTex = Count - 2
		newTex = Rand(1, MaxTex)
		Texnum$ = newTex
		If newTex < 10 Then
			Texnum = "0" + Texnum
		End If
		NPCs\texnumber = texnum
		Repeat
			NPCs\X = Rand(60, 2500)
			NPCs\Y = Rand(60, 2500)
		Until (Not PropInWay(NPCs\X, NPCs\Y, 15, zx, zy))

; SET NAME
		maxFirstNames = 0
		filName = ReadFile("data\" + NPCs\Race + "1.dat")
			While (Not Eof(filName))
				FirstNames(maxFirstNames) = ReadLine(filName)
				maxFirstNames = maxFirstNames + 1
			Wend
			maxFirstNames = maxFirstNames - 1
		CloseFile filName
		maxLastNames = 0
		filName = ReadFile("data\" + NPCs\Race + "2.dat")
			While (Not Eof(filName))
				LastNames(maxLastNames) = ReadLine(filName)
				maxLastNames = maxLastNames + 1
			Wend
			maxLastNames = maxLastNames - 1
		CloseFile filName
		firstName = Rand(0, maxFirstNames)
		NPCs\name = FirstNames(firstName) + " "
		secondName = Rand(1, 6)
		If secondName = 1 Then
			secondName = firstName
			While secondName = firstName
				secondName = Rand(0, maxFirstNames)
			Wend
			NPCs\name = NPCs\name + FirstNames(secondName) + " "
		End If
		NPCs\name = NPCs\name + LastNames(Rand(0, maxLastNames))		
		
; STATS GENERATION
		StatsValue# = (HEAT + MOVT + MORT + ST + DE + ME + DAM + AB) * groups(NPCs\Group)\Stats
		BStatsValue = StatsValue * Rnd(0.67, 0.73)
		RStatsValue = StatsValue * Rnd(0.28, 0.32)
		KidNPC = Rand(1, 9)
		If KidNPC = 1 Then
		    BStatsValue = BStatsValue * Rnd(0.65, 0.70)
		    RStatsValue = RStatsValue * Rnd(0.70, 0.75)
		End If
		While BStatsValue > 0
			NPCs\HEA = NPCs\HEA + 10
			NPCs\MOV = NPCs\MOV + 10
			NPCs\MOR = NPCs\MOR + 10
			NPCs\ST = NPCs\ST + 5
			NPCs\DE = NPCs\DE + 5
			NPCs\ME = NPCs\ME + 5
			NPCs\DAM = NPCs\DAM + 3
			NPCs\AB = NPCs\AB + 1
			BStatsValue = BStatsValue - 50
		Wend
		While RStatsValue > 0
			StatChange = Rand(1, 6)
			Select StatChange
				Case 1
					NPCs\HEA = NPCs\HEA + 1
					RStatsValue = RStatsValue - 1
				Case 2
					NPCs\MOR = NPCs\MOR + 1
					RStatsValue = RStatsValue - 1
				Case 3
					NPCs\MOV = NPCs\MOR + 1
					RStatsValue = RStatsValue - 1
				Case 4
					NPCs\ST = NPCs\ST + 1
					RStatsValue = RStatsValue - 1
				Case 5
					NPCs\DE = NPCs\DE + 1
					RStatsValue = RStatsValue - 1
				Case 6
					NPCs\ME = NPCs\ME + 1
					RStatsValue = RStatsValue - 1
			End Select
		Wend

		NPCs\ALI = groups(NPCs\group)\ALI
		NPCs\GOL = Rand(15, 50) * groups(NPCs\Group)\Stats * groups(NPCs\Group)\Stats
		cd# = groups(NPCs\Group)\Stats
		If outer = 1 Then
			mp# = groups(NPCs\group)\Stats
			NPCs\HEA = NPCs\HEA / groups(NPCs\group)\Stats
			NPCs\MOV = NPCs\MOV / groups(NPCs\group)\Stats
			NPCs\MOR = NPCs\MOV / groups(NPCs\group)\Stats
			NPCs\ST = NPCs\ST / groups(NPCs\group)\Stats
			NPCs\ME = NPCs\ME / groups(NPCs\group)\Stats
			NPCs\DE = NPCs\DE / groups(NPCs\group)\Stats
			NPCs\DAM = NPCs\DAM / groups(NPCs\group)\Stats
			NPCs\AB = NPCs\AB / groups(NPCs\group)\Stats
			NPCs\GOL = NPCs\GOL / groups(NPCs\group)\Stats
			NPCs\group = oldGroup
			mp# = (mp + groups(NPCs\group)\Stats) / 2
			NPCs\HEA = NPCs\HEA * mp
			NPCs\MOV = NPCs\MOV * mp
			NPCs\MOR = NPCs\MOV * mp
			NPCs\ST = NPCs\ST * mp
			NPCs\ME = NPCs\ME * mp
			NPCs\DE = NPCs\DE * mp
			NPCs\DAM = NPCs\DAM * mp
			NPCs\AB = NPCs\AB * mp
			NPCs\GOL = NPCs\GOL * mp
			NPCs\ALI = (NPCs\ALI + groups(NPCs\group)\ALI) / 2
			cd = (cd * 2/3 + Float(groups(NPCs\Group)\Stats) * 1/3)
		End If
		NPCs\ALI = NPCs\ALI + Rand(0, 100) - 50
		NPCs\REA = CompREA(ALI, NPCs\ALI)
		NPCs\HEAT = NPCs\HEA
		NPCs\MOVT = NPCs\MOV
		NPCs\MORT = NPCs\MOR

; SCALE FROM CONSIDER
		Consider1# = NPCs\ST + NPCs\DE + NPCs\ME + NPCs\DAM * 0.1 + NPCs\AB * 0.15
		Consider2# = ST + DE + ME + DAM * 0.1 + AB * 0.15
		Consi# = (Consider1 / Consider2) / CD
		NPCs\W = Consi + Rnd(0, 0.1) - 0.05
		NPCs\H = Consi + Rnd(0, 0.1) - 0.05
		
; ITEMS GENERATION
		numItems = Rand(2, 8) * groups(NPCs\Group)\Stats
		NPCs\items = ""
		For count = 1 To numItems
			newItem$ = Rand(0, maxItems)
			If Len(newItem) < 2 Then
				newItem = "0" + newItem
			End If
			If Len(newItem) < 3 Then
				newItem = "0" + newItem
			End If
			itemValue$ = Rand(getLow(valuables(newItem)), getHigh(valuables(newItem)))
			If Len(itemValue) < 2 Then
				itemValue = "0" + itemValue
			End If
			If Len(itemValue) < 3 Then
				itemValue = "0" + itemValue
			End If
			NPCs\items = NPCs\items + newItem + itemValue
		Next		
		
	Next

; GENERATE ZONE
	zones(zx, zy)\texture = TerTex
	zones(zx, zy)\terrain = Rand(1, maxTerrains)
	numExits = Rand(3,5)
	checkZones(0) = zy - 1
	checkZones(1) = zy + 1
	checkZones(2) = zx - 1
	checkZones(3) = zx + 1
	For Count = 0 To 3
		If checkZones(Count) > 99 Then
			checkZones(Count) = 0
		ElseIf checkZones(Count) < 0 Then
			checkZones(Count) = 99
		End If
		enabledDir(Count) = True
	Next
	exitCount = 0
	
; CHECK NORTH ZONE
	If zones(zx, checkZones(0)) <> Null Then
		enabledDir(0) = False
		Exits(0) = zones(zx, checkZones(0))\exit1
		Exits(1) = zones(zx, checkZones(0))\exit2
		Exits(2) = zones(zx, checkZones(0))\exit3
		Exits(3) = zones(zx, checkZones(0))\exit4
		Exits(4) = zones(zx, checkZones(0))\exit5
		For Counter = 0 To 4
			zonID$ = Left(exits(counter), 1)
			If zonID <> "" Then
				extPos = Mid(exits(counter), 2)
			End If	
			If zonID = "S" Then
				numExits = numExits - 1
				exitCount = exitCount + 1
				If exitCount = 1 Then
					zones(zx, zy)\exit1 = "N" + extPos
				ElseIf exitCount = 2 Then
					zones(zx, zy)\exit2 = "N" + extPos
				ElseIf exitCount = 3 Then
					zones(zx, zy)\exit3 = "N" + extPos
				ElseIf exitCount = 4 Then
					zones(zx, zy)\exit4 = "N" + extPos
				ElseIf exitCount = 5 Then
					zones(zx, zy)\exit5 = "N" + extPos
				End If			
			End If
		Next
	End If

; CHECK SOUTH ZONE
	If zones(zx, checkZones(1)) <> Null Then
		enabledDir(1) = False
		Exits(0) = zones(zx, checkZones(1))\exit1
		Exits(1) = zones(zx, checkZones(1))\exit2
		Exits(2) = zones(zx, checkZones(1))\exit3
		Exits(3) = zones(zx, checkZones(1))\exit4
		Exits(4) = zones(zx, checkZones(1))\exit5
		For Counter = 0 To 4
			zonID$ = Left(exits(counter), 1)
			If zonID <> "" Then
				extPos = Mid(exits(counter), 2)
			End If	
			If zonID = "N" Then
				numExits = numExits - 1
				exitCount = exitCount + 1
				If exitCount = 1 Then
					zones(zx, zy)\exit1 = "S" + extPos
				ElseIf exitCount = 2 Then
					zones(zx, zy)\exit2 = "S" + extPos
				ElseIf exitCount = 3 Then
					zones(zx, zy)\exit3 = "S" + extPos
				ElseIf exitCount = 4 Then
					zones(zx, zy)\exit4 = "S" + extPos
				ElseIf exitCount = 5 Then
					zones(zx, zy)\exit5 = "S" + extPos
				End If			
			End If
		Next
	End If
		
; CHECK WEST ZONE
	If zones(checkZones(2), zy) <> Null Then
		enabledDir(2) = False
		Exits(0) = zones(checkZones(2), zy)\exit1
		Exits(1) = zones(checkZones(2), zy)\exit2
		Exits(2) = zones(checkZones(2), zy)\exit3
		Exits(3) = zones(checkZones(2), zy)\exit4
		Exits(4) = zones(checkZones(2), zy)\exit5
		For Counter = 0 To 4
			zonID$ = Left(exits(counter), 1)
			If zonID <> "" Then
				extPos = Mid(exits(counter), 2)
			End If	
			If zonID = "E" Then
				numExits = numExits - 1
				exitCount = exitCount + 1
				If exitCount = 1 Then
					zones(zx, zy)\exit1 = "W" + extPos
				ElseIf exitCount = 2 Then
					zones(zx, zy)\exit2 = "W" + extPos
				ElseIf exitCount = 3 Then
					zones(zx, zy)\exit3 = "W" + extPos
				ElseIf exitCount = 4 Then
					zones(zx, zy)\exit4 = "W" + extPos
				ElseIf exitCount = 5 Then
					zones(zx, zy)\exit5 = "W" + extPos
				End If			
			End If
		Next
	End If

; CHECK EAST ZONE
	If zones(checkZones(3), zy) <> Null Then
		enabledDir(3) = False
		Exits(0) = zones(checkZones(3), zy)\exit1
		Exits(1) = zones(checkZones(3), zy)\exit2
		Exits(2) = zones(checkZones(3), zy)\exit3
		Exits(3) = zones(checkZones(3), zy)\exit4
		Exits(4) = zones(checkZones(3), zy)\exit5
		For Counter = 0 To 4
			zonID$ = Left(exits(counter), 1)
			If zonID <> "" Then
				extPos = Mid(exits(counter), 2)
			End If	
			If zonID = "W" Then
				numExits = numExits - 1
				exitCount = exitCount + 1
				If exitCount = 1 Then
					zones(zx, zy)\exit1 = "E" + extPos
				ElseIf exitCount = 2 Then
					zones(zx, zy)\exit2 = "E" + extPos
				ElseIf exitCount = 3 Then
					zones(zx, zy)\exit3 = "E" + extPos
				ElseIf exitCount = 4 Then
					zones(zx, zy)\exit4 = "E" + extPos
				ElseIf exitCount = 5 Then
					zones(zx, zy)\exit5 = "E" + extPos
				End If			
			End If
		Next
	End If

; IF STILL ENOUGH ROOM, MAKE NEW EXITS
	DisabledCount = 0
	For Count = 0 To 3
		OtherDir(Count) = 0
		CountDir(Count) = 0
	Next
	While numExits > 1 And DisabledCount < 4
		DisabledCount = 0
		For Count = 0 To 3
			If Not enabledDir(Count) Then
				DisabledCount = DisabledCount + 1
			End If
		Next
		NewExit = Rand(0, 3)
		If enabledDir(NewExit) And CountDir(NewExit) < 2 Then
			CountDir(NewExit) = CountDir(NewExit) + 1
			If OtherDir(NewExit) <> 0 Then
				ex = OtherDir(NewExit)
				DiffEx = Abs(OtherDir(NewExit) - ex)
				While DiffEx <= zoneDepth * 2
					ex = Rand(25 + zoneDepth, 225 - zoneDepth)
					DiffEx = Abs(OtherDir(NewExit) - ex)
				Wend
			Else
				ex = Rand(25 + zoneDepth, 225 - zoneDepth)
				OtherDir(NewExit) = ex
			End If
			exitCount = exitCount + 1
			numExits = numExits - 1
			Select NewExit
				Case 0
					znDir$ = "N"
				Case 1
					znDir$ = "S"
				Case 2
					znDir$ = "W"
				Case 3
					znDir$ = "E"
			End Select
			If exitCount = 1 Then
				zones(zx, zy)\exit1 = znDir + ex
			ElseIf exitCount = 2 Then
				zones(zx, zy)\exit2 = znDir + ex
			ElseIf exitCount = 3 Then
				zones(zx, zy)\exit3 = znDir + ex
			ElseIf exitCount = 4 Then
				zones(zx, zy)\exit4 = znDir + ex
			ElseIf exitCount = 5 Then
				zones(zx, zy)\exit5 = znDir + ex
			End If
		End If
	Wend
Else
	For NPCs.NPC = Each NPC
		If NPCs\zx = zx And NPCs\zy = zy Then
			diff = groups(NPCs\group)\Faction - NPCs\lastFaction
			If diff <> 0 Then
				NPCs\REA = NPCs\REA + diff
				NPCs\lastFaction = NPCs\lastFaction + diff
			End If
		End If
	Next		
End If