; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/


; LOAD KNIGHT AND WEAPON
mdlKnight = LoadMD2("models\knight\knight.md2")
texKnight = LoadTexture("models\knight\" + ARM + ".jpg")
EntityTexture mdlKnight, texKnight
LoadW$ = Mid(WEA, Instr(WEA, " ") + 1)
mdlWeapon = LoadMD2("models\knight\" + LoadW + ".md2", mdlKnight)
texWeapon = LoadTexture("models\knight\" + WEA + ".jpg")
EntityTexture mdlWeapon, texWeapon
AnimateMD2 mdlKnight, 1, AnimSpeed, 0, 40
AnimateMD2 mdlWeapon, 1, AnimSpeed, 0, 40
PositionEntity mdlKnight, EntryPosX, TerrainY(terZone, EntityX(mdlKnight), EntityY(mdlKnight), EntityZ(mdlKnight)) + 24, EntryPosY
RotateEntity mdlKnight, 0, EntryAngle, 0
EntityType mdlKnight, typModels
EntityRadius mdlKnight, 15
lstKnight = CreateListener(mdlKnight, 0.1, 0, 50)

; SET CAMERAS
pvtCam = CreatePivot(mdlKnight)
MoveEntity pvtCam, 0, 75, -85
camDefault = CreateCamera()
CameraProjMode camDefault, 1
PositionEntity camDefault, EntityX(pvtCam, True), EntityY(pvtCam, True), EntityZ(pvtCam, True)
CameraViewport camDefault, 0, 0, 640, 330
CameraFogMode camDefault, 1
	If hour >= 3 And hour < 9 Then
		timeset = minute + (hour - 3) * 60
		CameraClsColor camDefault, timeset / 2, timeset / 2, 75 + timeset / 2
		CameraFogColor camDefault, timeset / 2, timeset / 2, 75 + timeset / 2
		CameraFogRange camDefault, 140 + timeset, 440 + timeset
		AmbientLight 75 + timeset / 2, 75 + timeset / 2, 75 + timeset / 2
	ElseIf hour >= 15 And hour < 21 Then
		timeset = minute + (hour - 15) * 60
		CameraClsColor camDefault, 180 - timeset / 2, 180 - timeset / 2, 255 - timeset / 2
		CameraFogColor camDefault, 180 - timeset / 2, 180 - timeset / 2, 255 - timeset / 2
		CameraFogRange camDefault, 500 - timeset, 800 - timeset
		AmbientLight 255 - timeset / 2, 255 - timeset / 2, 255 - timeset / 2
	ElseIf hour >= 9 And hour < 15 Then
		CameraClsColor camDefault, 180, 180, 255
		CameraFogColor camDefault, 180, 180, 255
		CameraFogRange camDefault, 500, 800
		AmbientLight 255, 255, 255
	Else		
		CameraClsColor camDefault, 0, 0, 75
		CameraFogColor camDefault, 0, 0, 75
		CameraFogRange camDefault, 140, 440
		AmbientLight 75, 75, 75
	End If
CameraRange camDefault, 1, 800

; LOAD GRAPHICS
imgInterface = LoadImage("images\interface.bmp")
MaskImage imgInterface, 255, 0, 255
imgCursor = LoadImage("images\cursor.bmp")
MaskImage imgCursor, 255, 0, 255
imgBlankBar = LoadImage("images\blankbar.jpg")
MaskImage imgBlankBar, 255, 0, 255
imgHEA = LoadImage("images\lifebar.jpg")
imgMOR = LoadImage("images\moralebar.jpg")
imgMOV = LoadImage("images\movebar.jpg")
imgNorth = LoadImage("images\direction.bmp")
MaskImage imgNorth, 255, 0, 255
MidHandle imgNorth
imgDisable = LoadImage("images\disablebutton.bmp")
MaskImage imgDisable, 255, 0, 255
imgTarget = LoadImage("images\target.bmp")
MaskImage imgTarget, 255, 0, 255
imgMsg = LoadImage("images\imsg.bmp")
MaskImage imgMsg, 255, 0, 255
imgRadar = LoadImage("images\radar.bmp")
MaskImage imgRadar, 255, 0, 255
Dim imgYou(360)
For i = 0 To 360
	imgYou(i) = LoadImage("images\you.bmp")
	MidHandle imgYou(i)
	MaskImage imgYou(i), 255, 0, 255
	RotateImage imgYou(i), 360 - i
Next
imgQuests = LoadImage("images\quest.bmp")
MaskImage imgQuests, 255, 0, 255
MidHandle imgQuests
imgTreasure = LoadImage("images\treasure.bmp")
MaskImage imgTreasure, 255, 0, 255
MidHandle imgTreasure
imgShops = LoadImage("images\shop.bmp")
MaskImage imgShops, 255, 0, 255
MidHandle imgShops
imgMap = LoadImage("images\map.bmp")
MaskImage imgMap, 255, 0, 255
imgTrade = LoadImage("images\trade.jpg")
MaskImage imgTrade, 255, 0, 255
imgDTrade = LoadImage("images\disabletrade.bmp")
MaskImage imgDTrade, 255, 0, 255
imgLog = LoadImage("images\log.jpg")
MaskImage imgLog, 255, 0, 255
imgBtnShop = LoadImage("images\btnShop.jpg")
MaskImage imgBtnShop, 255, 0, 255
imgBtnTreasure = LoadImage("images\btnTreasure.jpg")
MaskImage imgBtnTreasure, 255, 0, 255
imgBtnQuest = LoadImage("images\btnQuest.jpg")
MaskImage imgBtnQuest, 255, 0, 255
imgSphere = LoadImage("images\sphere.bmp")
MaskImage imgSphere, 255, 0, 255

; LOAD SOUNDS
.LoadSounds
sndDie = LoadSound("sounds\die.wav")
sndDrink = LoadSound("sounds\drink potion.wav")
sndMoney = LoadSound("sounds\money.wav")
sndMiss = LoadSound("sounds\miss.wav")
sndHit = LoadSound("sounds\hit.wav")
sndStep1 = Load3DSound("sounds\foot step1.wav")
sndStep2 = Load3DSound("sounds\foot step2.wav")
sndStep3 = Load3DSound("sounds\foot step1.wav")
sndStep4 = Load3DSound("sounds\foot step2.wav")
sndTreasure = Load3DSound("sounds\treasure.wav")
sndMusic = LoadSound("sounds\music.mp3")
SoundVolume sndMusic, 0.5
LoopSound sndMusic
PlaySound sndMusic
SoundVolume sndStep3, 0.3
SoundVolume sndStep4, 0.3

; SET SOME DEFAULT VALUES
mdlTemp = CreateCube()
MoveEntity mdlTemp, 5000, 5000, 5000
moving = False
lastfps = 40
RealTime = True
Target = 0
Freed = False
timeGoing = 1
Weather = 0

FlushMouse
FlushKeys