; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

texLogo = LoadTexture("images\logo.jpg")
objLogo = CreateCube()
EntityTexture objLogo, texLogo

AmbientLight 255, 255, 255

camDefault = CreateCamera()
CameraProjMode camDefault, 1

MoveEntity camDefault, 0, 0, -8.5

ScaleEntity objLogo, 8, 6, 0.1

ResetSkip()

alpha# = 0

While alpha < 1 And (Not CheckSkip())

	WaitTimer frmRate

	EntityAlpha objLogo, alpha
	
	UpdateWorld
	RenderWorld
	
	Flip
	
	alpha = alpha + 0.02

Wend

timr = MilliSecs()
While timr > MilliSecs() - 2000 And (Not CheckSkip())
Wend

While alpha > 0 And (Not CheckSkip())

	WaitTimer frmRate

	EntityAlpha objLogo, alpha
	
	UpdateWorld
	RenderWorld
	
	Flip

	alpha = alpha - 0.03

Wend

FlushKeys
FreeTexture texLogo
FreeEntity objLogo
ResetSkip()

AmbientLight 225, 225, 225

sndMusic = LoadSound("sounds\intro.mp3")
LoopSound sndMusic
SoundVolume sndMusic, 0.4
PlaySound sndMusic

yIntro# = 960
Dim IntroText$(39)
filIntro = ReadFile("data\intro.dat")
	For Count = 0 To 38
		IntroText(Count) = ReadLine(filIntro)
	Next
CloseFile filIntro

fntIntro = LoadFont("Times New Roman", 30, True)
SetFont fntIntro
Color 60, 110, 165

mdlKnight = LoadMD2("models\knight\knight.md2")
EntityTexture mdlKnight, LoadTexture("models\knight\Iron Plate.jpg")
mdlWeapon = LoadMD2("models\knight\flail.md2", mdlKnight)
EntityTexture mdlWeapon, LoadTexture("models\knight\Iron Flail.jpg")
AnimateMD2 mdlKnight, 1, 0.12, 40, 46
AnimateMD2 mdlWeapon, 1, 0.12, 40, 46

objFloor = CreateTerrain(2)
MoveEntity objFloor, -1165, -24, -800
ScaleEntity objFloor, 800, 1, 800
texFloor = LoadTexture("textures\floor_s01.jpg")
ScaleTexture texFloor, 0.0625, 0.0625
EntityTexture objFloor, texFloor
EntityAlpha objFloor, 0.87

mirFloor = CreateMirror()
MoveEntity mirFloor, 0, -24.1, 0

objRoof = CreateTerrain(2)
MoveEntity objRoof, -1165, 50, 800
ScaleEntity objRoof, 800, 1, 800
texRoof = LoadTexture("textures\wood_s01.jpg")
ScaleTexture texRoof, 0.0625, 0.0625
EntityTexture objRoof, texRoof
TurnEntity objRoof, 180, 0, 0

texWall = LoadTexture("textures\wall_s01.jpg")
ScaleTexture texWall, 0.2, 0.3

Dim objWall(8)
objWall(1) = CreateCube()
ScaleEntity objWall(1), 200, 50, 200
MoveEntity objWall(1), 235, 24, 135
EntityTexture objWall(1), texWall

objWall(2) = CreateCube()
ScaleEntity objWall(2), 200, 50, 200
MoveEntity objWall(2), -230, 24, 200
EntityTexture objWall(2), texWall

objWall(3) = CreateCube()
ScaleEntity objWall(3), 235, 50, 200
MoveEntity objWall(3), 200, 24, 600
EntityTexture objWall(3), texWall

objWall(4) = CreateCube()
ScaleEntity objWall(4), 5, 33.55, 120
MoveEntity objWall(4), 440, 5.5, 220
EntityTexture objWall(4), texWall

objWall(5) = CreateCube()
ScaleEntity objWall(5), 5, 33.55, 120
MoveEntity objWall(5), 440, 5.5, 515
EntityTexture objWall(5), texWall

objWall(6) = CreateCube()
ScaleEntity objWall(6), 5, 40, 200
MoveEntity objWall(6), 440, 80, 340.5
EntityTexture objWall(6), texWall

objWall(7) = CreateCube()
ScaleEntity objWall(7), 200, 50, 200
MoveEntity objWall(7), 0, 24, -250
EntityTexture objWall(7), texWall

pvtDoor = CreatePivot()
objDoor = CreateCube(pvtDoor)
ScaleEntity objDoor, 4, 32.5, 27.5
MoveEntity pvtDoor, 440, 7.5, 367.5
MoveEntity pvtDoor, 0, -32.5, 0
MoveEntity objDoor, 0, 32.5, 0
texDoor = LoadTexture("textures\door_s01.jpg")
EntityTexture objDoor, texDoor
ScaleTexture texDoor, 1, 0.75

mdlGoblin = LoadMD2("models\npcs\npc01.md2")
EntityTexture mdlGoblin, LoadTexture("models\npcs\npc01-01.jpg")
mdlGobWpn = LoadMD2("models\npcs\wpn01.md2", mdlGoblin)
EntityTexture mdlGobWpn, LoadTexture("models\npcs\wpn01.jpg")
PositionEntity mdlGoblin, 1350, -9, 600
TurnEntity mdlGoblin, 0, 180, 0
AnimateMD2 mdlGoblin, 1, 0.12, 0, 40
AnimateMD2 mdlGobWpn, 1, 0.12, 0, 40

mdlHouse = LoadMesh("models\house\house.3ds")
EntityTexture mdlHouse, LoadTexture("models\house\house.jpg")
PositionEntity mdlHouse, 1650, -35, 700
TurnEntity mdlHouse, -90, -75, 0
ScaleEntity mdlHouse, 4.5, 4.5, 4.5

mdlPeasant = LoadMD2("models\npcs\npc01.md2")
EntityTexture mdlPeasant, LoadTexture("models\npcs\npc01-02.jpg")
PositionEntity mdlPeasant, 1350, -9, 575
TurnEntity mdlPeasant, 0, 115, 0
AnimateMD2 mdlPeasant, 1, 0.12, 0, 40

MoveEntity camDefault, 0, 60, 120
TurnEntity camDefault, 80, 0, 0

count = 1
While count < 190 And (Not CheckSkip())

	MoveEntity mdlKnight, 0, 0, 1.5
	MoveEntity camDefault, 0, 0.1, 0

	WaitTimer frmRate
	
	UpdateWorld
	RenderWorld
	
	Gosub displayIntro
	Flip
	
	count = count + 1
	
Wend

TurnEntity camDefault, -80, 0, 0
TurnEntity camDefault, 0, 75, 0
PositionEntity camDefault, 30, 20, 325

count = 1
While count < 95 And (Not CheckSkip())

	WaitTimer frmRate
	
	If count <= 45
		MoveEntity mdlKnight, 0, 0, 1.5
	ElseIf count <= 75
		MoveEntity mdlKnight, 0, 0, 1.5
		TurnEntity mdlKnight, 0, -3, 0
	Else
		MoveEntity mdlKnight, 0, 0, 1.5
	End If
	
	oldP = EntityPitch(camDefault)
	PointEntity camDefault, mdlKnight
	RotateEntity camDefault, oldP, EntityYaw(camDefault), 0

	UpdateWorld
	RenderWorld
	
	Gosub displayIntro
	Flip

	count = count + 1
	
Wend

PositionEntity camDefault, 45, 24, 375
RotateEntity camDefault, 0, -90, 0

count = 1
While count < 180 And (Not CheckSkip())

	WaitTimer frmRate
	
	MoveEntity mdlKnight, 0.11, 0, 1.5
	MoveEntity camDefault, 0.05, 0, 1.45

	UpdateWorld
	RenderWorld
	
	Gosub displayIntro
	Flip
	
	count = count + 1
	
Wend

PositionEntity camDefault, 420, 45, 340
RotateEntity camDefault, 45, 20, 0

speed# = 1.5
While EntityX(mdlKnight) < 380 And (Not CheckSkip())

	WaitTimer frmRate

	MoveEntity mdlKnight, 0.1, 0, speed
	speed = speed * 0.99
	
	If speed < 0.1
		speed = 0.1
	End If

	UpdateWorld
	RenderWorld
	
	Gosub displayIntro
	Flip

Wend

AnimateMD2 mdlKnight, 3, 0.12, 72, 84
AnimateMD2 mdlWeapon, 3, 0.12, 72, 84

While MD2Animating(mdlKnight) And (Not CheckSkip())

	WaitTimer frmRate

	UpdateWorld
	RenderWorld
	
	Gosub displayIntro
	Flip

Wend

AnimateMD2 mdlKnight, 1, 0.12, 1, 39
AnimateMD2 mdlWeapon, 1, 0.12, 1, 39

done = 0
wait = MilliSecs()
While (Not done) And (Not CheckSkip())

	WaitTimer frmRate
	
	If wait < MilliSecs() - 850
		TurnEntity pvtDoor, 0, 0, -0.1
		If EntityRoll(pvtDoor) <= -5
			done = 1
		End If
	End If
	
	UpdateWorld
	RenderWorld
	
	Gosub displayIntro
	Flip

Wend

FreeEntity mirFloor

objWall(8) = CreateCube()
ScaleEntity objWall(8), 5, 40, 200
MoveEntity objWall(8), 440, -66, 340.5
EntityTexture objWall(8), texWall

RotateEntity camDefault, -7, 110, 0
PositionEntity camDefault, 500, -7, 410
terWater = CreateTerrain(2)
ScaleEntity terWater, 50, 1, 450
texWater = LoadTexture("textures\water_01.jpg")
EntityTexture terWater, texWater
EntityAlpha terWater, 0.65
PositionEntity terWater, 425, -40, 0
ScaleTexture texWater, 1, 0.2
pos# = 0.0
If Not CheckSkip()
	UpdateWorld
	RenderWorld
	Gosub displayIntro
	Flip
End If

terOutside = LoadTerrain("terrains\intro.bmp")
ScaleEntity terOutside, 10, 200, 10
MoveEntity terOutside, 450, -135, -70
texOutside = LoadTexture("textures\terrain_01.jpg")
EntityTexture terOutside, texOutside
ScaleTexture texOutside, 20, 20
TerrainDetail terOutside, 250, False

done = 0
started = 0
finished = 0

x = 1

While (Not finished) And (Not CheckSkip())
	WaitTimer frmRate

	PositionTexture texWater, 0, pos
	PositionEntity terWater, EntityX(terWater), -40 + Sin(x), EntityZ(terWater)
	x = x + 1
	
	pos = pos - 0.01

	If Not done
		TurnEntity pvtDoor, 0, 0, -0.5
	End If
	If EntityRoll(pvtDoor) <= -92.5
		done = 1
	End If
	If done And (Not started)
		AnimateMD2 mdlKnight, 1, 0.12, 40, 46
		AnimateMD2 mdlWeapon, 1, 0.12, 40, 46
		started = 1
	End If
	If done And started And (Not finished)
		MoveEntity mdlKnight, 0, 0, 1.7
	End If
	If EntityX(mdlKnight) >= 510
		finished = 1
	End If
	
	UpdateWorld
	RenderWorld

	Gosub displayIntro
	Flip
Wend

TurnEntity camDefault, 7, -20, 0
TurnEntity camDefault, 40, 0, 0
PositionEntity camDefault, 555, 40, 355

While EntityX(camDefault) < 650 And (Not CheckSkip())

	WaitTimer frmRate

	PositionTexture texWater, 0, pos
	PositionEntity terWater, EntityX(terWater), -40 + Sin(x), EntityZ(terWater)
	x = x + 1

	pos = pos - 0.01
	
	If EntityX(camDefault) > 600 
		TurnEntity camDefault, 0.8, 0, 0
		TranslateEntity camDefault, -0.7, 0, 0
	End If
	TranslateEntity camDefault, 1.5, 0, 0
	MoveEntity mdlKnight, 0, 0, 1.5
	
	UpdateWorld
	RenderWorld

	Gosub displayIntro
	Flip

Wend

CameraRange camDefault, 1, 1000
CameraFogMode camDefault, 1
CameraFogRange camDefault, 200, 500
CameraFogColor camDefault, 180, 180, 255
CameraClsColor camDefault, 180, 180, 255
FreeEntity objFloor
FreeEntity objRoof
For counter = 1 To 8
	FreeEntity objWall(counter)
Next
FreeEntity objDoor
FreeEntity pvtDoor
FreeEntity terWater
FreeTexture texWater
FreeTexture texFloor
FreeTexture texWall
FreeTexture texRoof
FreeTexture texDoor

PositionEntity camDefault, EntityX(mdlKnight) + 9, EntityY(mdlKnight) + 24, EntityZ(mdlKnight)
RotateEntity camDefault, 5, EntityYaw(mdlKnight), 0

change# = 0.25
While EntityX(camDefault) < 850 And (Not CheckSkip())

	WaitTimer frmRate

	TranslateEntity camDefault, 1.5, change, 0
	If EntityY(camDefault) > 27
		change = change * -1
	End If
	If EntityY(camDefault) < 21
		change = change * -1
	End If
	MoveEntity mdlKnight, 0, 0, 1.5
	
	UpdateWorld
	RenderWorld

	Gosub displayIntro
	Flip

Wend

RotateEntity camDefault, 0, -150, 0
PositionEntity camDefault, 825, 20, 390

While EntityX(camDefault) < 1100 And (Not CheckSkip())

	WaitTimer frmRate

	TranslateEntity camDefault, 1.5, 0, 0
	MoveEntity mdlKnight, 0, 0, 1.5
	
	UpdateWorld
	RenderWorld

	Gosub displayIntro
	Flip

Wend

PositionEntity camDefault, 1200, 35, 500

While EntityX(mdlKnight) < 1275 And EntityZ(mdlKnight) < 515 And (Not CheckSkip())

	WaitTimer frmRate

	If EntityYaw(mdlKnight) < -40
		TurnEntity mdlKnight, 0, 0.5, 0
	End If
	MoveEntity mdlKnight, 0, 0, 1.5
	PointEntity camDefault, mdlKnight
	
	UpdateWorld
	RenderWorld

	Gosub displayIntro
	Flip

Wend

RotateEntity camDefault, 10, -95, 0
PositionEntity camDefault, 1200, 30, 515
AnimateMD2 mdlGoblin, 3, 0.12, 46, 54
AnimateMD2 mdlGobWpn, 3, 0.12, 46, 54
AnimateMD2 mdlKnight, 1, 0.12, 0, 40
AnimateMD2 mdlWeapon, 1, 0.12, 0, 40
done = 0

While MD2Animating(mdlGoblin) And (Not CheckSkip())
	WaitTimer frmRate

	If MD2AnimTime(mdlGoblin) > 50 And (Not done)
		AnimateMD2 mdlPeasant, 3, 0.12, 190, 196
		done = 1
	End If

	UpdateWorld
	RenderWorld
	
	Gosub displayIntro
	Flip
Wend

AnimateMD2 mdlGoblin, 1, 0.12, 0, 40
AnimateMD2 mdlGobWpn, 1, 0.12, 0, 40
timer = MilliSecs()

While timer > MilliSecs() - 800 And (Not CheckSkip())

	WaitTimer frmRate

	UpdateWorld
	RenderWorld
	
	Gosub displayIntro
	Flip

Wend


AnimateMD2 mdlGoblin, 3, 0.12, 72, 84
AnimateMD2 mdlGobWpn, 3, 0.12, 72, 84

While MD2Animating(mdlGoblin) And (Not CheckSkip())
	WaitTimer frmRate

	UpdateWorld
	RenderWorld
	
	Gosub displayIntro
	Flip
Wend

AnimateMD2 mdlGoblin, 1, 0.12, 0, 40
AnimateMD2 mdlGobWpn, 1, 0.12, 0, 40

RotateEntity camDefault, -2, 170, 0
PositionEntity camDefault, 1310, 15, 635

AnimateMD2 mdlKnight, 3, 0.08, 72, 84
AnimateMD2 mdlWeapon, 3, 0.08, 72, 84

mdlBlock = CreateCube()
PositionEntity mdlBlock, 1310, 15, 600
brhBlock = CreateBrush(255, 0, 0)
PaintMesh mdlBlock, brhBlock
ScaleEntity mdlBlock, 25, 25, 25
EntityAlpha mdlBlock, 0

zoom# = 2
While zoom < 13 And (Not CheckSkip())
	zoom = zoom + 0.1

	WaitTimer frmRate

	EntityAlpha mdlBlock, (zoom - 2.5) / 10
	CameraZoom camDefault, zoom

	UpdateWorld
	RenderWorld
	
	Gosub displayIntro
	Flip

Wend

EntityAlpha mdlBlock, 1

While yIntro > -1600 And (Not CheckSkip())

	WaitTimer frmRate

	UpdateWorld
	RenderWorld
	
	Gosub displayIntro
	
	Flip
	
Wend

FreeEntity terOutside
FreeEntity mdlGobWpn
FreeEntity mdlGoblin
FreeEntity mdlBlock
FreeEntity mdlPeasant
FreeEntity mdlHouse
FreeTexture texOutside
FreeBrush brhBlock

ResetSkip()
PositionEntity mdlKnight, 0, 0, 0
RotateEntity mdlKnight, 0, 140, 0
PositionEntity camDefault, 0, 0, -50
PointEntity camDefault, mdlKnight
CameraClsColor camDefault, 0, 0, 0
CameraZoom camDefault, 1
alpha = 0
timeForNew = True
Up = True
sprBlock = CreateSprite(camDefault)
MoveEntity sprBlock, 0, 0, 1.1
ScaleSprite sprBlock, 2, 2
EntityColor sprBlock, 0, 0, 0
yCredit = 480
Dim Credit$(54)
credit(0) = "Designer"
credit(1) = "     Jocelyn Perreault"
credit(3) = "Programmer"
credit(4) = "     Jocelyn Perreault"
credit(6) = "2D Artists"
credit(7) = "     David Gurrea"
credit(8) = "     Artists from 3DSMAX"
credit(9) = "     Jocelyn Perreault
credit(10) = "     Other unknown artists"
credit(12) = "3D Artists"
credit(13) = "     James Green"
credit(14) = "     Conrad"
credit(15) = "     Brian 'EvilBastard' Collins"
credit(16) = "     ALPHAwolf"
credit(17) = "     Psionic"
credit(18) = "     Scarecrow"
credit(19) = "     Neil Weber 'Dufusyte'"
credit(20) = "     Pascal 'Firebrandt' Jurock"
credit(21) = "     Magarnigal"
credit(22) = "     Burnt Kona"
credit(23) = "     AshMantle & Darklords"
credit(24) = "     Jocelyn Perreault"
credit(25) = "     Other unknown artists"
credit(27) = "Sounds & Music"
credit(28) = "     Authors from EverQuest"
credit(29) = "     Authors from FlashKit.com"
credit(30) = "     Edgen"
credit(31) = "     Other unknown authors"
credit(33) = "Beta Testers"
credit(34) = "     Grgoire 'Greg' Lamarche Ledoux"
credit(35) = "     Flix 'X' Adam"
credit(36) = "     Xavier 'Xav' Graveline"
credit(37) = "     Dominique 'Thruan' Perreault"
credit(38) = "     David 'Lessard' Lessard"
credit(39) = "     Choq 'Tschockque' Choquette"
credit(40) = "     Vincent 'Vince' Grgoire"
credit(41) = "     Frdric 'Maskott' Maheux"
credit(42) = "     Guillaume 'Dr. Guile' Boisvert"
credit(43) = "     Samuel 'Sam' Parenteau"
credit(44) = "     Marc-Olivier 'Tarko' Joyal-Gagnon"
credit(45) = "     Guillaume 'Korneil' d'Anjou"
credit(46) = "     Hugo 'Skorbut' Adam"
credit(47) = "     Louis-Philippe 'Lord MacLeod' Macaulay"
credit(48) = "     Manuel 'Zlavistrov' Simard"
credit(49) = "     Yony 'Saroumane' Royer"
credit(50) = "     Jasmin 'Jasmo' Roy"
credit(52) = "Special Thanks"
credit(53) = "     Cindy Richer"
credit(54) = "     Every public beta players!"

fntDefault = LoadFont("Times New Roman", 24, True)
SetFont fntDefault

frmRate2 = CreateTimer(20)
While (yCredit > -925 Or alpha > 0) And (Not CheckSkip())
	WaitTimer frmRate2
	
	If timeForNew Then
		newFrame# = Rand(0, 169)
		AnimateMD2 mdlKnight, 0, 1, newFrame, newFrame
		AnimateMD2 mdlWeapon, 0, 1, newFrame, newFrame
		timeForNew = False
	End If
	If up Then
		alpha = alpha + 0.03
		If alpha >= 1 Then
			alpha = 1
			Up = False
		End If
	Else
		alpha = alpha - 0.05
		If alpha <= 0 Then
			alpha = 0
			Up = True
			timeForNew = True
		End If
	End If
	
	EntityAlpha sprBlock, 1 - alpha

	RenderWorld

	For Count = 0 To 53
		OutlineText (160, yCredit+17*count, credit(count), False, False)
	Next
	yCredit = yCredit - 2

	Flip

Wend

FreeTimer frmRate2
FreeEntity camDefault
FreeEntity mdlWeapon
FreeEntity mdlKnight
FreeFont fntDefault
FreeSound sndMusic

Function CheckSkip()
	If GetKey() <> 0 Or GetMouse() <> 0 Then
		SkipIntro = True
	End If
	Return SkipIntro
End Function

Function ResetSkip()
	SkipIntro = False
	FlushKeys
End Function

If notIntro
.displayIntro
	For Counter = 0 To 38
		OutlineText(320, Float(yIntro / 2) + 20 * counter, IntroText(Counter), True, False)
	Next
	yIntro = yIntro - 1
Return
End If