; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

If zones(zx, zy)\terrain < 10 Then
	zon$ = "0"
Else
	zon$ = ""
End If
zon = zon + zones(zx, zy)\terrain
If zones(zx, zy)\texture < 10 Then
	zonT$ = "0"
Else
	zonT$ = ""
End If
zonT = zonT + zones(zx, zy)\texture

terZone = LoadTerrain("terrains\zone" + zon + ".bmp")
ScaleEntity terZone, 10, 100, 10
terZoneBorder = LoadTerrain("terrains\zone" + zon + ".bmp")
ScaleEntity terZoneBorder, 10, 200, 10
terZonePlateau = LoadTerrain("terrains\zone" + zon + ".bmp")
ScaleEntity terZonePlateau, 16, 0.0001, 16
MoveEntity terZonePlateau, -750, -1, -750

texHeight = LoadTexture("terrains\lmap" + zon + ".bmp")

texZone = LoadTexture("textures\terrain_" + zonT + ".jpg")
EntityTexture terZone, texZone
EntityTexture terZoneBorder, texZone
EntityTexture terZonePlateau, texZone
EntityTexture terZone, texHeight, 0, 1
EntityTexture terZoneBorder, texHeight, 0, 1
ScaleTexture texZone, 30, 30
ScaleTexture texHeight, 256, 256

EntityType terZoneBorder, typBorder
EntityType terZonePlateau, typBorder

TerrainDetail terZone, 1500, False
TerrainDetail terZoneBorder, 1000, False
TerrainDetail terZonePlateau, 1, False

; ADJUST ZONE BORDERS

For X = 0 To 256
	For Y = 0 To 256
		ModifyTerrain terZoneBorder, X, Y, 0
		ModifyTerrain terZoneBorder, Y, X, 0
	Next
Next
For stepDiff = 0 To zoneDepth
	For X = stepDiff To 256 - stepDiff Step 1
		X = X - 1 + 256 - stepDiff * 2
		For Y = stepDiff To 256 - stepDiff
			size# = stepDiff
			size = (zoneDepth - size) / zoneDepth
			ModifyTerrain terZoneBorder, X, Y, size * size * size
			ModifyTerrain terZoneBorder, Y, X, size * size * size
			ModifyTerrain terZoneBorder, 256 - X, 256 - Y, size * size * size
			ModifyTerrain terZoneBorder, 256 - Y, 256 - X, size * size * size
		Next
	Next
Next

Exits(0) = zones(zx, zy)\exit1
Exits(1) = zones(zx, zy)\exit2
Exits(2) = zones(zx, zy)\exit3
Exits(3) = zones(zx, zy)\exit4
Exits(4) = zones(zx, zy)\exit5

For Counter = 0 To 4
	zonID$ = Left(exits(counter), 1)
	If zonID <> "" Then
		extPos = Mid(exits(counter), 2)
	End If	
	If zonID = "N" Then
		For zCount = extPos - 25 To extPos + 25
			extDiff = Abs(extPos - zCount)
			size# = extDiff
			size = size / 25
			For Count2 = 0 To ZoneDepth
				Zsize# = Count2
				Zsize = (ZoneDepth - Zsize) / ZoneDepth
				ModifyTerrain terZoneBorder, zCount, 255 - Count2, Zsize * Zsize * Zsize * size * size
			Next
		Next
	ElseIf zonID = "E" Then
		For zCount = extPos - 25 To extPos + 25
			extDiff = Abs(extPos - zCount)
			size# = extDiff
			size = size / 25
			For Count2 = 0 To ZoneDepth
				Zsize# = Count2
				Zsize = (ZoneDepth - Zsize) / ZoneDepth
				ModifyTerrain terZoneBorder, 255 - Count2, zCount, Zsize * Zsize * Zsize * size * size
			Next
		Next
	ElseIf zonID = "S" Then
		For zCount = extPos - 25 To extPos + 25
			extDiff = Abs(extPos - zCount)
			size# = extDiff
			size = size / 25
			For Count2 = 1 To ZoneDepth
				Zsize# = Count2
				Zsize = (ZoneDepth - Zsize) / ZoneDepth
				ModifyTerrain terZoneBorder, zCount, Count2, Zsize * Zsize * Zsize * size * size
			Next
		Next
	ElseIf zonID = "W" Then
		For zCount = extPos - 25 To extPos + 25
			extDiff = Abs(extPos - zCount)
			size# = extDiff
			size = size / 25
			For Count2 = 1 To ZoneDepth
				Zsize# = Count2
				Zsize = (ZoneDepth - Zsize) / ZoneDepth
				ModifyTerrain terZoneBorder, Count2, zCount, Zsize * Zsize * Zsize * size * size
			Next
		Next
	End If
Next

; MODIFY ZONE EDGES
For Count = 0 To 256
	For Counter = 0 To ZoneDepth
		size = TerrainHeight(terZone, Count, Counter)
		size = size * (Float(Counter) / Float(ZoneDepth))
		ModifyTerrain terZone, Count, Counter, size

		size = TerrainHeight(terZone, Count, 256 - Counter)
		size = size * (Float(Counter) / Float(ZoneDepth))
		ModifyTerrain terZone, Count, 256 - Counter, size

		size = TerrainHeight(terZone, Counter, Count)
		size = size * (Float(Counter) / Float(ZoneDepth))
		ModifyTerrain terZone, Counter, Count, size

		size = TerrainHeight(terZone, 256 - Counter, Count)
		size = size * (Float(Counter) / Float(ZoneDepth))
		ModifyTerrain terZone, 256 - Counter, Count, size
	Next
Next

; MAKE PIVOT ZONE EXITS FOR RUNNING NPCS
xCount = 0
For Counter = 0 To 4
	pvtExit(Counter) = 0
	zonID$ = Left(exits(counter), 1)
	If zonID <> "" Then
		extPos = Mid(exits(counter), 2)
	End If	
	If zonID = "N" Then
		pvtExit(xCount) = CreatePivot()
		PositionEntity pvtExit(xCount), extPos * 10, 0, 2610
		xCount = xCount + 1
	ElseIf zonID = "E" Then
		pvtExit(xCount) = CreatePivot()
		PositionEntity pvtExit(xCount), 2610, 0, extPos * 10
		xCount = xCount + 1
	ElseIf zonID = "S" Then
		pvtExit(xCount) = CreatePivot()
		PositionEntity pvtExit(xCount), extPos * 10, 0, -50
		xCount = xCount + 1
	ElseIf zonID = "W" Then
		pvtExit(xCount) = CreatePivot()
		PositionEntity pvtExit(xCount), -50, 0, extPos * 10
		xCount = xCount + 1
	End If
Next

; LOAD NON RADIUS 0 PROPS (BUILDINGS, BIG BACKGROUND ELEMENTS, ETC)
For props.Prop = Each Prop
	If props\zx = zx And props\zy = zy And props\radius > 0 Then
		If props\modelpath <> "" Then
			props\model = LoadMesh(props\modelpath)
			EntityType props\model, typProps
			If props\texpath <> "" Then
				EntityTexture props\model, LoadTexture(props\texpath)
			End If
			minX# = props\x - props\radius
			minX = minX / 10
			maxX# = props\x + props\radius
			maxX = maxX / 10
			minY# = props\y - props\radius
			minY = minY / 10
			maxY# = props\y + props\radius
			maxY = maxY / 10
			RadZone# = props\radius
			RadZone = RadZone / 10
			PposX# = props\x
			PposX = PposX / 10
			PposY# = props\Y
			PposY = PposY / 10
			Total# = 0.0
			TotalCount = 0
			For pCount = minX To maxX
				For pCounter = minY To maxY
					RadDist# = Distance(pposx, pposy, pcount, pcounter)
					If RadDist <= RadZone Then
						Total = Total + TerrainHeight(terZone, pCount, pCounter)
						TotalCount = TotalCount + 1
					End If
				Next
			Next
			AvgHeight# = Total / Float(TotalCount)
			For pCount = minX To maxX
				For pCounter = minY To maxY
					RadDist# = Distance(pposx, pposy, pcount, pcounter)
					If RadDist <= RadZone Then
						RadDist = RadDist / RadZone
						RadDist = RadDist * RadDist * RadDist
						size# = TerrainHeight(terZone, pCount, pCounter)
						size = AvgHeight# * (1 - RadDist) + size * (RadDist)
						ModifyTerrain terZone, pCount, pCounter, size
					End If
				Next
			Next
		End If
		PositionEntity props\model, props\x, TerrainY(terZone, props\x, 0, props\y) + props\h - 1, props\y
		RotateEntity props\model, props\pitch, props\angle, 0
		ScaleEntity props\model, props\ws, props\hs, props\ws
	End If
Next
; LOAD RADIUS 0 PROPS (TREASURES, TREES, ETC)
For props.Prop = Each Prop
	If props\zx = zx And props\zy = zy And Props\Radius = 0Then
		If props\modelpath <> "" Then
			If props\treasure Or props\gol > 0
				props\model = LoadAnimMesh(props\modelpath)
				props\colmodel = LoadMesh(Left(props\modelpath, Len(props\modelpath) - 4) + "_col" + Right(props\modelpath, 4), props\model)
				EntityType props\colmodel, typProps
				EntityAlpha props\colmodel, 0
			Else
				props\model = LoadMesh(props\modelpath)
				EntityType props\model, typProps
			End If
			If props\texpath <> "" Then
				EntityTexture props\model, LoadTexture(props\texpath, 4)
			End If
			If (Not props\treasure) And props\gol > 0
				Animate props\model, 3, 100, 0
			End If
		End If
		PositionEntity props\model, props\x, TerrainY(terZone, props\x, 0, props\y) + props\h, props\y
		RotateEntity props\model, props\pitch, props\angle, 0
		ScaleEntity props\model, props\ws, props\hs, props\ws
	End If
Next


; LOAD NPCS
For NPCs.NPC = Each NPC
	If NPCs\zx = zx And NPCs\zy = zy Then
		NPCs\model = LoadMD2("models\npcs\npc" + NPCs\number + ".md2")
		EntityTexture NPCs\model, LoadTexture("models\npcs\npc" + NPCs\number + "-" + NPCs\texnumber + ".jpg")
		PositionEntity NPCs\model, NPCs\X, 200, NPCs\Y
		tyz# = TerrainY(terZone, EntityX(NPCs\model), EntityY(NPCs\model), EntityZ(NPCs\model))
		tyzb# = TerrainY(terZoneBorder, EntityX(NPCs\model), EntityY(NPCs\model), EntityZ(NPCs\model))
		If tyz > tyzb Then
			PositionEntity NPCs\model, EntityX(NPCs\model), tyz + 24 * NPCs\H, EntityZ(NPCs\model)
		Else
			PositionEntity NPCs\model, EntityX(NPCs\model), tyzb + 24 * NPCs\H, EntityZ(NPCs\model)
		End If
		NPCs\moving = False
		NPCs\turning = False
		NPCs\zoning = False
		If NPCs\HEA <= 0 Then
			NPCs\Dead = True
			AnimateMD2 NPCs\model, 1, AnimSpeed, 183, 184
		Else
			NPCs\HEA = NPCs\HEAT
			NPCs\MOR = NPCs\MORT
			NPCs\MOV = NPCs\MOVT
			NPCs\wpnmodel = LoadMD2("models\npcs\wpn" + NPCs\number + ".md2", NPCs\model)
			EntityTexture NPCs\wpnmodel, LoadTexture("models\npcs\wpn" + NPCs\number + ".jpg")
			AnimateMD2 NPCs\model, 1, AnimSpeed, 0, 40
			AnimateMD2 NPCs\wpnmodel, 1, AnimSpeed, 0, 40
			EntityType NPCs\model, typModels
			EntityRadius NPCs\model, 15 * NPCs\W
			EntityPickMode NPCs\model, 1
		End If
		ScaleEntity NPCs\model, NPCs\W, NPCs\H, NPCs\W
		TurnEntity NPCs\model, 0, Rand(1, 360), 0
		foundRace = False
		If NPCs\Dead Then
			foundRace = True
		End If
		For NPCRaces.NPCRace = Each NPCRace
			If NPCRaces\Race = NPCs\Race Then
				foundRace = True
			End If
		Next
		If Not foundRace Then
			NPCRaces.NPCRace = New NPCRace
			NPCRaces\Race = NPCs\Race
			NPCRaces\sndAtk = Load3DSound("sounds\atk" + NPCs\number + ".wav")
			NPCRaces\sndHit = Load3DSound("sounds\hit" + NPCs\number + ".wav")
			NPCRaces\sndDie = Load3DSound("sounds\die" + NPCs\number + ".wav")
		End If
	End If
Next