; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

AppTitle "Wandering Knights", "Are you sure you wish to terminate Wandering Knights?"
scrWidth = 640
scrHeight = 480
frameRate = 40
versionNumber$ = "0.3.1 Beta"

; LOAD CONFIG
filConfig = ReadFile("wk.cfg")
	cfg$ = ReadLine(filConfig)
	If cfg = "1" Then
		scrMode = 1
	Else
		scrMode = 2
	End If
	cfg$ = ReadLine(filConfig)
	If cfg = "1" Then
		DebugMode = True
	Else
		DebugMode = False
	End If
	cfg$ = ReadLine(filConfig)
	If cfg = "1" Then
		AntiAliasing = True
	Else
		AntiAliasing = False
	End If
	cfg$ = ReadLine(filConfig)
	If cfg = "1" Then
		Dithering = True
	Else
		Dithering = False
	End If
	cfg$ = ReadLine(filConfig)
	If cfg = "1" Then
		WBuffering = True
	Else
		WBuffering = False
	End If
	cfg$ = ReadLine(filConfig)
	scrDepth = Int(cfg$)
	cfg$ = ReadLine(filConfig)
	If cfg = "1" Then
		KeepBodies = True
	Else
		KeepBodies = False
	End If

; SET ENVIRON
Graphics3D scrWidth, scrHeight, scrDepth, scrMode
AntiAlias AntiAliasing
Dither Dithering 
WBuffer WBuffering
SetBuffer BackBuffer()
frmRate = CreateTimer(frameRate)
HidePointer
TFormFilter False
StartPlay = False

; LOAD CONFIG COLORS
fntColors = LoadFont("Courier New", 14, True)
SetFont fntColors
Dim MsgColors(14)
	For Count = 1 To 14
		RMsg = ReadLine(filConfig)
		GMsg = ReadLine(filConfig)
		BMsg = ReadLine(filConfig)
		MsgColors(Count) = L_CreateColor(RMsg, GMsg, BMsg)
	Next
CloseFile filConfig
FreeFont fntColors

Include "functions.bb"
Include "initstuff.bb"
Include "load.bb"
Include "load_part2.bb"
Include "win.bb"
Include "genprops.bb"
Include "particleworks.bb"
Include "logger.bb"

Include "intro.bb"

FinishedPlaying = False
While Not FinishedPlaying
	While Not StartPlay

		load = False
		Include "menu.bb"
	
		If Not load Then
			Include "create.bb"
		Else
			FlushMouse
			Gosub load
			Gosub load2
			FlushMouse
		End If
	Wend

	Include "character.bb"
	Gosub showChar

	Include "play.bb"
	StartPlay = False
Wend

FreeTimer frmRate