; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

FlushKeys
FlushMouse
SeedRnd MilliSecs()
; SET ENVIRON
fntDefault = LoadFont("Times New Roman", 14, True)
SetFont fntDefault
AmbientLight 255, 255, 255
PreviousZone = Rand(1,5)

; COLLISION TYPES
typModels = 1
typBorder = 2
typProps = 3
Collisions typModels, typBorder, 2, 2
Collisions typModels, typModels, 1, 2
Collisions typModels, typProps, 2, 3

; SEED THE RANDOM
SeedRnd MilliSecs()

; WELCOME MESSAGE
logMsg = L_CreateLog(0, logPath$ + "Adventures.txt", True, False, False)
L_AddMessage(logMsg, "Welcome to Wandering Knights " + versionNumber + "!", MsgColors(10))

.EnterZone

Loading()
; GENERATE ZONE
Include "genzone.bb"

; LOAD ZONE
Include "loadzone.bb"

; INITIALIZE GAME
Include "initplay.bb"

.LoopStart
While True

	WaitTimer(frmRate)
	
; PUT KNIGHT ON THE GROUND
	tyz# = TerrainY(terZone, EntityX(mdlKnight), EntityY(mdlKnight), EntityZ(mdlKnight))
	tyzb# = TerrainY(terZoneBorder, EntityX(mdlKnight), EntityY(mdlKnight), EntityZ(mdlKnight))
	If tyz > tyzb Then
		PositionEntity mdlKnight, EntityX(mdlKnight), tyz + 24, EntityZ(mdlKnight)
	Else
		PositionEntity mdlKnight, EntityX(mdlKnight), tyzb + 24, EntityZ(mdlKnight)
	End If

; KNIGHT FOOT STEP
	If MD2AnimTime(mdlKnight) > 41 And MD2AnimTime(mdlKnight) < 42 And (Not Step1)
		EmitSound sndStep3, mdlKnight
		Step1 = True
	End If
	If MD2AnimTime(mdlKnight) > 44 And MD2AnimTime(mdlKnight) < 45 And (Not Step2)
		EmitSound sndStep4, mdlKnight
		Step2 = True
	End If
	If MD2AnimTime(mdlKnight) < 41 And Step1
		Step1 = False
		Step2 = False
	End If

; NPC MAIN LOOP
	NPC_Total = 0
	NPC_Dead = 0
	NPC_Aggro = 0
	ExitResting = False
	For NPCs.NPC = Each NPC
		If NPCs\zx = zx And NPCs\zy = zy Then
	; COUNT NPCS
			NPC_Total = NPC_Total + 1
			If Not NPCs\Dead Then
	; RAISE MORALE / HEALTH / MOVE
				If NewMOR And NPCs\MOR < NPCs\MORT Then
					NPCs\MOR = NPCs\MOR + 1
					If NPCs\MOR > NPCs\MORT Then
						NPCs\MOR = NPCs\MORT
					End If
				End If
				If NewHEA And NPCs\HEA < NPCs\HEAT Then
					NPCs\HEA = NPCs\HEA + 1
					If NPCs\HEA > NPCs\HEAT Then
						NPCs\HEA = NPCs\HEAT
					End If
				End If
				If NPCs\MOV < NPCs\MOVT Then
					NPCs\MOV = NPCs\MOV + 0.5 + Float(NPCs\MOVT) / 125
					If NPCs\MOV > NPCs\MOVT Then
						NPCs\MOV = NPCs\MOVT
					End If
				End If
	; CHECK IF IT HAS POTENTIAL TO ZONE
				zoned = False
				If Not NPCs\zoning Then
					If EntityX(NPCs\model) < 25 Then
						NPCs\zoning = True
						RotateEntity NPCs\model, 0, 90, 0
						turnAround = Rand(1, 5)
						If turnAround > 1 Or NPCs\MOR > 0 Then
							NPCs\zoning = False
							TurnEntity NPCs\model, 0, 180, 0
							MoveEntity NPCs\model, 0, 0, 2
						End If
					ElseIf EntityX(NPCs\model) > 2535 Then
						NPCs\zoning = True
						RotateEntity NPCs\model, 0, 270, 0
						turnAround = Rand(1, 5)
						If turnAround > 1 Or NPCs\MOR > 0 Then
							NPCs\zoning = False
							TurnEntity NPCs\model, 0, 180, 0
							MoveEntity NPCs\model, 0, 0, 2
						End If
					ElseIf EntityZ(NPCs\model) < 25 Then
						NPCs\zoning = True
						RotateEntity NPCs\model, 0, 180, 0
						turnAround = Rand(1, 5)
						If turnAround > 1 Or NPCs\MOR > 0 Then
							NPCs\zoning = False
							TurnEntity NPCs\model, 0, 180, 0
							MoveEntity NPCs\model, 0, 0, 2
						End If
					ElseIf EntityZ(NPCs\model) > 2535 Then
						NPCs\zoning = True
						RotateEntity NPCs\model, 0, 0, 0
						turnAround = Rand(1, 5)
						If turnAround > 1 Or NPCs\MOR > 0 Then
							NPCs\zoning = False
							TurnEntity NPCs\model, 0, 180, 0
							MoveEntity NPCs\model, 0, 0, 2
						End If
					End If
				Else
					If Target <> 0 Then
						If EntityX(NPCs\model) < -1100 Then
							NPCs\zx = WrapZone(NPCs\zx - 1)
							NPCs\x = 2400
							NPCs\y = EntityZ(NPCs\model)
							NPCs\zoning = False
							NPCs\moving = False
							NPCs\turning = False
							FreeEntity NPCs\wpnmodel
							FreeEntity NPCs\model
							zoned = True
						ElseIf EntityX(NPCs\model) > 3600 Then
							NPCs\zx = WrapZone(NPCs\zx + 1)
							NPCs\x = 100
							NPCs\y = EntityZ(NPCs\model)
							NPCs\zoning = False
							NPCs\moving = False
							NPCs\turning = False
							FreeEntity NPCs\wpnmodel
							FreeEntity NPCs\model
							zoned = True
						ElseIf EntityZ(NPCs\model) < -1100 Then
							NPCs\zy = WrapZone(NPCs\zy + 1)
							NPCs\y = 2400
							NPCs\x = EntityX(NPCs\model)
							NPCs\zoning = False
							NPCs\moving = False
							NPCs\turning = False
							FreeEntity NPCs\wpnmodel
							FreeEntity NPCs\model
							zoned = True
						ElseIf EntityZ(NPCs\model) > 3600 Then
							NPCs\zy = WrapZone(NPCs\zy - 1)
							NPCs\y = 100
							NPCs\x = EntityX(NPCs\model)
							NPCs\zoning = False
							NPCs\moving = False
							NPCs\turning = False
							FreeEntity NPCs\wpnmodel
							FreeEntity NPCs\model
							zoned = True
						End If
					End If
				End If
			End If
; IF THE NPC IS DEAD/DYING
			If NPCs\Dead Then
				NPC_Dead = NPC_Dead + 1
				If Not KeepBodies Then
					EntityAlpha NPCs\model, NPCs\Alpha
					ScaleEntity NPCs\model, NPCs\W * NPCs\Scale, NPCs\H, NPCs\W * NPCs\Scale
					MoveEntity NPCs\model, 0, 0.01, 0
					If NPCs\Alpha > 0 Then
						NPCs\Alpha = NPCs\Alpha - 0.01
						NPCs\Scale = NPCs\Scale + 0.001
					End If
				End If
			ElseIf Not zoned
; PUT NPC ON THE GROUND
				tyz# = TerrainY(terZone, EntityX(NPCs\model), EntityY(NPCs\model), EntityZ(NPCs\model))
				tyzb# = TerrainY(terZoneBorder, EntityX(NPCs\model), EntityY(NPCs\model), EntityZ(NPCs\model))
				If tyz > tyzb Then
					PositionEntity NPCs\model, EntityX(NPCs\model), tyz + 24 * NPCs\H, EntityZ(NPCs\model)
				Else
					PositionEntity NPCs\model, EntityX(NPCs\model), tyzb + 24 * NPCs\H, EntityZ(NPCs\model)
				End If
; RESTART ANIM IF NOT PLAYING
				If Not MD2Animating(NPCs\model)
					speed# = AnimSpeed - 0.02 + Rnd(0, 0.04) * timeGoing
					AnimateMD2 NPCs\model, 1, speed#, 0, 40
					AnimateMD2 NPCs\wpnmodel, 1, speed#, 0, 40
					NPCs\moving = False
				End If
; CUT MOVING IF ANIMATED IN IDLE
				If NPCs\moving And MD2AnimTime(NPCs\model) < 40
					NPCs\moving = False
				End If
; CONTROL MOVE/TURN
				If NPCs\zoning
					modifiedRate# = 0.1 + Float(NPCs\HEA) / Float(NPCs\HEAT)
					If modifiedRate > 1 Then
						modifiedRate = 1
					End If
					MoveEntity NPCs\model, 0, 0, MoveSpeed * timeGoing * modifiedRate
					If Not NPCs\moving Then
						NPCs\moving = True
						speed# = AnimSpeed - 0.02 + Rnd(0, 0.04)
						AnimateMD2 NPCs\model, 1, speed# * timeGoing, 40, 46
						AnimateMD2 NPCs\wpnmodel, 1, speed# * timeGoing, 40, 46
					End If
				Else
		; IF NOT AGGRO'ED
					; CALCULATE CONSIDER
					Consider1# = NPCs\ST + NPCs\DE + NPCs\ME + NPCs\DAM * 7 + NPCs\AB * 8
					Consider2# = ST + DE + ME + DAM * 7 + AB * 8
					Cons# = Consider1 / Consider2
					ReaComp = Float(NPCs\REA) * Cons * 0.3 + Float(NPCs\REA) * 0.7
					If EntityDistance(NPCs\model, mdlKnight) > AggroRange Or ReaComp >= -550
			; IF ON TARGET AND CLOSE, TURN TOWARD PLAYER AND WAIT		
						If Target = NPC_Total And EntityDistance(NPCs\model, mdlKnight) <= AttackRange * 1.5 Then
							PointEntity NPCs\model, mdlKnight
							RotateEntity NPCs\model, 0, EntityYaw(NPCs\model), 0
							If MD2AnimTime(NPCs\model) > 40 Then
								AnimateMD2 NPCs\model, 1, AnimSpeed * timeGoing, 0, 40
								AnimateMD2 NPCs\wpnmodel, 1, AnimSpeed * timeGoing, 0, 40
							End If
						Else
			; MOVE AND TURN RANDOMLY
							If Not NPCs\moving And NPCs\turning = 0 Then
								option = Rand(1, 100)
								If option < 3 Then
									NPCs\moving = True
									AnimateMD2 NPCs\model, 1, AnimSpeed * timeGoing, 40, 46
									AnimateMD2 NPCs\wpnmodel, 1, AnimSpeed * timeGoing, 40, 46
								ElseIf option > 95 Then
									NPCs\turning = Rand(1, 2)
									If NPCs\turning = 1 Then
										NPCs\turning = -2
									Else
										NPCs\turning = 2
									End If
								End If
							End If
							If NPCs\moving Then
								option = Rand(1, 50)
								If option = 1 Then
									NPCs\moving = False 
									AnimateMD2 NPCs\model, 1, AnimSpeed * timeGoing, 0, 40
									AnimateMD2 NPCs\wpnmodel, 1, AnimSpeed, 0 * timeGoing, 40
								Else
									modifiedRate# = 0.1 + Float(NPCs\HEA) / Float(NPCs\HEAT)
									If modifiedRate > 1 Then
										modifiedRate = 1
									End If
									MoveEntity NPCs\model, 0, 0, MoveSpeed * timeGoing * modifiedRate
								End If
							End If
							If NPCs\turning <> 0 Then
								option = Rand(1, 35)
								If option = 1 Then
									NPCs\turning = 0
								Else
									TurnEntity NPCs\model, 0, NPCs\turning, 0
								End If
							End If
						End If
		; IF OUT OF MORALE, ZONE OUT
					ElseIf NPCs\MOR <= 0
						If MD2AnimTime(NPCs\model) <= 46 Then
							closest = 5000
							For Count = 0 To 4
								If pvtExit(Count) > 0 Then
									If EntityDistance(NPCs\model, pvtExit(count)) < closest Then 
										closest = EntityDistance(NPCs\model, pvtExit(count))
										PointEntity NPCs\model, pvtExit(count)
									End If
								End If
							Next
							RotateEntity NPCs\model, 0, EntityYaw(NPCs\model), 0
							If Not(NPCs\moving)
								speed# = (0.10 + Rnd(0.04)) * TimeGoing
								AnimateMD2 NPCs\model, 1, speed, 40, 46
								AnimateMD2 NPCs\wpnmodel, 1, speed, 40, 46
								NPCs\moving = True
							End If
							modifiedRate# = 1 / (Float(NPCs\HEA) / Float(NPCs\HEAT))
							If modifiedRate# > Float(NPCs\MOVT) * 0.10 Then
								modifiedRate# = Float(NPCs\MOVT) * 0.10
							End If
							MovBonus# = Float(NPCs\MOV) / Float(NPCs\MOVT)
							If MovBonus# < 0.6 Then
								MovBonus# = 0.6
							End If
							MoveEntity NPCs\model, 0, 0, ((Float(MoveSpeed) / modifiedRate#) * movBonus) * timeGoing
							NPCs\MOV = NPCs\MOV - 1
							If NPCs\MOV < 0 Then
								NPCs\MOV = 0
							End If
						End If
		; WHEN AGGRO'ED AND NOT OUT OF MORALE, GO TOWARD PLAYER
					ElseIf EntityDistance(NPCs\model, mdlKnight) > AttackRange - 20
						NPC_Aggro = NPC_Aggro + 1
						PointEntity NPCs\model, mdlKnight
						RotateEntity NPCs\model, 0, EntityYaw(NPCs\model), 0
						modifiedRate# = 0.1 + Float(NPCs\HEA) / Float(NPCs\HEAT)
						If modifiedRate > 1 Then
							modifiedRate = 1
						End If
						MovBonus# = Float(NPCs\MOV) / Float(NPCs\MOVT)
						If MovBonus# < 0.6 Then
							MovBonus# = 0.6
						End If
						If Not(NPCs\moving)
							speed# = (0.10 + Rnd(0.04)) * TimeGoing
							AnimateMD2 NPCs\model, 1, speed, 40, 46
							AnimateMD2 NPCs\wpnmodel, 1, speed, 40, 46
							NPCs\moving = True
						End If
						MoveEntity NPCs\model, 0, 0, ((MoveSpeed / modifiedRate#) * MovBonus) * timeGoing
						NPCs\MOV = NPCs\MOV - 1
						If NPCs\MOV < 0 Then
							NPCs\MOV = 0
						End If
						If Not(NPCs\moving)
							speed# = 0.10 + Rnd(0.04)
							AnimateMD2 NPCs\model, 1, speed, 40, 46
							AnimateMD2 NPCs\wpnmodel, 1, speed, 40, 46
							NPCs\moving = True
						End If
		; IF MODEL IS CLOSE ENOUGH TO PLAYER, HE THEN CAN ATTACKS, IF ENOUGH MOVE
					ElseIf EntityDistance(NPCs\model, mdlKnight) <= AttackRange - 20
						NPC_Aggro = NPC_Aggro + 1
						mp# = NPCs\MOV
						mp = mp / NPCs\MOVT
						If Target = 0 Then
							Target = NPC_Total
							NewMessage$ = "New target: " + NPCs\name + "."
							TargetName$ = NPCs\name
							TargetGroup$ = groups(NPCs\group)\name
							L_AddMessage(logMsg, NewMessage$, MsgColors(2))
						End If
						If mp >= 0.75
							If Rest Then
								ExitResting = True
							End If
							PointEntity NPCs\model, mdlKnight
							RotateEntity NPCs\model, 0, EntityYaw(NPCs\model), 0
							MOVMod# = NPCs\MOVT - NPCs\MOV
							MOVMod = MOVMod / NPCs\MOVT
							MOVMod = MOVMod * 25
							NPCs\MOV = NPCs\MOV - NPCs\MOVT * 0.75
							ToHit# = NPCs\ST
							ToHit = ToHit / (2 * ST)
							ToHit = 35 + ToHit * 75
							ToHit = ToHit - MOVMod
							Hit = Rand(1, 100)
							anim = Rand(0, 2)
							speed# = 0.1 + Rnd(0, 0.04)
							NPCs\moving = False
							AnimateMD2 NPCs\model, 3, speed, 46, 53
							AnimateMD2 NPCs\wpnmodel, 3, speed, 46, 53
							If Hit <= ToHit Then
								dmg = NPCs\DAM - AB
								If Hit <= 12 Then
									NewMessage$ = "Critical! "
									dmg = dmg * 2
								Else
									NewMessage$ = ""
								End If
								moving = False
								AnimateMD2 mdlKnight, 3, AnimSpeed, 54 + 4 * anim, 57 + 4 * anim
			   				    AnimateMD2 mdlWeapon, 3, AnimSpeed, 54 + 4 * anim, 57 + 4 * anim
								BothAnim = True
								If dmg < 1 Then
									dmg = 1
								End If
								NewMessage$ = NewMessage$ + NPCs\name + " hits you for " + dmg + " damage."
								newBloodEmitter(1, dmg, mdlKnight)
								AddLog("Damage Received", dmg)
								If GodMode Then
									dmg = 0
								End If
								L_AddMessage(logMsg, NewMessage$, MsgColors(5))
								HEA = HEA - dmg
								MOR = MOR - Int(dmg * 1.5)
								NPCs\MOR = NPCs\MOR + dmg
								If NPCs\MOR > NPCs\MORT Then
									NPCs\MOR = NPCs\MORT
								End If
								If HEA <= 0
									dead = True
									lzx = zx
									lzy = zy
									NewMessage$ = "You have been killed by " + NPCs\name + "!"
									L_AddMessage(logMsg, NewMessage$, MsgColors(5))
									PlaySound sndDie
									Gosub CloseTarget
									Gosub FreeAll
									Include "die.bb"
									Gosub FinishIt
								Else
									For NPCRaces.NPCRace = Each NPCRace
										If NPCRaces\Race = NPCs\Race Then
											EmitSound(NPCRaces\sndAtk, NPCs\model)
										End If
									Next
								End If
							Else
								For NPCRaces.NPCRace = Each NPCRace
									If NPCRaces\Race = NPCs\Race Then
										EmitSound(NPCRaces\sndAtk, NPCs\model)
									End If
								Next
								NewMessage$ = NPCs\name + " missed."
								L_AddMessage(logMsg, NewMessage$, MsgColors(5))
							End If
						End If
					End If
				End If
; RESTART ANIM WHEN FINISHED
				If NPCs\MOV <= 0
					If NPCs\moving Then
						speed# = 0.10 + Rnd(0.04)
						AnimateMD2 NPCs\model, 1, speed, 0, 40
						AnimateMD2 NPCs\wpnmodel, 1, speed, 0, 40
						NPCs\moving = False
					End If
				End If
			End If
		End If
	Next
	If ExitResting Then
		Gosub SwitchResting
	End If

; RESET TOOLTIP
	tooltip$ = ""

; TIME SETTING
	newMOR = False
	newHEA = False
	minute = minute + 0.05 * timeGoing
	If hour > 20 Or hour < 4 Then
		minute = minute + 0.05 * timeGoing
	End If	
	intMin = Int(minute)
	If lastIntMin <> intMin Then
		numMin = numMin + 1
		numMinH = numMinH + 1
		lastIntMin = intMin
	End If
	If numMin = 5 Then
		numMin = 0
		newMOR = True
	End If
	If numMinH = 12 Then
		numMinH = 0
		newHEA = True
	End If
	
	While minute >= 60
		minute = minute - 60
		hour = hour + 1
		While hour >= 24
			hour = hour - 24
			day = day + 1
			firstNPC = True
			For NPCs.NPC = Each NPC
				If firstNPC Then
					If npcs\zx <> zx Or npcs\zy <> zy Then
						ChaosMoves = Rand(1, 6)
						If ChaosMoves = 1 Then
							diffZones = npcs\zx - zx
							If diffZones > 0 Then
								If npcs\zx + diffZones > 99 And WrapZone(npcs\zx + diffZones) > zx - 1 Then
									npcs\zx = WrapZone(npcs\zx + 1)
								Else
									npcs\zx = WrapZone(npcs\zx - 1)
								End If
							ElseIf diffZones < 0 Then
								If npcs\zx + diffZones < 0 And WrapZone(npcs\zx + diffZones) < zx - 1 Then
									npcs\zx = WrapZone(npcs\zx - 1)
								Else
									npcs\zx = WrapZone(npcs\zx + 1)
								End If
							End If
						ElseIf ChaosMoves = 2 Then
							diffZones = npcs\zy - zy
							If diffZones > 0 Then
								If npcs\zy + diffZones > 99 And WrapZone(npcs\zy + diffZones) > zy - 1 Then
									npcs\zy = WrapZone(npcs\zy + 1)
								Else
									npcs\zy = WrapZone(npcs\zy - 1)
								End If
							ElseIf diffZones < 0 Then
								If npcs\zy + diffZones < 0 And WrapZone(npcs\zy + diffZones) < zy - 1 Then
									npcs\zy = WrapZone(npcs\zy - 1)
								Else
									npcs\zy = WrapZone(npcs\zy + 1)
								End If
							End If
						End If
					End If
					firstNPC = False
				Else
					NPCs\GOL = NPCs\GOL + Rand(1, 5) * groups(NPCs\group)\stats
				End If
			Next
			For shops.Shop = Each Shop
				shops\GOL = shops\GOL + Rand(25, 100)
			Next
			If day Mod 5 = 0 Then
; EVERY 5 DAYS, UPDATE SHOPS AND NPCS
				For shops.Shop = Each Shop
					shops\GOL = shops\GOL + Rand(0, 50)
					shops\pot = shops\POT + Rand(0, 5) - Rand(0, 3)
					If shops\POT < 0 Then
						shops\POT = 0
					End If
					shopItems = Rand(0, 5)
					shopWeapons = Rand(0, 3)
					shopArmors = Rand(0, 1)
; ADD ITEMS
					For count = 1 To shopItems
						newItem$ = Rand(0, maxItems)
						If Len(newItem) < 2 Then
							newItem = "0" + newItem
						End If
						If Len(newItem) < 3 Then
							newItem = "0" + newItem
						End If
						itemValue$ = Rand(getLow(valuables(newItem)), getHigh(valuables(newItem)))
						If Len(itemValue) < 2 Then
							itemValue = "0" + itemValue
						End If
						If Len(itemValue) < 3 Then
							itemValue = "0" + itemValue
						End If
						If Len(Shops\Items) < 100 Then
							shops\items = shops\items + newItem + itemValue
						Else
							shops\GOL = shops\GOL + Float(itemValue) * 0.50
						End If
					Next
; ADD WEAPONS
					For count = 1 To shopWeapons
						newWeapon = Rand(1, 6)
						If Len(shops\weapons) < 15 Then
							Select newWeapon
								Case 1
									shops\weapons = shops\weapons + "02"
								Case 2
									shops\weapons = shops\weapons + "03"
								Case 3
									shops\weapons = shops\weapons + "07"
								Case 4
									shops\weapons = shops\weapons + "11"
								Case 5
									shops\weapons = shops\weapons + "14"
								Case 6
									shops\weapons = shops\weapons + "20"
							End Select
							newWeapon = Rand(1, 7)
							Select newWeapon
								Case 1
									shops\weapons = shops\weapons + "01"
								Case 2
									shops\weapons = shops\weapons + "04"
								Case 3
									shops\weapons = shops\weapons + "08"
								Case 4
									shops\weapons = shops\weapons + "13"
								Case 5
									shops\weapons = shops\weapons + "19"
								Case 6
									shops\weapons = shops\weapons + "24"
								Case 7
									shops\weapons = shops\weapons + "30"
							End Select
						End If
					Next
; ADD ARMORS					
					For count = 1 To shopArmors
						If Len(shops\armors) < 15 Then
							newArmor = Rand(1, 7)
							Select newArmor
								Case 1
									shops\armors = shops\armors + "01"
								Case 2
									shops\armors = shops\armors + "04"
								Case 3
									shops\armors = shops\armors + "08"
								Case 4
									shops\armors = shops\armors + "13"
								Case 5
									shops\armors = shops\armors + "19"
								Case 6
									shops\armors = shops\armors + "24"
								Case 7
									shops\armors = shops\armors + "30"
							End Select
						End If
					Next		
					shopItems = Rand(0, 3) - Rand(0, 2)
					shopWeapons = Rand(0, 2) - Rand(0, 2)
					shopArmors = Rand(0, 1) - Rand(0, 1)
; REMOVE ITEMS
					While shopItems > 0 And Len(shops\items) > 0
						shopItems = shopItems - 1
						remove = Rand(0, Len(shops\items) / 6)
						If remove = 0 Then
							part1$ = ""
						Else
							Part1$ = Mid(shops\Items, 1, remove * 6)
						End If
						Part2$ = Mid(shops\Items, 1 + (remove + 1) * 6)
						shops\Items = Part1$ + Part2$
					Wend
; REMOVE WEAPONS					
					While shopWeapons > 0 And Len(shops\weapons) > 0
						shopWeapons = shopWeapons - 1
						remove = Rand(0, Len(shops\weapons) / 4)
						If remove = 0 Then
							part1$ = ""
						Else
							Part1$ = Mid(shops\weapons, 1, remove * 4)
						End If
						Part2$ = Mid(shops\weapons, 1 + (remove + 1) * 4)
						shops\weapons = Part1$ + Part2$
					Wend
; REMOVE ARMORS					
					While shopArmors > 0 And Len(shops\armors) > 0
						shopArmors = shopArmors - 1
						remove = Rand(0, Len(shops\armors) / 6)
						If remove = 0 Then
							part1$ = ""
						Else
							Part1$ = Mid(shops\armors, 1, remove * 6)
						End If
						Part2$ = Mid(shops\armors, 1 + (remove + 1) * 6)
						shops\armors = Part1$ + Part2$
					Wend
				Next					

				For npcs.NPC = Each NPC
					npcs\GOL = npcs\GOL + Rand(0, 20)
					shopItems = Rand(0, 2)
; ADD ITEMS
					For count = 1 To shopItems
						newItem$ = Rand(0, maxItems)
						If Len(newItem) < 2 Then
							newItem = "0" + newItem
						End If
						If Len(newItem) < 3 Then
							newItem = "0" + newItem
						End If
						itemValue$ = Rand(getLow(valuables(newItem)), getHigh(valuables(newItem)))
						If Len(itemValue) < 2 Then
							itemValue = "0" + itemValue
						End If
						If Len(itemValue) < 3 Then
							itemValue = "0" + itemValue
						End If
						npcs\items = npcs\items + newItem + itemValue
					Next
; REMOVE ITEMS
					shopItems = Rand(0, 2) - Rand(0, 1)
					While shopItems > 0 And Len(npcs\items) > 0
						shopItems = shopItems - 1
						remove = Rand(0, Len(npcs\items) / 6)
						If remove = 0 Then
							part1$ = ""
						Else
							Part1$ = Mid(npcs\Items, 1, remove * 6)
						End If
						Part2$ = Mid(npcs\Items, 1 + (remove + 1) * 6)
						npcs\Items = Part1$ + Part2$
					Wend
; UPDATE STATS
					NPCs\DAM = NPCs\DAM + 1
					NPCs\AB = NPCs\AB + 1
					NPCs\ST = NPCs\ST + 3
					NPCs\DE = NPCs\DE + 3
					NPCs\ME = NPCs\ME + 3
					NPCs\HEA = NPCs\HEA + 5
					NPCs\MOR = NPCs\MOR + 5
					NPCs\MOV = NPCs\MOV + 5
					NPCs\HEAT = NPCs\HEAT + 5
					NPCs\MORT = NPCs\MORT + 5
					NPCs\MOVT = NPCs\MOVT + 5
				Next
			End If
			If day = birthDay Then
				age = Int(age) + 1
				NewMessage$ = "Happy birthday! You are now " + age + " years old."
				L_AddMessage(logMsg, NewMessage$, MsgColors(1))
				ST = ST + 1
				DE = DE + 1
				ME = ME + 2
				POW = POW - 1
				RES = RES - 1
				COO = COO - 1
				SPE = SPE - 1
				MIN = MIN + 1
				MORT = MORT + 2
				MOR = MOR + 2
				DAM = WTY + WME + ST / 5
				AB = AME + RES / 5
			End If
			While day >= 365
				day = day - 365
				year = year + 1
			Wend
		Wend
	Wend
	
; CAMERA LIGHTING
	If hour >= 3 And hour < 9 Then
		timeset = minute + (hour - 3) * 60
		CameraClsColor camDefault, timeset / 2, timeset / 2, 75 + timeset / 2
		CameraFogColor camDefault, timeset / 2, timeset / 2, 75 + timeset / 2
		CameraFogRange camDefault, 140 + timeset, 440 + timeset
		AmbientLight 75 + timeset / 2, 75 + timeset / 2, 75 + timeset / 2
	ElseIf hour >= 15 And hour < 21
		timeset = minute + (hour - 15) * 60
		CameraClsColor camDefault, 180 - timeset / 2, 180 - timeset / 2, 255 - timeset / 2
		CameraFogColor camDefault, 180 - timeset / 2, 180 - timeset / 2, 255 - timeset / 2
		CameraFogRange camDefault, 500 - timeset, 800 - timeset
		AmbientLight 255 - timeset / 2, 255 - timeset / 2, 255 - timeset / 2
	ElseIf hour >= 9 And hour < 15 Then
		CameraClsColor camDefault, 180, 180, 255
		CameraFogColor camDefault, 180, 180, 255
		CameraFogRange camDefault, 500, 800
		AmbientLight 255, 255, 255
	Else		
		CameraClsColor camDefault, 0, 0, 75
		CameraFogColor camDefault, 0, 0, 75
		CameraFogRange camDefault, 140, 440
		AmbientLight 75, 75, 75
	End If

; RESTART ANIM IF NOT ANIMATED
	If Not(MD2Animating(mdlKnight))
		AnimateMD2 mdlKnight, 1, AnimSpeed, 0, 40
		AnimateMD2 mdlWeapon, 1, AnimSpeed, 0, 40
		Moving = False
	End If

; IF TIME FOR MORALE RAISE, RAISE IT
	If NewMOR And MOR < MORT Then
		MOR = MOR + 1
		If Rest Then
			MOR = MOR + 2
		End If
		If MOR > MORT Then
			MOR = MORT
		End If
	End If
	If NewHEA And HEA < HEAT Then
		HEA = HEA + 1
		If Rest Then
			HEA = HEA + 2
		End If
		If HEA > HEAT Then
			HEA = HEAT
		End If
	End If
	If MOV < MOVT Then
		MOV = MOV + 0.5 + Float(SPE) / 100.0
		If Rest Then
			MOV = MOV + 2 + Float(SPE) / 50.0
		End If
		If MOV > MOVT Then
			MOV = MOVT
		End If
	End If
	If Rest And HEA = HEAT And MOR = MORT And (Not FullHealth) Then
		Gosub SwitchResting
	End If

; CALCULATE WHAT IS CARRIED
	Gosub ComputeWeight

; MOVE CAMERA UP AND DOWN WITH PAGEUP/PAGEDOWN
	If KeyDown(201) Or KeyDown(209) Then
		If KeyDown(201) Then
			Move = 1
		Else
			Move = -1
		End If
		MoveEntity pvtCam, 0, Move * 5, 0
		If EntityY(pvtCam) < 0 Then
			PositionEntity pvtCam, EntityX(pvtCam), 0, EntityZ(pvtCam)
		End If
		If EntityY(pvtCam) > 300 Then
			PositionEntity pvtCam, EntityX(pvtCam), 300, EntityZ(pvtCam)
		End If
	End If

; TURN CAMERA AROUND IF ON MOUSELOOK
	If MouseLook Then
		MoveX = scrWidth / 2 - MouseX()
		MoveY = (scrHeight - 150) / 2 - MouseY()
		TurnEntity mdlKnight, 0, MoveX / 5, 0
		MoveEntity pvtCam, 0, MoveY / -3, 0
		If EntityY(pvtCam) < 0 Then
			PositionEntity pvtCam, EntityX(pvtCam), 0, EntityZ(pvtCam)
		End If
		If EntityY(pvtCam) > 300 Then
			PositionEntity pvtCam, EntityX(pvtCam), 300, EntityZ(pvtCam)
		End If
		MoveMouse scrWidth / 2, (scrHeight - 150) / 2
	End If

; HANDLE MOUSE & KEYBOARD SHORTCUTS
	button = GetMouse()
	key = GetKey()

; LAST ACTION
	If button = 3 Then
		Select LastAction
			Case 1
				key = 65
			Case 2
				key = 68
			Case 3
				key = 84
		End Select
	End If

; CLICKED ON THE SCREEN
	If button = 1 Then
		If MouseY() < 330 Then
			If CameraPick(camDefault, MouseX(), MouseY()) Then
	; CHANGE TARGET
				LastT = Target
				NPCNumb = 0
				NPCTotal = 0
				For NPCs.NPC = Each NPC
					NPCTotal = NPCTotal + 1
					If NPCs\zx = zx And NPCs\zy = zy Then
						NPCNumb = NPCNumb + 1
						If (PointDistance#(PickedX(), PickedY(), PickedZ(), EntityX(NPCs\model), EntityY(NPCs\model), EntityZ(NPCs\model)) < TargetRange) And (Not NPCs\Dead) Then
							Target = NPCNumb
							If LastT <> Target
								PlaySound sndClick
								NewMessage$ = "New target: " + NPCs\name + "."
								TargetName$ = NPCs\name
								TargetGroup$ = groups(NPCs\group)\name
								L_AddMessage(logMsg, NewMessage$, MsgColors(2))
								Exit
							End If
						End If
					End If
				Next
			End If
		End If
	End If

; SWITCH MOUSELOOK
	If button = 2 Then
		If MouseLook Then
			MouseLook = False
		Else
			MouseLook = True
			MoveMouse scrWidth / 2, (scrHeight - 150) / 2
		End If
	End If

; SAVE A SCREENSHOT
	If key = 19 Then
		PlaySound sndClick
		imgSS = CreateImage(640, 480)
		GrabImage imgSS, 0, 0
		SSName$ = CurrentDate() + "-" + CurrentTime() + "-" + MilliSecs() + ".BMP"
		For Count = 1 To Len(SSName)
			If Mid(SSName, count, 1) = ":" Then
				SSName = Mid(SSName, 1, count - 1) + " " + Mid(SSName, count + 1)
			End If
		Next
		SaveImage(imgSS, SSName)
		NewMessage$ = "Screenshot Saved."
		L_AddMessage(logMsg, NewMessage$, MsgColors(1))
		FreeImage imgSS
	End If
			

; QUICKSAVE
	If key = 81 Or key = 113 Then
		If Slot <> -1 Then
			imgSS = CreateImage(640, 480)
			GrabImage imgSS, 0, 0
			ScaleImage imgSS, 0.375, 0.375
			Gosub QuickSave
			NewMessage$ = "Game saved!"
		Else
			NewMessage$ = "No Save Game Selected!"
		End If
		L_AddMessage(logMsg, NewMessage$, MsgColors(1))
	End If
; QUICKLOAD
	If key = 79 Or key = 111 Then
		If Slot <> -1 Then
			StartPlay = True
			Gosub FreeAll
			fntDefault = LoadFont("Times New Roman", 14, True)
			SetFont fntDefault
			Gosub EradicateAll
			Gosub load2
			Gosub ShowChar
			fntDefault = LoadFont("Times New Roman", 14, True)
			SetFont fntDefault
			Gosub EnterZone
			NewMessage$ = "Game loaded!"
		Else
			NewMessage$ = "No Save Game Selected!"
		End If
		L_AddMessage(logMsg, NewMessage$, MsgColors(1))
	End If

; CHEATS
	If GodMode Then
		HEA = HEAT
		MOR = MORT
		MOV = MOVT
	End If
	If key = 96 ; ENTER CHEAT MODE
		Locate 200, 175
		prev$ = cheatcode$
		cheatcode$ = Input("Enter the cheat: ")
		If cheatcode = "" Then
			cheatcode = prev
		End If
		Select cheatcode
			Case "porntipsguzzard"
				GOL = GOL + 1000
				NewMessage$ = "+1000 golds!"
			Case "uuddlrlrbabas"
				POT = POT + 10
				NewMessage$ = "+10 potions!"
			Case "cooper team"
				ALI = ALI + 25
				NewMessage$ = "+25 alignment!"
			Case "gouranga"
				ALI = ALI - 25
				NewMessage$ = "-25 alignment!"
			Case "mil"
				STU# = STU# + 3 * STRA + 1
				DEU# = DEU# + 3 * DERA + 1
				MEU# = MEU# + 3 * MERA + 1
				NewMessage$ = "More skills!"
			Case "iddqd"
				If GodMode Then
					GodMode = False
					NewMessage$ = "God Mode OFF!"
				Else
					GodMode = True
					NewMessage$ = "God Mode ON!"
				End If				
			Case "idspispopd"
				If FastMode Then
					FastMode = False
					NewMessage$ = "Fast Run Mode OFF!"
				Else
					FastMode = True
					NewMessage$ = "Fast Run Mode ON!"
				End If				
			Case "there can be only one"
				If Target > 0 Then
					For NPCs.NPC = Each NPC
						If NPCs\zx = zx And NPCs\zy = zy Then
							If MD2AnimTime(NPCs\model) > 39 And MD2AnimTime(NPCs\model) < 100 Then
								AnimateMD2 NPCs\model, 1, AnimSpeed, 0, 40
								If NPCs\wpnmodel > 0 Then
									AnimateMD2 NPCs\wpnmodel, 1, AnimSpeed, 0, 40
								End If
								NPCs\moving = False
							End If
						End If
					Next
					NPCNumb = 0
					For NPCs.NPC = Each NPC
						If NPCs\zx = zx And NPCs\zy = zy Then
							NPCNumb = NPCNumb + 1
							If NPCNumb = Target Then
								Exit
							End If
						End If
					Next
					If NPCs\Name <> "Chaos" Then
						FreeEntity NPCs\wpnmodel
						NewMessage$ = "The hand of the gods struck " + NPCs\name + "."
						NPCs\HEA = -1000
						anim = Rand(0, 2)
						AnimateMD2 NPCs\model, 3, AnimSpeed, 178 + 6 * anim, 183 + 6 * anim
						For NPCRaces.NPCRace = Each NPCRace
							If NPCRaces\Race = NPCs\Race Then
								EmitSound(NPCRaces\sndDie, NPCs\model)
							End If
						Next
						FinishDecay = False
						loops = 0
						a# = 1
						s# = 1
						tooltip = ""
						While (Not FinishDecay)
							WaitTimer(frmRate)
							Gosub RenderAndDrawUI
							NPCNumb = 0
							For NPCs.NPC = Each NPC
								If NPCs\zx = zx And NPCs\zy = zy Then
									NPCNumb = NPCNumb + 1
									If NPCNumb = Target Then
										Exit
									End If
								End If
							Next
							loops = loops + 1
							If loops >= 20 Then
								loops = loops - 1
								EntityAlpha NPCs\model, a
								ScaleEntity NPCs\model, s, 1, s
								MoveEntity NPCs\model, 0, 0.01, 0
								a = a - 0.01
								s = s + 0.001
								If a < 0 Then
									loops = loops + 1
									If loops >= 120 Then
										FinishDecay = True
										Gosub CloseTarget
										FreeEntity NPCs\model
										Delete NPCs
									End If
								End If
							End If
						Wend
						NewMessage$ = "The gods are in peace now..."
					Else
						NewMessage$ = NPCs\name + " IS the hands of the gods!"
					End If
				Else
					NewMessage$ = "No targets selected."
				End If
			Case "dlktdr"
				If wire Then
					wire = False
				Else
					wire = True
				End If
				WireFrame wire
				NewMessage$ = "Wire frame switched!"
			Default 
				NewMessage$ = "Incorrect cheat code!"
		End Select	
		L_AddMessage(logMsg, NewMessage$, MsgColors(7))
	End If

; DERIVED STATS	TOOL TIPS
		If MouseArea(173, 351, 14, 107)
			tooltip = "Health: " + HEA + "/" + HEAT
		End If
		If MouseArea(193, 351, 14, 107)
			tooltip = "Morale: " + MOR + "/" + MORT
		End If
		If MouseArea(212, 351, 14, 107)
			tooltip = "Move: " + Int(MOV) + "/" + MOVT
		End If

; DEAL WITH MOVEMENTS
; MOVEMENT UP
		If Not Rest
			If KeyDown(200)
				If MD2AnimTime(mdlKnight) <= 46 Then
					CARMod# = CAR
					CARMod = CARMod / CART
					If CARMod < 0.25 Then
						CARMod = 1.2
					ElseIf CARMod >= 2
						CARMod = 0.6
					Else
						CARMod = 1
					End If
					If FastMode Then
						RunBonus# = 4
					Else
						RunBonus# = 1
					End If
					MovBonus# = Float(MOV) / Float(MOVT)
					If MovBonus# < 0.8 Then
						MovBonus# = 0.8
					End If
					MoveEntity mdlKnight, 0, 0, CARMod * MoveSpeed * RunBonus * MovBonus#
					If Not moving Then
						moving = True
						AnimateMD2 mdlKnight, 1, 0.12 * CARMod, 40, 46
						AnimateMD2 mdlWeapon, 1, 0.12 * CARMod, 40, 46
					End If
					MOV = MOV - 0.75
					MOV = MOV - (1.0 - TerLife#) / 3
					If MOV < 0 Then
						MOV = 0
					End If
				End If
			Else
				If moving = True
					moving = False
					AnimateMD2 mdlKnight, 1, AnimSpeed, 0, 40
					AnimateMD2 mdlWeapon, 1, AnimSpeed, 0, 40
				End If
			End If
	; MOVEMENT LEFT/RIGHT
			If KeyDown(203)
				TurnEntity mdlKnight, 0, 2, 0
			End If
			If KeyDown(205)
				TurnEntity mdlKnight, 0, -2, 0
			End If
	
	; CHECK FOR ZONE CHANGE
			lzx = zx
			lzy = zy
			If EntityX(mdlKnight) <= 0 Then
				zx = WrapZone(zx - 1)
				EntryPosX = 2460
				EntryPosY = EntityZ(mdlKnight)
				EntryAngle = EntityYaw(mdlKnight)
				NewMessage$ = "Moving to the West zone."
				If Target > 0 Then
					Gosub CloseTarget
				End If
				L_AddMessage(logMsg, NewMessage$, MsgColors(10))
				ZoneChange = True
			ElseIf EntityX(mdlKnight) >= 2560 Then	
				zx = WrapZone(zx + 1)
				EntryPosX = 100
				EntryPosY = EntityZ(mdlKnight)
				EntryAngle = EntityYaw(mdlKnight)
				NewMessage$ = "Moving to the East zone."
				If Target > 0 Then
					Gosub CloseTarget
				End If
				L_AddMessage(logMsg, NewMessage$, MsgColors(10))
				ZoneChange = True
			ElseIf EntityZ(mdlKnight) >= 2560 Then
				zy = WrapZone(zy - 1)
				EntryPosX = EntityX(mdlKnight)
				EntryPosY = 100
				EntryAngle = EntityYaw(mdlKnight)
				NewMessage$ = "Moving to the North zone."
				If Target > 0 Then
					Gosub CloseTarget
				End If
				L_AddMessage(logMsg, NewMessage$, MsgColors(10))
				ZoneChange = True
			ElseIf EntityZ(mdlKnight) <= 0 Then	
				zy = WrapZone(zy + 1)
				EntryPosX = EntityX(mdlKnight)
				EntryPosY = 2460
				EntryAngle = EntityYaw(mdlKnight)
				NewMessage$ = "Moving to the South zone."
				If Target > 0 Then
					Gosub CloseTarget
				End If
				L_AddMessage(logMsg, NewMessage$, MsgColors(10))
				ZoneChange = True
			End If
		End If

; NPC NAME TOOLTIP
		If Target > 0 And MouseArea(460, 15, 130, 15)
			tooltip = TargetName$
		End If
; GROUP NAME TOOLTIP
		If Target > 0 And MouseArea(460, 145, 130, 15)
			tooltip = TargetGroup$
		End If
; ON RADAR, SHOW MAP
		dx# = MouseX() - 74
		dx = dx * dx
		dy# = MouseY() - 404.0
		dy = dy * dy
		If Sqr(dy + dx) <= 60 Or key = 77 Or key = 109 Then
			If button = 1 Or key = 77 Or key = 109
				PlaySound sndClick
				Gosub ShowMap
				While KeyDown(1)
				Wend
				FlushKeys
				key = 0
			ElseIf button = 0
				tooltip = "Show map [M]"
			End If
		End If
; CLOSE TARGET WINDOW
		If (MouseArea(470, 240, 110, 10) Or key = 67 Or key = 99 ) And Target > 0
			If button = 1 Or key = 67 Or key = 99
				PlaySound sndClick
				Gosub CloseTarget
			End If
		End If
		
; IF SHOP CLOSE
		If lzx = zx And lzy = zy Then
			For props.Prop = Each prop
				If props\shop > 0 And props\zx = zx And props\zy = zy Then
					If EntityDistance(props\model, mdlKnight) < AttackRange + props\radius / 2 Then
						; SHOP IS CLOSE ENOUGH
						If (MouseArea(571, 275, 50, 50) And button = 1) Or key = 72 Or key = 104
							Gosub CloseTarget
							Include "shop.bb"
							EntryPosX = EntityX(mdlKnight)
							EntryPosY = EntityZ(mdlKnight)
							EntryAngle = EntityYaw(mdlKnight)
							Gosub FreeAll
							Gosub EnterZone
							Exit
						ElseIf MouseArea(571, 275, 50, 50) And button = 0
							tooltip = "Enter Shop [H]"
						End If
					End If							
				End If
			Next
		End If
		
; IF QUEST OBELISK CLOSE
		If lzx = zx And lzy = zy Then
			For props.Prop = Each prop
				If props\zx = zx And props\zy = zy Then
					If props\quest > 0 Then
						If EntityDistance(props\model, mdlKnight) < AttackRange + props\radius / 2 Then
							; QUEST OBELISK IS CLOSE ENOUGH
							If (MouseArea(461, 275, 50, 50) And button = 1)
								; ACCEPT THE QUEST	
								NewMessage$ = "You approach the obelisk and notice something written. It reads: '"
								For Quests.Quest = Each Quest
									If props\quest = Quests\ID Then
										Exit
									End If
								Next
								Select Quests\Typ
									Case 1 ; RETRIEVE THE ITEM
										NewMessage$ = NewMessage$ + "To the worthy adventurer; retrieve a " + Quests\Name$ + " and you shall be rewarded.'"
										QuestLog$ = "Retrieve " + Quests\Name$
									Case 2 ; KILL THE NPC
										NewMessage$ = NewMessage$ + "To the courageous warrior; " + Quests\Name$ + " must be found and executed. Your efforts will be worth it.'"
										QuestLog$ = "Kill " + Quests\Name$
									Case 3 ; CONVINCE THE NPC
										NewMessage$ = NewMessage$ + "To the noble knight; find " + Quests\Name$ + " and convince him, he will be a precious ally. If you do, you will be noticed.'"
										QuestLog$ = "Convince " + Quests\Name$
									Case 4 ; PICKPOCKET AN AMOUNT OF GOLDS 
										NewMessage$ = NewMessage$ + "To the shameless thief; come back when you have stolen " + Quests\Name$ + " golds, and you will be rewarded.'"
										QuestLog$ = "Pickpocket"
									Case 5 ; KILL AN AMOUNT OF RACE
										NewMessage$ = NewMessage$ + "For the executioner; exterminate at least " + 30 + " " + Quests\Name$ + " and come back, you will be rewarded.'"
										QuestLog$ = "Kill " + Quests\Name$
									Case 6 ; BRING AN AMOUNT OF GOLDS
										NewMessage$ = NewMessage$ + "To the gatherer, bring " + Quests\Name$ + " golds here and you will not go unoticed by the gods.'"
										QuestLog$ = "Bring Money"
									Case 7 ; KILL AN AMOUNT OF GROUP
										NewMessage$ = NewMessage$ + "To the slaughterer; kill at least " + 15 + " " + Quests\Name$ + " as you can, And come back here For your reward.'"
										QuestLog$ = "Kill " + Quests\Name$
									Case 8 ; GET RESPECT FROM GROUP
										NewMessage$ = NewMessage$ + Quests\Name$ + " are a group important in the eyes of the gods. Gain respect from them and you will gain the respect of the gods.'"
										QuestLog$ = "Get Respect From " + Quests\Name$
								End Select
								L_AddMessage(logMsg, NewMessage$, MsgColors(4))
								setLog(QuestLog$ + " (" + Quests\ID + ")", "In Progress")
								props\quest = -1 * props\quest
								Gosub CloseTarget
								Exit
							ElseIf MouseArea(461, 275, 50, 50) And button = 0
								tooltip = "Accept Quest"
							End If
						End If							
					ElseIf props\quest < 0 Then
						If EntityDistance(props\model, mdlKnight) < AttackRange + props\radius / 2 Then
							; QUEST OBELISK IS CLOSE ENOUGH
							If (MouseArea(461, 275, 50, 50) And button = 1)
								; VERIFY IF THE QUEST IS FINISHED
								For Quests.Quest = Each Quest
									If Abs(props\quest) = Quests\ID Then
										Exit
									End If
								Next
								Select Quests\Typ
									Case 1 ; RETRIEVE THE ITEM
										QuestLog$ = "Retrieve " + Quests\Name$
										For Items.Valuable = Each Valuable
											If GetName(Valuables(Items\ID)) = Quests\Name$ Then
												Quests\Done = True
												Delete Items
												Exit
											End If
										Next
									Case 2 ; KILL THE NPC
										QuestLog$ = "Kill " + Quests\Name$
									Case 3 ; CONVINCE THE NPC
										QuestLog$ = "Convince " + Quests\Name$
										For NPCs.NPC = Each NPC
											If NPCs\Name$ = Quests\Name$ Then
												If NPCs\REA >= 300 Then
													Quests\Done = True
												End If
											End If
										Next
									Case 4 ; PICKPOCKET AN AMOUNT OF GOLDS 
										QuestLog$ = "Pickpocket"
										If Int(Quests\Name$) <= 0 Then
											Quests\Done = True
										End If
									Case 5 ; KILL AN AMOUNT OF RACE
										QuestLog$ = "Kill " + Quests\Name$
										If Int(GetLog(Quests\Name$ + " Race Kills")) >= 30 Then
											Quests\Done = True
										End If
									Case 6 ; BRING AN AMOUNT OF GOLDS
										QuestLog$ = "Bring Money"
										If GOL >= Int(Quests\Name$) Then
											GOL = GOL - Int(Quests\Name$)
											Quests\Done = True
										End If
									Case 7 ; KILL AN AMOUNT OF GROUP
										QuestLog$ = "Kill " + Quests\Name$
										If Int(GetLog(Quests\Name$ + " Group Kills")) >= 15 Then
											Quests\Done = True
										End If
									Case 8 ; GET RESPECT FROM GROUP
										QuestLog$ = "Get Respect From " + Quests\Name$
										For grp.Group = Each Group
											If grp\Name$ = Quests\Name$ Then
												If grp\Faction >= 200 Then
													Quests\Done = True
												End If
											End If
										Next
								End Select								
								If Quests\Done Then	
									NewMessage$ = "You are worthy, noble one. Your efforts will be rewarded as promised."
									STU# = STU# + STRA + 1
									DEU# = DEU# + DERA + 1
									MEU# = MEU# + MERA + 1
									setLog(QuestLog$ + " (" + Quests\ID + ")", "Finished")
									props\quest = 0
								Else
									NewMessage$ = "You have not yet accomplished your task (" + QuestLog$ + "), come back when you are finished."
								End If
								L_AddMessage(logMsg, NewMessage$, MsgColors(4))
								Gosub CloseTarget
								Exit
							ElseIf MouseArea(461, 275, 50, 50) And button = 0
								tooltip = "Finish Quest"
							End If
						End If							
					End If
				End If
			Next
		End If


; IF TREASURE CLOSE
		If lzx = zx And lzy = zy 
			For props.Prop = Each Prop
				If props\zx = zx And props\zy = zy Then
					If props\treasure Then
						If EntityDistance(mdlKnight, props\model) <= AttackRange Then
							If (MouseArea(516, 275, 50, 50) And button = 1) Or key = 69 Or key = 101
								EmitSound sndTreasure, props\model
								If props\GOL > 0 Then
									GOL = GOL + props\GOL
									NewMessage$ = "You found " + props\gol + " golds"
									High = 3
								Else
									NewMessage$ = "Empty"
									High = 2
								End If
								High = Rand(1, High)
								If High = 1 Then
									items.Valuable = New Valuable
									items\id = Rand(0, maxItems)
									If Len(items\id) < 2 Then
										items\id = "0" + items\id
									End If
									If Len(items\id) < 3 Then
										items\id = "0" + items\id
									End If
									items\value = Rand(getLow(valuables(items\id)), getHigh(valuables(items\id)))
									If NewMessage$ = "Empty" Then
										NewMessage$ = "You found an item: " + getName(valuables(items\id))
									Else
										NewMessage$ = NewMessage$ + " along with an item: " + getName(valuables(items\id))
									End If						
								End If
								NewMessage$ = NewMessage$ + "!"
								L_AddMessage(logMsg, NewMessage$, MsgColors(9))
								Animate props\model, 3, 1.5, 0
								props\gol = 1
								props\treasure = 0
							ElseIf MouseArea(516, 275, 50, 50) And button = 0
								tooltip = "Open Treasure [E]"
							End If
						End If
					End If
				End If
			Next
		End If

		If (MouseArea(499, 343, 37, 37) Or key = 32) And (Not Rest)
			If button = 1 Or key = 32
				PlaySound sndClick
; CHANGE TARGET
				NTarget = Target
				LastT = Target
				Repeat
					NTarget = NTarget + 1
					NPCNumb = 0
					NPCTotal = 0
					For NPCs.NPC = Each NPC
						NPCTotal = NPCTotal + 1
						If NPCs\zx = zx And NPCs\zy = zy Then
							NPCNumb = NPCNumb + 1
							If NPCNumb = NTarget Then
								If EntityDistance(NPCs\model, mdlKnight) < AttackRange And (Not NPCs\DEAD) Then
									Target = NTarget
									If LastT <> Target
										PointEntity mdlKnight, NPCs\model
										RotateEntity mdlKnight, 0, EntityYaw(mdlKnight), 0
										NewMessage$ = "New target: " + NPCs\name + "."
										TargetName$ = NPCs\name
										TargetGroup$ = groups(NPCs\group)\name
										L_AddMessage(logMsg, NewMessage$, MsgColors(2))
									Else
										NewMessage$ = "No other targets available."
										L_AddMessage(logMsg, NewMessage$, MsgColors(2))
									End If
								End If
							End If
						End If
					Next
					If NPCTotal < NTarget
						NTarget = 0
					End If
				Until Target = NTarget
				If Target = 0 Then
					NewMessage = "No targets close enough."
					L_AddMessage(logMsg, NewMessage$, MsgColors(2))
				End If
			ElseIf button = 0
				tooltip = "Change target [SPC]"
			End If
		End If
; ATTACK TARGET
		If (MouseArea(542, 343, 37, 37) Or key = 65 Or key = 97) And (Not Rest)
			If button = 1 Or key = 65 Or key = 97
				mp# = MOV
				mp = mp / MOVT
				If mp >= 0.60 And Target > 0
					NPCNumb = 0
					For NPCs.NPC = Each NPC
						If NPCs\zx = zx And NPCs\zy = zy Then
							NPCNumb = NPCNumb + 1
							If NPCNumb = Target And (Not NPCs\Dead) Then
								If EntityDistance(NPCs\model, mdlKnight) < AttackRange Then
									LastAction = 1
									NPCGroup = NPCs\group
									If NPCs\REA > -750 Then
										NPCs\REA = -750
									Else
										NPCs\REA = NPCs\REA - 75
									End If
									PointEntity mdlKnight, NPCs\model
									RotateEntity mdlKnight, 0, EntityYaw(mdlKnight), 0
									targetCamX# = camSpeed * ((EntityX(pvtCam, True) + EntityX(camDefault)) / 2 - EntityX(camDefault))
									targetCamY# = camSpeed * ((EntityY(pvtCam, True) + EntityY(camDefault)) / 2 - EntityY(camDefault))
									targetCamZ# = camSpeed * ((EntityZ(pvtCam, True) + EntityZ(camDefault)) / 2 - EntityZ(camDefault))
									TranslateEntity camDefault, targetCamX, targetCamY, targetCamZ
									If EntityX(camDefault) < 10 Then
										PositionEntity camDefault, 10, EntityY(camDefault), EntityZ(camDefault)
									End If
									If EntityX(camDefault) > 2550 Then
										PositionEntity camDefault, 2550, EntityY(camDefault), EntityZ(camDefault)
									End If
									If EntityZ(camDefault) < 10 Then
										PositionEntity camDefault, EntityX(camDefault), EntityY(camDefault), 10
									End If
									If EntityZ(camDefault) > 2550 Then
										PositionEntity camDefault, EntityX(camDefault), EntityY(camDefault), 2550
									End If
									PointEntity camDefault, mdlKnight
									TurnEntity camDefault, -15, 0, 0
									MOVMod# = MOVT - MOV
									MOVMod = MOVMod / MOVT
									MOVMod = MOVMod * 25
									MOV = MOV - 0.60 * Float(MOVT)
									ToHit# = ST
									ToHit = ToHit / (2 * NPCs\ST)
									ToHit = 35 + ToHit * 75
									ToHit = ToHit - MOVMod
									Hit = Rand(1, 100)
									AnimateMD2 mdlKnight, 3, AnimSpeed, 46, 53
									AnimateMD2 mdlWeapon, 3, AnimSpeed, 46, 53
									STU# = STU# + 1 * Float(Consider) / 100
									If Hit <= ToHit Then
										PlaySound sndHit
									Else
										PlaySound sndMiss
									End If
									If Hit <= ToHit Then
										dmg = DAM - NPCs\AB
										If Hit <= 12 Then
											NewMessage$ = "Critical! "
											dmg = dmg * 2
											IncLog("Critical Hits")
										Else
											NewMessage$ = ""
										End If
										STU# = STU# + 1 * Float(Consider) / 100
										BothAnim = True
										If dmg < 1 Then
											STU# = STU# - 1 * Float(Consider) / 100
											dmg = 1
										End If
										MORMod# = MOR
										MORMod = MORMod / MORT
										MORMod = MORMod - 0.5
										MORMod = MORMod * 4
										dmg = dmg + Int(MORMod)
										NewMessage$ = NewMessage$ + "You hit " + NPCs\name + " for " + dmg + " damage."
										newBloodEmitter(1, dmg, NPCs\model)
										AddLog("Damage Dealt", dmg)
										IncLog("Hits Landed")
										SetLog("Average Damage", Int(Float(GetLog("Damage Dealt")) / Float(GetLog("Hits Landed"))))
										Hits# = GetLog("Hits Landed")
										Misses# = GetLog("Misses Count")
										If Misses + Hits = 0 Then
											Misses = 1
										End If
										SetLog("Hit Ratio", Int(Hits / (Misses + Hits) * 100) + "%")
										L_AddMessage(logMsg, NewMessage$, MsgColors(3))
										NPCs\HEA = NPCs\HEA - dmg
										NPCs\MOR = NPCs\MOR - Int(dmg * 1.5)
										MOR = MOR + dmg
										If MOR > MORT Then
											MOR = MORT
										End If
										anim = Rand(0, 2)
										If NPCs\HEA <= 0
											STU# = STU# + 1 * Float(Consider) / 100
											FreeEntity NPCs\wpnmodel
											NPCs\wpnmodel = 0
											NewMessage$ = NPCs\name + " died!"
											For Quests.Quest = Each Quest
												If Quests\Typ = 2 Then
													If NPCs\Name$ = Quests\Name$ Then
														Quests\Done = True
														Exit
													End If
												End If
											Next
											newBloodEmitter(2, dmg, NPCs\model)
											For OtherNPCs.NPC = Each NPC
												If OtherNPCs\ZX = ZX And OtherNPCs\ZY = ZY Then
													If OtherNPCs\Group = NPCs\group Then
														OtherNPCs\MOR = OtherNPCs\MOR + NPCs\HEA	
													End If
												End If
											Next											
											L_AddMessage(logMsg, NewMessage$, MsgColors(3))
											IncLog(NPCs\race + " Race Kills")
											IncLog(groups(NPCs\group)\name + " Group Kills")
											IncLog("Total Kills")
											IncLog(ALIText(NPCs\ALI) + " ALI Kills")
											If Len(NPCs\items) > 0 Then
												ItemTotal = Len(NPCs\items) / 6
												ItemBroken = 0
												For count = 1 To ItemTotal
													itemid = (count - 1) * 6 + 1
													itm$ = Mid(NPCs\items, itemid, 3)
													vle$ = Mid(NPCs\items, itemid + 3, 3)
													If Rand(1, 100) < getFragility(valuables(itm)) Then
														ItemBroken = ItemBroken + 1
													Else
														items.Valuable = New Valuable
														items\id = itm
														items\value = vle
													End If
												Next
												Perc# = ItemBroken
												Perc = Perc / ItemTotal * 100
												Prc = Perc
												NewMessage$ = "You broke " + prc + "% of the valuables."
												L_AddMessage(logMsg, NewMessage$, MsgColors(8))
												If ItemBroken <> ItemTotal Then
													NewMessage$ = "You looted the remaining valuables (" + (ItemTotal - ItemBroken) + ") and " + NPCs\GOL + " golds!"
												Else
													NewMessage$ = "You looted " + NPCs\GOL + " golds!"
												End If
											Else
												NewMessage$ = "You looted " + NPCs\GOL + " golds!"
											End If
											L_AddMessage(logMsg, NewMessage$, MsgColors(9))
											GOL = GOL + NPCs\GOL
											AddLog("Golds Looted", NPCs\GOL)
											ALI = ALI - NPCs\ALI / 100
											For Count = 0 To GroupCount
												If groups(count)\ALI < 0 Then
													groups(count)\Faction = groups(count)\Faction + NPCs\ALI / 200
												Else
													groups(count)\Faction = groups(count)\Faction - NPCs\ALI / 200
												End If
											Next
											groups(NPCs\group)\Faction = groups(NPCs\group)\Faction - Rand(10, 15)
											SetLog(groups(NPCs\group)\Name + " Group Faction", groups(NPCs\group)\Faction)
											NPCs\dead = True
										End If
									Else
										BothAnim = False
										IncLog("Misses Count")
										Hits# = GetLog("Hits Landed")
										Misses# = GetLog("Misses Count")
										If Misses + Hits = 0 Then
											Misses = 1
										End If
										SetLog("Hit Ratio", Int(Hits / (Misses + Hits) * 100) + "%")
										NewMessage$ = "You missed " + NPCs\name + "."
										L_AddMessage(logMsg, NewMessage$, MsgColors(3))
									End If
									If NPCs\dead And NPCs\name = "Chaos" Then
										NewMessage$ = "You have killed Chaos!"
										L_AddMessage(logMsg, NewMessage$, MsgColors(3))
										Gosub CloseTarget
										Gosub Win
									Else
										NPCNumb = 0
										For NPCs.NPC = Each NPC
											If NPCs\zx = zx And NPCs\zy = zy Then
												NPCNumb = NPCNumb + 1
												If NPCNumb = Target Then
													Exit
												End If
											End If
										Next
										If BothAnim Then
											If NPCs\dead Then
												AnimateMD2 NPCs\model, 3, AnimSpeed, 178 + 6 * anim, 183 + 6 * anim
												For NPCRaces.NPCRace = Each NPCRace
													If NPCRaces\Race = NPCs\Race Then
														EmitSound(NPCRaces\sndDie, NPCs\model)
													End If
												Next
												NPCs\Alpha# = 1
												NPCs\Scale# = 1
												EntityType NPCs\model, 0
												Gosub CloseTarget
											Else
												AnimateMD2 NPCs\model, 3, AnimSpeed, 54 + 4 * anim, 57 + 4 * anim
												AnimateMD2 NPCs\wpnmodel, 3, AnimSpeed, 54 + 4 * anim, 57 + 4 * anim
												For NPCRaces.NPCRace = Each NPCRace
													If NPCRaces\Race = NPCs\Race Then
														EmitSound(NPCRaces\sndHit, NPCs\model)
													End If
												Next
											End If
										End If
									End If
									NewNPCNum = 0
									For NPCs.NPC = Each NPC
										NewNPCNum = NewNPCNum + 1
										If NPCs\zx = zx And NPCs\zy = zy Then
											If NPCGroup = NPCs\group And NPCs\REA > -650 Then
												NPCs\REA = -650
											End If
										End If
									Next
									Exit
								End If
							End If
						End If
					Next
				End If
			ElseIf button = 0
				tooltip = "Attack [A]"
			End If
		End If
; DRINK POTION
		If MouseArea(585, 343, 37, 37) Or key = 80 Or key = 112
			If button = 1 Or key = 80 Or key = 112
				mp# = MOV
				mp = mp / MOVT
				If mp >= 0.10 And POT > 0 And HEA < HEAT
					PlaySound sndDrink
					POT = POT - 1
					MOV = MOV - 0.10 * MOVT
					minH# = HEAT
					maxH# = HEAT
					minH = 0.08 * minH
					maxH = 0.12 * maxH
					Hamt = Rand(Int(minH), Int(maxH))
					If Rand(1, 10) = 1 Then
						Hamt = Hamt * 3
					End If
					If HEA + Hamt > HEAT Then
						Hamt = HEAT - HEA
					End If
					HEA = HEA + Hamt
					NewMessage$ = "You quaffed a potion and gained " + Hamt + " Health points."
					L_AddMessage(logMsg, NewMessage$, MsgColors(6))
				End If
			ElseIf button = 0
				tooltip = "Use a potion (" + POT + ") [P]"
			End If
		End If
		If (MouseArea(499, 386, 37, 37) Or key = 68 Or key = 100) And (Not Rest)
			If (button = 1 Or key = 68 Or key = 100) And DisableSteal < MilliSecs() - 1000
; STEAL/BACKSTAB
				mp# = MOV
				mp = mp / MOVT
				If mp >= 0.75 And Target > 0
					NPCNumb = 0
					For NPCs.NPC = Each NPC
						If NPCs\zx = zx And NPCs\zy = zy Then
							NPCNumb = NPCNumb + 1
							If NPCNumb = Target And (Not NPCs\Dead) Then
								If EntityDistance(NPCs\model, mdlKnight) < AttackRange Then
									LastAction = 2
									NPCGroup = NPCs\group
	; PLACE KNIGHT AND CAMERA
									PointEntity mdlKnight, NPCs\model
									RotateEntity mdlKnight, 0, EntityYaw(mdlKnight), 0
									targetCamX# = camSpeed * ((EntityX(pvtCam, True) + EntityX(camDefault)) / 2 - EntityX(camDefault))
									targetCamY# = camSpeed * ((EntityY(pvtCam, True) + EntityY(camDefault)) / 2 - EntityY(camDefault))
									targetCamZ# = camSpeed * ((EntityZ(pvtCam, True) + EntityZ(camDefault)) / 2 - EntityZ(camDefault))
									TranslateEntity camDefault, targetCamX, targetCamY, targetCamZ
									If EntityX(camDefault) < 10 Then
										PositionEntity camDefault, 10, EntityY(camDefault), EntityZ(camDefault)
									End If
									If EntityX(camDefault) > 2550 Then
										PositionEntity camDefault, 2550, EntityY(camDefault), EntityZ(camDefault)
									End If
									If EntityZ(camDefault) < 10 Then
										PositionEntity camDefault, EntityX(camDefault), EntityY(camDefault), 10
									End If
									If EntityZ(camDefault) > 2550 Then
										PositionEntity camDefault, EntityX(camDefault), EntityY(camDefault), 2550
									End If
									PointEntity camDefault, mdlKnight
									TurnEntity camDefault, -15, 0, 0
									If NPCs\REA >= -550 Then
	; PICKPOCKET
										MOV = MOV - Float(MOVT) * 0.75
										ToHit# = DE
										ToHit = ToHit / (2 * NPCs\DE)
										ToHit = 40 + ToHit * 60
										Hit = Rand(1, 100)
										Hit = Float(ToHit - Hit) / 5
										If Hit > 0 Then
											DEU# = DEU# + 1 * Float(Consider) / 100
											If Hit >= NPCs\GOL Then
												Hit = NPCs\GOL
											End If
											If Hit = 0 Then
												DEU# = DEU# + 0.1 * Float(Consider) / 100
												NewMessage$ = NPCs\Name + " doesn't have any golds to steal from."
												PlaySound sndClick
											Else
												DEU# = DEU# + 2 * Float(Consider) / 100
												NPCs\GOL = NPCs\GOL - Hit
												GOL = GOL + Hit
												For Quests.Quest = Each Quest
													If Quests\Typ = 4 Then
														Quests\Name$ = Int(Quests\Name$) - Hit
													End If
												Next
												PlaySound sndMoney
												NewMessage$ = "You stole " + hit + " golds from " + NPCs\Name + "."
												AddLog("Golds Stolen", hit)
											End If
											L_AddMessage(logMsg, NewMessage$, MsgColors(12))
										Else
											DEU# = DEU# + 1 * Float(Consider) / 100
											If NPCs\REA > -600 Then
												NPCs\REA = -600
											Else
												NPCs\REA = NPCs\REA - 60
											End If
											PlaySound sndClick
											NewMessage$ = NPCs\Name + " saw you trying to pickpocket!"
											L_AddMessage(logMsg, NewMessage$, MsgColors(5))
										End If
									Else
	; BACKSTAB
										MOVMod# = MOVT - MOV
										MOVMod = MOVMod / MOVT
										MOVMod = MOVMod * 25
										MOV = MOV - Float(MOVT) * 0.75
										ToHit# = DE
										ToHit = ToHit / (2 * NPCs\DE)
										ToHit = 10 + ToHit * 35
										ToHit = ToHit - MOVMod
										Hit = Rand(1, 100)
										AnimateMD2 mdlKnight, 3, AnimSpeed, 46, 53
										AnimateMD2 mdlWeapon, 3, AnimSpeed, 46, 53
										DEU# = DEU# + 1 * Float(Consider) / 100
										If Hit <= ToHit Then
											PlaySound sndHit
										Else
											PlaySound sndMiss
										End If
										If Hit <= ToHit Then
											DEU# = DEU# + 1 * Float(Consider) / 100
											BothAnim = True
											dmg = (DAM - NPCs\AB) * 3
											If dmg < 1 Then
												DEU# = DEU# - 1 * Float(Consider) / 100
												dmg = 1
											End If
											MORMod# = MOR
											MORMod = MORMod / MORT
											MORMod = MORMod - 0.5
											MORMod = MORMod * 4
											dmg = dmg + Int(MORMod)
											newBloodEmitter(1, dmg, NPCs\model)
											NewMessage$ = "You backstab " + NPCs\name + " for " + dmg + " damage."
											AddLog("Backstab Damage", dmg)
											IncLog("Backstabs Landed")
											SetLog("Average Damage per Backstab", Int(Float(GetLog("Backstab Damage")) / Float(GetLog("Backstabs Landed"))))
											Hits# = GetLog("Backstabs Landed")
											Misses# = GetLog("Backstabs Missed")
											If Misses + Hits = 0 Then
												Misses = 1
											End If
											SetLog("Backstabs Hit Ratio", Int(Hits / (Misses + Hits) * 100) + "%")
											L_AddMessage(logMsg, NewMessage$, MsgColors(3))
											NPCs\HEA = NPCs\HEA - dmg
											NPCs\MOR = NPCs\MOR - dmg
											MOR = MOR + dmg / 3
											If MOR > MORT Then
												MOR = MORT
											End If
											anim = Rand(0, 2)
											If NPCs\HEA <= 0
												DEU# = DEU# + 1 * Float(Consider) / 100
												FreeEntity NPCs\wpnmodel
												newBloodEmitter(2, dmg, NPCs\model)
												NewMessage$ = NPCs\name + " died!"
												For Quests.Quest = Each Quest
													If Quests\Typ = 2 Then
														If NPCs\Name$ = Quests\Name$ Then
															Quests\Done = True
															Exit
														End If
													End If
												Next
												L_AddMessage(logMsg, NewMessage$, MsgColors(3))
												IncLog(NPCs\race + " Race Kills")
												IncLog(groups(NPCs\group)\name + " Group Kills")
												IncLog("Total Kills")
												IncLog(ALIText(NPCs\ALI) + " ALI Kills")
												If Len(NPCs\items) > 0 Then
													ItemTotal = Len(NPCs\items) / 6
													ItemBroken = 0
													For count = 1 To ItemTotal
														itemid = (count - 1) * 6 + 1
														itm$ = Mid(NPCs\items, itemid, 3)
														vle$ = Mid(NPCs\items, itemid + 3, 3)
														If Rand(0, 80)-5 < getFragility(valuables(itm)) Then
															ItemBroken = ItemBroken + 1
														Else
															items.Valuable = New Valuable
															items\id = itm
															items\value = vle
														End If
													Next
													Perc# = ItemBroken
													Perc = Perc / ItemTotal * 100
													Prc = Perc
													NewMessage$ = "You broke " + prc + "% of the valuables."
													L_AddMessage(logMsg, NewMessage$, MsgColors(8))
													If ItemBroken <> ItemTotal Then
														NewMessage$ = "You looted the remaining valuables (" + (ItemTotal - ItemBroken) + ") and " + NPCs\GOL + " golds!"
													Else
														NewMessage$ = "You looted " + NPCs\GOL + " golds!"
													End If
												Else
													NewMessage$ = "You looted " + NPCs\GOL + " golds!"
												End If
												L_AddMessage(logMsg, NewMessage$, MsgColors(9))
												GOL = GOL + NPCs\GOL
												AddLog("Golds Looted", NPCs\GOL)
												ALI = ALI - NPCs\ALI / 100
												For Count = 0 To GroupCount
													If groups(count)\ALI < 0 Then
														groups(count)\Faction = groups(count)\Faction + NPCs\ALI / 200
													Else
														groups(count)\Faction = groups(count)\Faction - NPCs\ALI / 200
													End If
												Next
												groups(NPCs\group)\Faction = groups(NPCs\group)\Faction - Rand(10, 15)
												SetLog(groups(NPCs\group)\Name + " Group Faction", groups(NPCs\group)\Faction)
												NPCs\dead = True
											End If
										Else
											IncLog("Backstabs Missed")
											Hits# = GetLog("Backstabs Landed")
											Misses# = GetLog("Backstabs Missed")
											If Misses + Hits = 0 Then
												Misses = 1
											End If
											SetLog("Backstabs Hit Ratio", Int(Hits / (Misses + Hits) * 100) + "%")
											NewMessage$ = "Your backstab attempt on " + NPCs\name + " missed."
											L_AddMessage(logMsg, NewMessage$, MsgColors(3))
										End If
										If NPCs\DEAD And NPCs\NAME = "Chaos" Then
											NewMessage$ = "You have killed Chaos!"
											L_AddMessage(logMsg, NewMessage$, MsgColors(3))
											Gosub CloseTarget
											Gosub Win
										Else
											NPCNumb = 0
											For NPCs.NPC = Each NPC
												If NPCs\zx = zx And NPCs\zy = zy Then
													NPCNumb = NPCNumb + 1
													If NPCNumb = Target Then
														Exit
													End If
												End If
											Next
											If BothAnim Then
												If NPCs\dead Then
													AnimateMD2 NPCs\model, 3, AnimSpeed, 178 + 6 * anim, 183 + 6 * anim
													For NPCRaces.NPCRace = Each NPCRace
														If NPCRaces\Race = NPCs\Race Then
															EmitSound(NPCRaces\sndDie, NPCs\model)
														End If
													Next
													NPCs\Alpha# = 1
													NPCs\Scale# = 1
													EntityType NPCs\model, 0
													Gosub CloseTarget
												Else
													AnimateMD2 NPCs\model, 3, AnimSpeed, 54 + 4 * anim, 57 + 4 * anim
													AnimateMD2 NPCs\wpnmodel, 3, AnimSpeed, 54 + 4 * anim, 57 + 4 * anim
													For NPCRaces.NPCRace = Each NPCRace
														If NPCRaces\Race = NPCs\Race Then
															EmitSound(NPCRaces\sndHit, NPCs\model)
														End If
													Next
												End If
											End If
										End If
										NewNPCNum = 0
										For NPCs.NPC = Each NPC
											NewNPCNum = NewNPCNum + 1
											If NPCs\zx = zx And NPCs\zy = zy Then
												If NPCGroup = NPCs\group And NPCs\REA > -700 Then
													NPCs\REA = -700
												End If
											End If
										Next
										Exit
									End If
								End If
							End If
						End If
					Next
				End If
			ElseIf button = 0
				tooltip = "Pick pocket/Backstab [D]"
			End If
		End If
; TALK/RESONATE
		If (MouseArea(542, 386, 37, 37) Or key = 84 Or key = 116) And (Not Rest)
			If (button = 1 Or key = 84 Or key = 116)
				mp# = MOV
				mp = mp / MOVT
				If mp >= 0.30 And Target > 0
					NPCNumb = 0
					For NPCs.NPC = Each NPC
						If NPCs\zx = zx And NPCs\zy = zy Then
							NPCNumb = NPCNumb + 1
							If NPCNumb = Target And (Not NPCs\Dead) Then
								If EntityDistance(NPCs\model, mdlKnight) < AttackRange Then
									lastAction = 3
									PlaySound sndClick
									NPCGroup = NPCs\group
	; PLACE KNIGHT AND CAMERA
									PointEntity mdlKnight, NPCs\model
									RotateEntity mdlKnight, 0, EntityYaw(mdlKnight), 0
									targetCamX# = camSpeed * ((EntityX(pvtCam, True) + EntityX(camDefault)) / 2 - EntityX(camDefault))
									targetCamY# = camSpeed * ((EntityY(pvtCam, True) + EntityY(camDefault)) / 2 - EntityY(camDefault))
									targetCamZ# = camSpeed * ((EntityZ(pvtCam, True) + EntityZ(camDefault)) / 2 - EntityZ(camDefault))
									TranslateEntity camDefault, targetCamX, targetCamY, targetCamZ
									If EntityX(camDefault) < 10 Then
										PositionEntity camDefault, 10, EntityY(camDefault), EntityZ(camDefault)
									End If
									If EntityX(camDefault) > 2550 Then
										PositionEntity camDefault, 2550, EntityY(camDefault), EntityZ(camDefault)
									End If
									If EntityZ(camDefault) < 10 Then
										PositionEntity camDefault, EntityX(camDefault), EntityY(camDefault), 10
									End If
									If EntityZ(camDefault) > 2550 Then
										PositionEntity camDefault, EntityX(camDefault), EntityY(camDefault), 2550
									End If
									PointEntity camDefault, mdlKnight
									TurnEntity camDefault, -15, 0, 0
									If NPCs\REA >= -550 Then
	; TALK/TRADE
										If NPCs\REA < -100 Then
											NPCSay$ = "'Please be quick, my time is precious.' " + NPCs\name + " doesn't want to trade with you."
										ElseIf NPCs\REA <= 100 Then
											NPCSay$ = "'Hello there, " + name + ", what do you want?'"
										Else
											NPCSay$ = "'Hey! How are you good friend?'"
										End If
										NPCSay$ = NPCs\Name + " says: " + NPCSay$
										
										FirstYI = 0
										FirstNI = 0
										
										NGOL = 0
										YGOL = 0
										
										For Count = 0 To 9
											NItems(Count) = -1
											YItems(Count) = -1
										Next
	
										overItmY = -1
										overItmN = -1
										
										If ME >= NPCs\ME Then
											VMY# = 1 + Float((Float(ME) / Float(NPCs\ME))) * 0.1
											VMN# = 1 - Float((Float(ME) / Float(NPCs\ME))) * 0.1
										Else
											VMY# = 1 - Float((Float(NPCs\ME) / Float(ME))) * 0.1
											VMN# = 1 + Float((Float(NPCs\ME) / Float(ME))) * 0.1
										End If
										If NPCs\REA >= 150
											VMY = VMY + 0.1
										End If
										
										Advance = 0
										
										FinishTalk = False
										
										Talk = True
										
										While Not FinishTalk
										
											WaitTimer frmRate
											
											Trade = True
											If NPCs\REA < -100 Then
												Trade = False
											End If
											If YOffer < NOffer Then
												Trade = False
											End If
											If YOffer = 0 Then
												Trade = False
											End If
											If YOffer = YGOL And NOffer = NGOL And YOffer = NOffer Then
												Trade = False
											End If
											
											DrawImage imgTrade, 0, 0
											If Not trade Then
												DrawImage imgDTrade, 290, 445
											End If
											If Not talk Then
												DrawImage imgDTrade, 232, 445
											End If
	
											Color 255, 255, 255
											; WRITE NPC NAME
											OutlineText(345, 25, NPCs\Name, False, False)
											
											; PROCESS AND WRITE WHAT THE MESSAGE IS
											NPCSay2$ = NPCSay
											Count = 0
											While Len(NPCSay2) > 45
												SpacePos = 46
												Repeat
													SpacePos = SpacePos - 1
												Until Mid(NPCSay2, SpacePos, 1) = " "
												OutlineText(352, 57 + Count * 15, Mid(NPCSay2, 1, SpacePos), False, False)
												NPCSay2 = Mid(NPCSay2, SpacePos + 1)
												Count = Count + 1
											Wend
											OutlineText(352, 57 + Count * 15, NPCSay2, False, False)
											
											; WRITE THE INVENTORIES
											OutlineText(15, 135, "Your inventory:", False, False)
											TotalY = 0
											Count = 0
											For Items.Valuable = Each Valuable
												TotalY = TotalY + 1
												If Count >= FirstYI And Count < FirstYI + 15
													Slct = False
													For Counter = 0 To 9
														If Count = YITems(Counter) Then
															Slct = True
														End If
													Next
													If Slct Then
														Color 0, 0, 255
													Else
														Color 255, 255, 255
													End If
													If Count = overItmY And Slct Then
														Color 0, 255, 255
													ElseIf Count = overItmY Then
														Color 0, 255, 0
													End If
													OutlineText(25, 157 + (Count - FirstYI) * 15, getName(valuables(Items\ID)) + " (" + Int(Int(items\value) * VMY) + " golds)", False, False)
												End If
												Count = Count + 1
											Next
											
											Color 255, 255, 255
											OutlineText(345, 135, "Inventory:", False, False)
											TotalN = 0
											Count = 0
											While Count * 6 < Len(NPCs\items)
												TotalN = TotalN + 1
												If Count >= FirstNI And Count < FirstNI + 15
													Slct = False
													For Counter = 0 To 9
														If Count = NITems(Counter) Then
															Slct = True
														End If
													Next
													If Slct Then
														Color 0, 0, 255
													Else
														Color 255, 255, 255
													End If
													If Count = overItmN And Slct Then
														Color 0, 255, 255
													ElseIf Count = overItmN Then
														Color 0, 255, 0
													End If
													OutlineText(355, 157 + (Count - FirstNI) * 15, getName(valuables(Mid(NPCs\items, 1 + Count * 6, 3))) + " (" + Int(Int(Mid(NPCs\items, 4 + Count * 6, 3)) * VMN) + " golds)", False, False)
												End If
												Count = Count + 1
											Wend
											
											; WRITE GOLDS
											Color 255, 255, 0
											OutlineText(71, 410, YGOL + " golds out of " + GOL + " (Total Offer: " + YOffer + ")", False, False)
											OutlineText(401, 410, NGOL + " golds out of " + NPCs\GOL + " (Total Offer: " + NOffer + ")", False, False)
											
											; DRAW CURSOR IF NOT IN MOUSELOOK
											DrawImage imgCursor, MouseX(), MouseY()
											
											Flip
											
											; PROCESS CLICKS
											
											overItmY = -1
											overItmN = -1
											mouse = GetMouse()
											key = GetKey()
											If MouseArea(15, 405, 25, 25) And mouse = 1
												YGOL = YGOL + 1
												If YGOL > GOL Then
													YGOL = GOL
													PlaySound sndInvalid
												Else
												    PlaySound sndClick
												End If
											End If
											If MouseArea(41, 405, 25, 25) And mouse = 1
												YGOL = YGOL - 1
												If YGOL < 0 Then
													YGOL = 0
													PlaySound sndInvalid
												Else
													PlaySound sndClick
												End If
											End If
											If MouseArea(345, 405, 25, 25) And mouse = 1
												NGOL = NGOL + 1
												If NGOL > NPCs\GOL Then
													NGOL = NPCs\GOL
													PlaySound sndInvalid
												Else
													PlaySound sndClick
												End If
											End If
											If MouseArea(371, 405, 25, 25) And mouse = 1
												NGOL = NGOL - 1
												If NGOL < 0 Then
													NGOL = 0
													PlaySound sndInvalid
												Else
													PlaySound sndClick
												End If
											End If
											If MouseArea(25, 157, 240, 225) And mouse = 1
												NewI = True
												ItmC = (MouseY() - 157) / 15 + FirstYI
												For Count = 0 To 9
													If YItems(Count) = ItmC Then
														PlaySound sndClick
														YItems(Count) = -1
														NewI = False	
													End If
												Next
												If NewI And ItmC <= TotalY Then
													Avail = -1
													For Count = 0 To 9
														If YItems(Count) = -1 Then
															Avail = Count
														End If
													Next
													If Avail = -1 Then
														NPCSay = "You cannot trade more than ten (10) items at once, complete this trade first."
														PlaySound sndInvalid
													Else
														YItems(Avail) = ItmC
														PlaySound sndClick
													End If
												End If											
											End If
											If MouseArea(355, 157, 240, 225) And mouse = 1
												NewI = True
												ItmC = (MouseY() - 157) / 15 + FirstNI
												For Count = 0 To 9
													If NItems(Count) = ItmC Then
														NItems(Count) = -1
														NewI = False
														PlaySound sndClick	
													End If
												Next
												If NewI And ItmC <= TotalN Then
													Avail = -1
													For Count = 0 To 9
														If NItems(Count) = -1 Then
															Avail = Count
														End If
													Next
													If Avail = -1 Then
														NPCSay = "You cannot trade more than ten (10) items at once, complete this trade first."
														PlaySound sndInvalid
													Else
														NItems(Avail) = ItmC
														PlaySound sndClick
													End If
												End If											
											End If
											If MouseArea(275, 150, 15, 15) And mouse = 1
												FirstYI = FirstYI - 1
												If FirstYI < 0 Then
													FirstYI = 0
													PlaySound sndInvalid
												Else
													PlaySound sndClick
												End If
											End If
											If MouseArea(275, 375, 15, 15) And mouse = 1
												FirstYI = FirstYI + 1
												If FirstYI > TotalY - 15 Then
													FirstYI = TotalY - 15
													If FirstYI < 0 Then
														FirstYI = 0
													End If
													PlaySound sndInvalid
												Else
													PlaySound sndClick
												End If
											End If
											If MouseArea(605, 150, 15, 15) And mouse = 1
												FirstNI = FirstNI - 1
												If FirstNI < 0 Then
													FirstNI = 0
													PlaySound sndInvalid
												Else
													PlaySound sndClick
												End If
											End If
											If MouseArea(605, 375, 15, 15) And mouse = 1
												FirstNI = FirstNI + 1
												If FirstNI > TotalN - 15 Then
													FirstNI = TotalN - 15
													If FirstNI < 0 Then
														FirstNI = 0
													End If
													PlaySound sndInvalid
												Else
													PlaySound sndClick
												End If
											End If
											If ((MouseArea(232, 445, 55, 25) And mouse = 1) Or (key = 84 Or key = 116)) And Talk
												PlaySound sndClick
												Select Rand(1, 20)
													Case 1
														t$ = " for a while"
													Case 2
														t$ = " for some time"
													Case 3
														t$ = " a bit"
													Case 4
														t$ = " about rumors"
													Case 5
														t$ = " about a group of the region"
													Case 6
														t$ = " about a local group"
													Case 7
														t$ = " to catch up"
													Case 8
														t$ = " and learn some news"
													Case 9
														t$ = " to get news"
													Case 10
														t$ = " about things to watch out"
													Case 11
														t$ = " about the weather"
													Case 12
														t$ = " and hear about things you didn't know"
													Case 13
														t$ = ""
													Case 14
														t$ = " while cleaning with your weapon"
													Case 15
														t$ = " while removing stains on your plate"
													Case 16
														t$ = " and you stop abruptly"
													Case 17
														t$ = " and run out of subjects after a while"
													Case 18
														t$ = ", but notice you have other things to do"
													Case 19
														t$ = " and notice your hair is a mess"
													Case 20
														t$ = " and notice that you stink big time
												End Select
												NPCSay = "You talk with " + NPCs\name + t$ + "..."
												Advance = Advance + 10
												PrevREA = NPCs\REA
												NPCs\REA = NPCs\REA + 5
												MEU# = MEU# + 0.1
												Talk = Rand(1, 20)
												If Talk = 1 Then
													Talk = False
													NPCSay = NPCSay + " " + NPCs\name + " doesn't want to talk anymore."
												Else
													Talk = True
												End If
											End If
											If MouseArea(290, 445, 55, 25) And Trade And mouse = 1
												PlaySound sndMoney
												NPCSay = "You trade your goods with " + NPCs\name + "."
												Advance = Advance + 5
												PrevREA = NPCs\REA
												NPCs\REA = NPCs\REA + 2 + (YOffer - NOffer) / 5
												MEU# = MEU# + Float(NOffer) / 50
												NPCs\GOL = NPCs\GOL + YGOL - NGOL
												GOL = GOL + NGOL - YGOL
												NValue = 0
												YValue = 0
												For Count = 0 To 9
													If YItems(Count) > -1 Then
														Counter = 0
														For Items.Valuable = Each Valuable
															If Len(Items\ID) < 2 Then
																Items\ID = "0" + Items\ID
															End If
															If Len(Items\ID) < 3 Then
																Items\ID = "0" + Items\ID
															End If
															If Len(Items\Value) < 2 Then
																Items\Value = "0" + Items\Value
															End If
															If Len(Items\Value) < 3 Then
																Items\Value = "0" + Items\Value
															End If
															If Counter = YItems(Count) Then
																NPCs\Items = NPCs\Items + Items\ID + Items\Value
																NValue = NValue + Int(Items\Value)
																Delete Items
																For Count2 = Count + 1 To 9
																	If YItems(Count2) > YItems(Count) Then
																		YItems(Count2) = YItems(Count2) - 1
																	End If
																Next
															End If
															Counter = Counter + 1
														Next
													End If
												Next
												For Count = 0 To 9
													If NItems(Count) > -1 Then
														If NItems(Count) = 0 Then
															Part1$ = ""
														Else
															Part1$ = Mid(NPCs\Items, 1, NItems(Count) * 6)
														End If
														Part2$ = Mid(NPCs\Items, 1 + (NItems(Count) + 1) * 6)
														Items.Valuable = New Valuable
														Items\ID = Mid(NPCs\Items, 1 + NItems(Count) * 6, 3)
														Items\Value = Mid(NPCs\Items, 4 + NItems(Count) * 6, 3)
														YValue = YValue + Int(Items\Value)
														For Counter = Count + 1 To 9
															If NItems(Counter) > NItems(Count) Then
																NItems(Counter) = NItems(Counter) - 1
															End If
														Next
														NPCs\Items = Part1$ + Part2$
													End If
												Next
												AddLog("Buy Amount", NOffer - NGOL)
												AddLog("Buy Value", NValue)
												AddLog("Sell Amount", YOffer - YGOL)
												AddLog("Sell Value", YValue)
												MercRatio# = GetLog("Buy Amount") + GetLog("Sell Value")
												MercRatio = MercRatio / Float(GetLog("Buy Value") + GetLog("Sell Amount"))
												MercRatio = MercRatio * 100
												SetLog("Mercantile Efficiency", Int(MercRatio) + "%")
												YGOL = 0
												NGOL = 0
												FirstYI = 0
												FirstNI = 0
												For Count = 0 To 9
													NItems(Count) = -1
													YItems(Count) = -1
												Next
											End If
											If MouseArea(305, 405, 25, 25) And mouse = 1
												PlaySound sndClick
												Difference = Abs(YOffer - NOffer)
												If YOffer > NOffer Then
													NPCs\GOL = NPCs\GOL - Difference
													If NPCs\GOL - NGOL <= 0 Then
														NGOL = NPCs\GOL + Difference
													Else
														NGOL = NGOL + Difference
													End If
													NPCs\GOL = NPCs\GOL + Difference
												ElseIf YOffer < NOffer Then
													GOL = GOL - Difference
													If GOL - YGOL <= 0 Then
														YGOL = GOL + Difference
													Else
														YGOL = YGOL + Difference
													End If
													GOL = GOL + Difference
												End If
												If Difference > 0 Then
													NPCSay = "Trade has been balanced as close as it could."
												End If
											End If
											If (MouseArea(348, 445, 55, 25) And mouse = 1) Or key = 27
												PlaySound sndClick
												FinishTalk = True
												key = 0
											End If
											If (((MouseArea(232, 445, 55, 25) And Talk) Or (MouseArea(290, 445, 55, 25) And Trade)) And mouse = 1) Or ((key = 84 Or key = 116) And (Talk Or Trade))
												If ME + MEU# / MERA >= NPCs\ME Then
													VMY# = 1 + (Float(ME + MEU# / MERA) / Float(NPCs\ME)) * 0.1
													VMN# = 1 - (Float(ME + MEU# / MERA) / Float(NPCs\ME)) * 0.1
												Else
													VMY# = 1 - (Float(NPCs\ME) / Float(ME + MEU# / MERA)) * 0.1
													VMN# = 1 + (Float(NPCs\ME) / Float(ME + MEU# / MERA)) * 0.1
												End If
												If NPCs\REA >= 150
													VMY = VMY + 0.1
												End If
												If PrevREA < -100 And NPCs\REA >= -100 Then
													NPCSay = NPCSay + " " + NPCs\Name + " is starting to trust you."
													groups(NPCs\group)\Faction = groups(NPCs\group)\Faction + Rand(10, 15)
													SetLog(groups(NPCs\group)\Name + " Group Faction", groups(NPCs\group)\Faction)
													ALI = ALI + NPCs\ALI / 100
													IncLog("NPCs Convinced")
												End If
											End If
											If MouseArea(25, 157, 240, 225)
												OverItmY = (MouseY() - 157) / 15 + FirstYI
											End If
											If MouseArea(355, 157, 240, 225)
												OverItmN = (MouseY() - 157) / 15 + FirstNI
											End If
											
											; CALCULATE OFFERS
											YOffer = YGOL
											NOffer = NGOL
											For Count = 0 To 9
												If YItems(Count) > -1 Then
													Counter = 0
													For Items.Valuable = Each Valuable
														If YItems(Count) = Counter Then
															YOffer = YOffer + Int(Items\Value) * VMY
														End If
														Counter = Counter + 1
													Next
												End If
												If NItems(Count) > -1 Then
													NOffer = NOffer + Int(Mid(NPCs\items, 4 + NItems(Count) * 6, 3)) * VMN
												End If
											Next
											
											FlushMouse
											
										Wend
										
										HEA = HEA + Advance / 24
										MOR = MOR + Advance / 10
										If HEA > HEAT Then
											HEA = HEAT
										End If
										If MOR > MORT Then
											MOR = MORT
										End If
										
										While Advance > 0
											Advance = Advance - 5
											Minute = Minute + 5
											Count = 0
											For NPCs.NPC = Each NPC
												If NPCs\ZX = ZX And NPCs\ZY = ZY Then
													Count = Count + 1
													If Count <> Target Then
														MoveEntity NPCs\model, Rnd(0, 400) - 200, 0, Rnd(0, 400) - 200
														NewX = EntityX(NPCs\model)
														NewZ = EntityZ(NPCs\model)
														If EntityX(NPCs\model) > 2500 Then
															NewX = 2500
														End If
														If EntityX(NPCs\model) < 60 Then
															NewX = 60
														End If
														If EntityZ(NPCs\model) > 2500 Then
															NewZ = 2500
														End If
														If EntityZ(NPCs\model) < 60 Then
															NewZ = 60
														End If
														PositionEntity NPCs\model, NewX, EntityY(NPCs\model), NewZ
														TurnEntity NPCs\model, 0, Rnd(0, 90) - 45, 0
													End If
												End If
											Next
										Wend
										
										Count = 0
										For NPCs.NPC = Each NPC
											If NPCs\ZX = ZX And NPCs\ZY = ZY Then
												Count = Count + 1
												If Count = Target Then
													Exit
												End If
											End If	
										Next
										
										Gosub ComputeWeight
	
									Else
	; REASON
										MOV = MOV - Float(MOVT) * 0.3
										REAMod# = Float(NPCs\REA) / 35
										ToHit# = ME
										ToHit = ToHit / (2 * NPCs\ME)
										ToHit = 20 + ToHit * 60 + REAMod
										Hit = Rand(1, 100)
										Hit = Float(ToHit - Hit) / 2
										If Hit >= 0 Or REAMod >= 0 Then
											If REAMod > 10 Then
												REAMod = 0.1 * Float(Consider) / 100
												NewMessage$ = "You say 'Hi!' to your good friend " + NPCs\Name + "."
											ElseIf REAMod > 0
												REAMod = (1/REAMod + Float(Consider/100)) / 3
												NewMessage$ = "You say 'Hi!' to your friend " + NPCs\Name + "."
											ElseIf REAMod = 0
												REAMod = Float(Consider / 100)
												NewMessage$ = "You say 'Hi!' to " + NPCs\Name + "."
											Else
												REAMod = (REAMod/-5 + Float(Consider/100)) / 2
												If NPCs\REA <= -300
													NewMessage$ = "You try to reason " + NPCs\Name + "."
												Else
													NewMessage$ = "You try to get " + NPCs\Name + " to talk to you."
												End If
											End If
											L_AddMessage(logMsg, NewMessage$, MsgColors(13))
											MEU# = MEU# + REAMod
										    PrevREA = NPCs\REA
											If Hit >= 0
												NPCs\REA = NPCs\REA + Hit
											End If
											If PrevREA < -100 And NPCs\REA >= -100 Then
												IncLog("NPCs Convinced")
												MEU# = MEU# + REAMod
												NewMessage$ = "You convinced " + NPCs\Name + " to trust you."
												groups(NPCs\group)\Faction = groups(NPCs\group)\Faction + Rand(3, 6)
												L_AddMessage(logMsg, NewMessage$, MsgColors(13))
											ElseIf PrevREA < -550 And NPCs\REA >= -550 Then
												MEU# = MEU# + REAMod / 3
												NewMessage$ = "You reasoned " + NPCs\Name + " to stop attacking you!"
												L_AddMessage(logMsg, NewMessage$, MsgColors(13))
											End If
										Else
											MEU# = MEU# + 0.7 * Float(Consider) / 100
											NewMessage$ = NPCs\Name + " is ignoring you totally."
											L_AddMessage(logMsg, NewMessage$, MsgColors(13))
										End If
									End If
								End If
							End If
						End If
					Next
				End If
			ElseIf button = 0
				tooltip = "Talk/Reason [T]"
			End If
		End If
; START/STOP RESTING
		If MouseArea(585, 386, 37, 37) Or key = 82 Or key = 114
			If (button = 1 Or key = 82 Or key = 114)
				PlaySound sndClick
				Gosub SwitchResting
			ElseIf button = 0
				If Not Rest
					tooltip = "Rest [R]"
				Else
					tooltip = "Stop Resting [R]"
				End If				
			End If
		End If
; SHOW CHARACTER
		If MouseArea(499, 429, 37, 37) Or key = 83 Or key = 115
			If button = 1 Or key = 83 Or key = 115
				Gosub CloseTarget
				PlaySound sndClick
				Gosub ShowChar
				SetFont fntDefault
			ElseIf button = 0
				tooltip = "Stats [S]"
			End If
		End If
		If MouseArea(542, 429, 37, 37) Or key = 76 Or key = 108
			If button = 1 Or key = 76 Or key = 108
; SHOW LOG BOOK
				PlaySound sndClick
				minu$ = Int(minute)
				If Int(minu) < 10 Then
					minu = "0" + minu
				End If
				If minu = "60" Then
					minu = "00"
				End If
				hr$ = Int(hour)
				If hr = "24" Then
					hr = "0"
				End If
				dayS$ = Int(day)
				If dayS = "366" Then
					dayS = "1"
				End If
				SetLog("Date and Time", hr+":"+minu+" on day "+dayS+" of the year "+year)
				DrawImage imgLog, 0, 0
				count = 0
				off = 0
				Color 255, 255, 220
				logs.LogData = First LogData
				Gosub LogWrite
				logs = After logs
				Gosub LogWrite
				Gosub ShowSeparator
				For logs.LogData = Each LogData
					If Instr(Upper(logs\value), Upper("In Progress"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				For logs.LogData = Each LogData
					If Instr(Upper(logs\value), Upper("Finished"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				Gosub ShowSeparator
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Hit"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Backstabs Landed"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Miss"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Damage"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				Gosub ShowSeparator
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Group Faction"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				Gosub ShowSeparator
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Group Kill"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				Gosub ShowSeparator
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Race Kill"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				Gosub ShowSeparator
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("ALI Kill"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				Gosub ShowSeparator
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Total Kill"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				Gosub ShowSeparator
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Gold"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				Gosub ShowSeparator
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Buy"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Sell"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Mercantile"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				Gosub ShowSeparator
				For logs.LogData = Each LogData
					If Instr(Upper(logs\name), Upper("Convinced"), 1) > 0 Then
						Gosub LogWrite
					End If
				Next
				If OnlyForLogging
.LogWrite
					OutlineText(off + 30, 30 + count * 15, logs\name + ": " + logs\value, False, False)
					count = count + 1
					If count = 28 Then
						If off = 0 Then
							count = 0
							off = 320
						Else
							Flip
							While Not KeyDown(1)
							Wend
							DrawImage imgLog, 0, 0
							count = 0
							off = 0
							While KeyDown(1)
							Wend
						End If						
					End If
Return				
.ShowSeparator
					OutlineText(off + 30, 30 + count * 15, "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=", False, False)
					count = count + 1
					If count = 28 Then
						If off = 0 Then
							count = 0
							off = 320
						Else
							Flip
							While Not KeyDown(1)
							Wend
							DrawImage imgLog, 0, 0
							count = 0
							off = 0
							While KeyDown(1)
							Wend
						End If						
					End If
Return				
				End If
				Flip
				While Not KeyDown(1)
				Wend
				PlaySound sndClick
			ElseIf button = 0
				tooltip = "Log [L]"
			End If
		End If
		If MouseArea(585, 429, 37, 37) Or key = 27
			If button = 1 Or key = 27
				PlaySound sndClick
				imgSS = CreateImage(640, 480)
				GrabImage imgSS, 0, 0
				ScaleImage imgSS, 0.375, 0.375
; SHOW OPTIONS
				Gosub CloseTarget
				imgOption = LoadImage("images\options.jpg")
				MaskImage imgOption, 255, 0, 255
				
				OptionSave = False
				OptionLoad = False
				OptionQuit = False
				OptionMenu = False
				OptionChosen = False

				While Not OptionChosen
				
					WaitTimer frmRate
					
					RenderWorld
					
					DrawImage imgOption, 0, 330
					DrawImage imgCursor, MouseX(), MouseY()
					
					button = GetMouse()
					If button = 1 Then
						If MouseArea(315, 355, 150, 50) Then
							PlaySound sndClick
							OptionSave = True
							OptionChosen = True
						End If
						If MouseArea(315, 410, 150, 50) Then
							PlaySound sndClick
							OptionLoad = True
							OptionChosen = True
						End If
						If MouseArea(155, 410, 150, 50) Then
							PlaySound sndClick
							OptionChosen = True
							OptionMenu = True
						End If
						If MouseArea(470, 355, 150, 50) Then
							PlaySound sndClick
							OptionQuit = True
							OptionChosen = True
						End If
						If MouseArea(470, 410, 150, 50) Then
							PlaySound sndClick
							OptionChosen = True
						End If
					End If
					FlushMouse()
					
					Flip
					
				Wend

				FreeImage imgOption
				FreeFont fntDefault
				FlushKeys
				If OptionSave Then
					Include "save.bb"
					If OKPressed Then
						NewMessage$ = "Game saved!"
						L_AddMessage(logMsg, NewMessage$, MsgColors(1))
					End If
					fntDefault = LoadFont("Times New Roman", 14, True)
					SetFont fntDefault
				ElseIf OptionLoad Then
					StartPlay = False
					Gosub load
					If StartPlay Then
						Gosub FreeAll
						fntDefault = LoadFont("Times New Roman", 14, True)
						SetFont fntDefault
						Gosub EradicateAll
						Gosub load2
						Gosub ShowChar
						fntDefault = LoadFont("Times New Roman", 14, True)
						SetFont fntDefault
						Gosub EnterZone
					End If
					fntDefault = LoadFont("Times New Roman", 14, True)
					SetFont fntDefault
				ElseIf OptionMenu Then
					Gosub FreeAll
					Gosub FinishIt				
				ElseIf OptionQuit Then
					End
				End If
				fntDefault = LoadFont("Times New Roman", 14, True)
				SetFont fntDefault
				FreeImage imgSS
			ElseIf button = 0
				tooltip = "Options [ESC]"
			End If
		End If
				
		FlushMouse
		FlushKeys

; ALIGN CAMERA
	targetCamX# = camSpeed * ((EntityX(pvtCam, True) + EntityX(camDefault)) / 2 - EntityX(camDefault))
	targetCamY# = camSpeed * ((EntityY(pvtCam, True) + EntityY(camDefault)) / 2 - EntityY(camDefault))
	targetCamZ# = camSpeed * ((EntityZ(pvtCam, True) + EntityZ(camDefault)) / 2 - EntityZ(camDefault))
	TranslateEntity camDefault, targetCamX, targetCamY, targetCamZ
	If EntityX(camDefault) < 10 Then
		PositionEntity camDefault, 10, EntityY(camDefault), EntityZ(camDefault)
	End If
	If EntityX(camDefault) > 2550 Then
		PositionEntity camDefault, 2550, EntityY(camDefault), EntityZ(camDefault)
	End If
	If EntityZ(camDefault) < 10 Then
		PositionEntity camDefault, EntityX(camDefault), EntityY(camDefault), 10
	End If
	If EntityZ(camDefault) > 2550 Then
		PositionEntity camDefault, EntityX(camDefault), EntityY(camDefault), 2550
	End If
	PointEntity camDefault, mdlKnight
	TurnEntity camDefault, -15, 0, 0

; IF SKILL USE, PROCESS IT
	If LSTU# <> STU# Then
		If STU# >= STRA Then
			STU# = STU# - STRA
			STUS = STUS + 1
			ST = ST + 1
			DAM = WTY + WME + ST / 5
			NewMessage$ = "You gained Strength!"
			L_AddMessage(logMsg, NewMessage$, MsgColors(14))
		End If
		If STUS = 3 Then
			STUS = 0
			STRA = STRA + 1
			POW = POW + 1
			RES = RES + 1
			HEAT = HEAT + 2
			HEA = HEA + 2
			CART = CART + 1
			AB = AME + RES / 5
			NewMessage$ = "You gained Power and Resistance!"
			L_AddMessage(logMsg, NewMessage$, MsgColors(14))
		End If
		If STU# >= STRA Then
			LSTU# = 0
		Else
			LSTU# = STU#
		End If
	End If
	If LDEU# <> DEU# Then
		If DEU# >= DERA Then
			DEU# = DEU# - DERA
			DEUS = DEUS + 1
			DE = DE + 1
			NewMessage$ = "You gained Dexterity!"
			L_AddMessage(logMsg, NewMessage$, MsgColors(14))
		End If
		If DEUS = 3 Then
			DEUS = 0
			DERA = DERA + 1
			COO = COO + 1
			SPE = SPE + 1
			MOVT = MOVT + 3
			MOV = MOV + 3
			NewMessage$ = "You gained Coordination and Speed!"
			L_AddMessage(logMsg, NewMessage$, MsgColors(14))
		End If
		If DEU# >= DERA Then
			LDEU# = 0
		Else
			LDEU# = DEU#
		End If
	End If
	If LMEU# <> MEU# Then
		If MEU# >= MERA Then
			MEU# = MEU# - MERA
			MEUS = MEUS + 1
			ME = ME + 1
			NewMessage$ = "You gained Mental!"
			L_AddMessage(logMsg, NewMessage$, MsgColors(14))
		End If
		If MEUS = 3 Then
			MEUS = 0
			MERA = MERA + 1
			MIN = MIN + 1
			AWA = AWA + 1
			MORT = MORT + 3
			MOR = MOR + 3
			NewMessage$ = "You gained Mind and Awareness!"
			L_AddMessage(logMsg, NewMessage$, MsgColors(14))
		End If
		If MEU# >= MERA Then
			LMEU# = 0
		Else
			LMEU# = MEU#
		End If
	End If

; DRAW UI

	Gosub RenderAndDrawUI

; CHANGE ZONE
	If ZoneChange Then
		PreviousZone = zones(lzx, lzy)\texture
		MOV = MOVT
		ZoneChange = False
		Gosub FreeAll
		Gosub EnterZone
	End If

Wend
endedOK = True

.FreeAll
If Not endedOK Then
	FreeEntity pvtOnCam
	Gosub CloseTarget
	FreeTexture texZone
	FreeTexture texHeight
	FreeEntity terZone
	FreeEntity terZoneBorder
	FreeEntity terZonePlateau
	FreeEntity pvtCam
	FreeEntity camDefault
	camDefault = 0
	FreeEntity lstKnight
	FreeTexture texWeapon
	FreeEntity mdlWeapon
	FreeTexture texKnight
	FreeEntity mdlKnight
	FreeImage imgInterface
	FreeImage imgCursor
	FreeImage imgBlankBar
	FreeImage imgHEA
	FreeImage imgMOR
	FreeImage imgMOV
	FreeImage imgNorth
	FreeImage imgDisable
	FreeImage imgTarget
	FreeImage imgMsg
	FreeImage imgRadar
	FreeImage imgZone
	FreeImage imgExit
	FreeImage imgTreasure
	FreeImage imgQuests
	FreeImage imgShops
	FreeImage imgMap
	FreeImage imgTrade
	FreeImage imgDTrade
	FreeImage imgLog
	FreeImage imgBtnShop
	FreeImage imgBtnQuest
	FreeImage imgBtnTreasure
	For i = 0 To 360
		FreeImage imgYou(i)
	Next
	FreeSound sndDrink
	FreeSound sndMoney
	FreeSound sndMiss
	FreeSound sndStep1
	FreeSound sndStep2
	FreeSound sndStep3
	FreeSound sndStep4
	FreeSound sndTreasure
	FreeSound sndMusic
	FreeSound sndDie
	FreeSound sndHit
	For BloodEmitters.BloodEmitter = Each BloodEmitter
		PW_KillParticles(BloodEmitters\emt)
		PW_KillEmitter(BloodEmitters\emt)
		Delete BloodEmitters
	Next
	For NPCRaces.NPCRace = Each NPCRace
		FreeSound NPCRaces\sndAtk
		FreeSound NPCRaces\sndHit
		FreeSound NPCRaces\sndDie
		Delete NPCRaces
	Next
	For NPCs.NPC = Each NPC
		If NPCs\zx = lzx And NPCs\zy = lzy Then
			NPCs\x = EntityX(NPCs\model)
			NPCs\y = EntityZ(NPCs\model)
			If Not NPCs\Dead Then
				FreeEntity NPCs\wpnmodel
			End If
			FreeEntity NPCs\model
			If NPCs\Dead And (Not KeepBodies) Then
				Delete NPCs
			Else
				NPCs\Items$ = ""
			End If
		End If
	Next
	For props.Prop = Each Prop
		If props\zx = lzx And props\zy = lzy Then
			FreeEntity props\model
		End If
	Next
	Return
End If

.RenderAndDrawUI
If Not endedOK Then
	; DRAW BARS
		DrawImage imgHEA, 174, 352
		DrawImage imgMOR, 194, 352
		DrawImage imgMOV, 213, 352
	
		s1# = HEA
		s2# = HEAT
		pos# = s1# / s2# * 107.0
		If pos# <= 2 Then
			pos# = 2
		End If
		If HEA <= 0 Then
			pos# = 1
		End If
		DrawImage imgBlankBar, 174, 352 - pos#
		s1# = MOR
		s2# = MORT
		pos# = s1# / s2# * 107.0
		If pos# <= 2 Then
			pos# = 2
		End If
		If MOR <= 0 Then
			pos# = 1
		End If
		DrawImage imgBlankBar, 194, 352 - pos#
		s1# = MOV
		s2# = MOVT
		pos# = s1# / s2# * 107.0
		If pos# <= 2 Then
			pos# = 2
		End If
		If MOV <= 0 Then
			pos# = 1
		End If
		DrawImage imgBlankBar, 213, 352 - pos#
	
		DrawImage imgMsg, 253, 345
		DrawImage imgRadar, 15, 345

		If zoneChange Then
			exPsK1# = Float(EntryPosX) / 2560.0 * 40.0
			exPsK2# = 40.0 - Float(EntryPosY) / 2560.0 * 40.0
		Else
			exPsK1# = EntityX(mdlKnight) / 2560.0 * 40.0
			exPsK2# = 40.0 - EntityZ(mdlKnight) / 2560 * 40.0
		End If
		shiftX = -20 + exPsK1
		shiftY = 350 - exPsK2

		offX = WrapZone(zx - 1)
		offY = WrapZone(zy - 1)
		For XCount = offX To offX + 2
			For YCount = offY To offY + 2
				If zones(WrapZone(XCount), WrapZone(YCount)) <> Null Then
; DRAW ZONE BASE
					xPs = (WrapZone(XCount - offX)) * 50 - shiftX
					yPs = (WrapZone(YCount - offY)) * 50 + shiftY
					Select zones(WrapZone(XCount), WrapZone(YCount))\texture
						Case 1
							Color 58,76,12
						Case 2
							Color 37,67,25
						Case 3
							Color 93,88,83
						Case 4
							Color 96,91,91
						Case 5
							Color 145,119,70
						Case 6
							Color 65,67,36
						Case 7
							Color 39,84,36
						Case 8
							Color 67,101,48
						Case 9
							Color 68,88,52
						Case 10
							Color 88,101,84
					End Select
					Rect xPs, yPs, 50, 50, True					
					Select zones(WrapZone(XCount), WrapZone(YCount))\texture
						Case 1
							Color 157,153,75
						Case 2
							Color 94,124,75
						Case 3
							Color 119,111,107
						Case 4
							Color 151,137,137
						Case 5
							Color 180,143,94
						Case 6
							Color 117,109,75
						Case 7
							Color 79,124,75
						Case 8
							Color 97,128,76
						Case 9
							Color 95,113,75
						Case 10
							Color 103,112,99
					End Select
					Rect xPs + 5, yPs + 5, 40, 40, True
					
; DRAW ZONE EXITS
					Exits(0) = zones(WrapZone(XCount), WrapZone(YCount))\exit1
					Exits(1) = zones(WrapZone(XCount), WrapZone(YCount))\exit2
					Exits(2) = zones(WrapZone(XCount), WrapZone(YCount))\exit3
					Exits(3) = zones(WrapZone(XCount), WrapZone(YCount))\exit4
					Exits(4) = zones(WrapZone(XCount), WrapZone(YCount))\exit5
					For Counter = 0 To 4
						zonID$ = Left(exits(counter), 1)
						If zonID <> "" Then
							extPos = Mid(exits(counter), 2)
							exPs# = extPos
							exPs = exPs / 256 * 50
						End If	
						If zonID = "N" Then
							Rect (WrapZone(XCount - offX)) * 50 + exPs - 2 - shiftX, (WrapZone(YCount - offY)) * 50 + shiftY, 5, 5, True
						ElseIf zonID = "S" Then
							Rect (WrapZone(XCount - offX)) * 50 + exPs - 2 - shiftX, (WrapZone(YCount - offY)) * 50 + 45 + shiftY, 5, 5, True
						ElseIf zonID = "E" Then
							Rect (WrapZone(XCount - offX)) * 50 + 45 - shiftX, (WrapZone(YCount - offY)) * 50 + (50 - exPs) - 2 + shiftY, 5, 5, True
						ElseIf zonID = "W" Then
							Rect (WrapZone(XCount - offX)) * 50 - shiftX, (WrapZone(YCount - offY)) * 50 + (50 - exPs) - 2 + shiftY, 5, 5, True
						End If
					Next

; DRAW UNOPENED TREASURES, QUESTS AND SHOPS
					For props.Prop = Each Prop
						If props\zx = WrapZone(XCount) And props\zy = WrapZone(YCount) Then
							If props\treasure Then
								exPs1# = Float(props\X) / 2560 * 40
								exPs2# = 40 - Float(props\Y) / 2560 * 40
								DrawImage imgTreasure, (WrapZone(XCount - offX)) * 50 + exPs1 - 2 + 5 - shiftX, (WrapZone(YCount - offY)) * 50 + exPs2 - 2 + 5 + shiftY
							End If
							If props\shop > 0 Then
								exPs1# = Float(props\X) / 2560 * 40
								exPs2# = 40 - Float(props\Y) / 2560 * 40
								DrawImage imgShops, (WrapZone(XCount - offX)) * 50 + exPs1 - 2 + 5 - shiftX, (WrapZone(YCount - offY)) * 50 + exPs2 - 2 + 5 + shiftY
							End If
							If props\quest <> 0 Then
								exPs1# = Float(props\X) / 2560 * 40
								exPs2# = 40 - Float(props\Y) / 2560 * 40
								DrawImage imgQuests, (WrapZone(XCount - offX)) * 50 + exPs1 - 2 + 5 - shiftX, (WrapZone(YCount - offY)) * 50 + exPs2 - 2 + 5 + shiftY
							End If

						End If
					Next	

; DRAW YOU-POINTER AT END
					If zx = WrapZone(XCount) And zy = WrapZone(YCount) Then

						If Not ZoneChange Then
							; DRAW NPCS PIXELS
							For NPCs.NPC = Each NPC
								If zx = NPCs\zx And zy = NPCs\zy And (Not NPCs\Dead) Then
									R = NPCs\REA
									If R < -650 Then
										R = -650
									ElseIf R > 150 Then
										R = 150
									End If
									R = R + 650
									R = (Float(R) / 800) * 255
									Color 255, R, R
									exPs1# = Float(EntityX(NPCs\model)) / 2560 * 40
									exPs2# = 40 - Float(EntityZ(NPCs\model)) / 2560 * 40
									Xps = (WrapZone(XCount - offX)) * 50 + exPs1 - 2 + 5 - shiftX - 1
									Yps = (WrapZone(YCount - offY)) * 50 + exPs2 - 2 + 5 + shiftY - 1
									Rect Xps, Yps, 2, 2, True
								End If
							Next
						End If
						
						DrawImage imgYou(Wrap360(Int(EntityYaw(mdlKnight)+90))), (WrapZone(XCount - offX)) * 50 + exPsK1 - 2 + 5 - shiftX, (WrapZone(YCount - offY)) * 50 + exPsK2 - 2 + 5 + shiftY
					End If

				End If
			Next
		Next
		
	; UPDATE AND RENDER WORLD
		PW_UpdateParticles()
		PW_UpdateEmitters()
		UpdateWorld
		RenderWorld

	; DRAW USER INTERFACE
		DrawImage imgInterface, 0, 330
		mp# = MOV
		mp = mp / MOVT
		If Target > 0 Then
			If mp < 0.60 Then
				DrawImage imgDisable, 542, 343
			End If
			If mp < 0.75 Then
				DrawImage imgDisable, 499, 386
			End If
			If mp < 0.30 Then
				DrawImage imgDisable, 542, 386
			End If
		Else
			DrawImage imgDisable, 542, 343
			DrawImage imgDisable, 499, 386
			DrawImage imgDisable, 542, 386
		End If
		If mp < 0.10 Or POT <= 0 Or HEA = HEAT
			DrawImage imgDisable, 585, 343
		End If
		
	; DRAW THE ACCEPT QUEST BUTTON
		If lzx = zx And lzy = zy Then
			For props.Prop = Each prop
				If props\quest <> 0 And props\zx = zx And props\zy = zy Then
					If EntityDistance(props\model, mdlKnight) < AttackRange + props\radius / 2 Then
						DrawImage imgBtnQuest, 461, 275
					End If
				End If
			Next
		End If	
	
	
	; DRAW THE ENTER SHOP BUTTON
		If lzx = zx And lzy = zy Then
			For props.Prop = Each prop
				If props\shop > 0 And props\zx = zx And props\zy = zy Then
					If EntityDistance(props\model, mdlKnight) < AttackRange + props\radius / 2 Then
						DrawImage imgBtnShop, 571, 275
					End If
				End If
			Next
		End If	
		
	; DRAW THE OPEN TREASURE BUTTON
		If lzx = zx And lzy = zy 
			For props.Prop = Each Prop
				If props\zx = zx And props\zy = zy Then
					If props\treasure Then
						If EntityDistance(mdlKnight, props\model) <= AttackRange Then
							DrawImage imgBtnTreasure, 516, 275
						End If
					End If
				End If
			Next
		End If
	
	; DRAW TARGET WINDOW, IF NEEDED
		If Target > 0 Then
	; CREATE A NEW CAM IF NEED BE
			If Target <> LTarget Then
				NPCNumb = 0
				For NPCs.NPC = Each NPC
					If NPCs\zx = zx And NPCs\zy = zy Then
						NPCNumb = NPCNumb + 1
						If NPCNumb = Target Then
							If Not Freed
								FreeEntity camTarget
								FreeEntity mdlTemp
							End If
							Freed = False
							mdlTemp = CopyEntity(NPCs\model)
							lgtTarget = CreateLight(2, mdlTemp)
							MoveEntity lgtTarget, 0, 0, 5
							LightRange lgtTarget, 25
							AnimateMD2 mdlTemp, 0, AnimSpeed, 0, 40
							EntityType mdlTemp, 0
		 				    PositionEntity mdlTemp, -5000, -5000, -5000, True
							camTarget = CreateCamera(mdlTemp)
							CameraProjMode camTarget, 1
							CameraClsColor camTarget, 70, 65, 60
							MoveEntity camTarget, 0, 0, 30
							PointEntity camTarget, mdlTemp
							MoveEntity camTarget, 0, 20, 0
							CameraViewport camTarget, 465, 35, 120, 100
							CameraRange camTarget, 1, 60
							Exit
						End If
					End If
				Next
			End If
	; PUT TARGET AS LAST TARGET
			LTarget = Target
	; DRAW THE WINDOW ITSELF
			DrawImage imgTarget, 450, 10
			NPCNumb = 0
			For NPCs.NPC = Each NPC
				If NPCs\zx = zx And NPCs\zy = zy Then
					NPCNumb = NPCNumb + 1
					If NPCNumb = Target Then
						Color 255, 255, 255
						If Len(NPCs\name) > 22 Then
							ShadowText(460, 16, Mid(NPCs\name, 1, 20) + "...", False, False)
						Else
							ShadowText(460, 16, NPCs\name, False, False)
						End If
						If Len(groups(NPCs\group)\name) > 22 Then
							ShadowText(460, 145, Mid(groups(NPCs\group)\name, 1, 20) + "...", False, False)
						Else
							ShadowText(460, 145, groups(NPCs\group)\name, False, False)
						End If
						If NPCs\ALI < -100 Then
							Color 255, 0, 0
						ElseIf NPCs\ALI > 100 Then
							Color 0, 255, 0
						End If
						OutlineText(525, 45, ALIText(NPCs\ALI), True, True)
						Perc# = NPCs\HEA
						Perc = Perc / NPCs\HEAT * 100
						Per = Perc
						Color 0, 255, 0
						ShadowText(460, 165, "Health: " + Per + "%", False, False)
						Perc# = NPCs\MOR
						Perc = Perc / NPCs\MORT * 100
						Per = Perc
						Color 0, 0, 255
						ShadowText(460, 180, "Morale: " + Per + "%", False, False)
						Color 255, 255, 255
						ReaComp = Float(NPCs\REA) * Float(Cons) * 0.3 + Float(NPCs\REA) * 0.7
						ShadowText(460, 200, "Reaction: " + Reaction(ReaComp), False, False)
						Consider1# = NPCs\ST + NPCs\DE + NPCs\ME + NPCs\DAM * 7 + NPCs\AB * 8
						Consider2# = ST + DE + ME + DAM * 7 + AB * 8
						Consider = Consider1 / Consider2 * 100
						If Consider <= 25
							Color 0, 255, 0
						ElseIf Consider <= 50
							Color 255, 255, 0
						ElseIf Consider <= 100
							Color 255, 128, 64
						Else
							Color 255, 0, 0
						End If
						ShadowText(460, 220, "Consider: " + Consider + "%", False, False)
						Color 255, 255, 255
						If MouseArea(470, 240, 110, 10)
							Color 255, 255, 220
						End If
						ShadowText(525, 245, "Close this window [C]", True, True)
					End If
				End If
			Next
		End If	
		
	; DRAW NORTH INDICATOR
		ang = Wrap360(EntityYaw(mdlKnight))
		If RadarCamEnable Then
			DrawImage imgNorth, 74 + Sin(ang) * 53, 404 - Cos(ang) * 53
		Else
			DrawImage imgNorth, 74 - Sin(ang) * 53, 404 - Cos(ang) * 53
		End If
		
	; DRAW THE GLOBE REFLECTION
		DrawImage imgSphere, 0, 330
			
	; MESSAGES PROCESS
		L_ClearLog(logMsg, 12)
		L_DisplayMessages(logMsg, 253, 340, 226, 119)
		
	; CALCULATE FPS	
		fps = fps + 1
		If timer < MilliSecs() - 1000 Then
			lastfps = fps
			fps = 0
			timer = MilliSecs()
		End If
	
	; DISPLAY THE DEBUG TEXT
		If DebugMode Then
			minu$ = Int(minute)
			If Int(minu) < 10 Then
				minu = "0" + minu
			End If
			If minu = "60" Then
				minu = "00"
			End If
			hr$ = Int(hour)
			If hr = "24" Then
				hr = "0"
			End If
			dayS$ = Int(day)
			If dayS = "366" Then
				dayS = "1"
			End If
			Color 255, 255, 255
			OutlineText(2,0,"FPS: "+lastfps,False,False)
			OutlineText(2,12,"Tris Rendered: "+TrisRendered(),False,False)
			OutlineText(2,24,"Date and Time: "+hr+":"+minu+" on day "+dayS+" of the year "+year,False,False)
			OutlineText(2,36,"Mouse Position: "+MouseX()+", "+MouseY(),False,False)
			OutlineText(2,48,"Zone: "+zx+", "+zy,False,False)
			OutlineText(2,60,"Knight: "+Int(EntityX(mdlKnight))+", "+Int(EntityY(mdlKnight))+", "+Int(EntityZ(mdlKnight)), False, False)
			OutlineText(2,72,"NPCs in Zone: " + (NPC_Total - NPC_Dead), False, False)
		End If
		
	; DISPLAY THE TOOLTIP TEXT
		If tooltip <> lt$ Then
			lt = tooltip
			ttt = MilliSecs()
		ElseIf ttt <= MilliSecs() - 1000
			Color 255, 255, 220
			OutlineText(MouseX(), MouseY() - 8, tooltip, True, True)
		End If
		
	; IF ON MOUSELOOK, DRAW A CENTER POINT
		If MouseLook Then
			Color 255, 255, 255
			Plot scrWidth / 2, (scrHeight - 150) / 2
		End If
			
	; DRAW CURSOR ON TOP OF EVERYTHING
		If Not MouseLook Then
			DrawImage imgCursor, MouseX(), MouseY()
		End If
		
	; FLIP BUFFER TO SCREEN
		Flip
	
		Return
End If

.ShowMap
If Not endedOK Then
	offX = WrapZone(zx - 6)
	offY = WrapZone(zy - 4)

	key = 0
	While key <> 27
		key = GetKey()
		WaitTimer(frmRate)
		Cls
		For XCount = offX To offX + 12
			For YCount = offY To offY + 9
				If zones(WrapZone(XCount), WrapZone(YCount)) <> Null Then
; DRAW ZONE BASE
					xPs = (WrapZone(XCount - offX)) * 50
					yPs = (WrapZone(YCount - offY)) * 50
					Select zones(WrapZone(XCount), WrapZone(YCount))\texture
						Case 1
							Color 58,76,12
						Case 2
							Color 37,67,25
						Case 3
							Color 93,88,83
						Case 4
							Color 96,91,91
						Case 5
							Color 145,119,70
						Case 6
							Color 65,67,36
						Case 7
							Color 39,84,36
						Case 8
							Color 67,101,48
						Case 9
							Color 68,88,52
						Case 10
							Color 88,101,84
					End Select
					Rect xPs, yPs, 50, 50, True					
					Select zones(WrapZone(XCount), WrapZone(YCount))\texture
						Case 1
							Color 157,153,75
						Case 2
							Color 94,124,75
						Case 3
							Color 119,111,107
						Case 4
							Color 151,137,137
						Case 5
							Color 180,143,94
						Case 6
							Color 117,109,75
						Case 7
							Color 79,124,75
						Case 8
							Color 97,128,76
						Case 9
							Color 95,113,75
						Case 10
							Color 103,112,99
					End Select
					Rect xPs + 5, yPs + 5, 40, 40, True
					
; DRAW ZONE EXITS
					Exits(0) = zones(WrapZone(XCount), WrapZone(YCount))\exit1
					Exits(1) = zones(WrapZone(XCount), WrapZone(YCount))\exit2
					Exits(2) = zones(WrapZone(XCount), WrapZone(YCount))\exit3
					Exits(3) = zones(WrapZone(XCount), WrapZone(YCount))\exit4
					Exits(4) = zones(WrapZone(XCount), WrapZone(YCount))\exit5
					For Counter = 0 To 4
						zonID$ = Left(exits(counter), 1)
						If zonID <> "" Then
							extPos = Mid(exits(counter), 2)
							exPs# = extPos
							exPs = exPs / 256 * 50
						End If	
						If zonID = "N" Then
							Rect (WrapZone(XCount - offX)) * 50 + exPs - 2, (WrapZone(YCount - offY)) * 50, 5, 5, True
						ElseIf zonID = "S" Then
							Rect (WrapZone(XCount - offX)) * 50 + exPs - 2, (WrapZone(YCount - offY)) * 50 + 45, 5, 5, True
						ElseIf zonID = "E" Then
							Rect (WrapZone(XCount - offX)) * 50 + 45, (WrapZone(YCount - offY)) * 50 + (50 - exPs) - 2, 5, 5, True
						ElseIf zonID = "W" Then
							Rect (WrapZone(XCount - offX)) * 50, (WrapZone(YCount - offY)) * 50 + (50 - exPs) - 2, 5, 5, True
						End If
					Next

; DRAW UNOPENED TREASURES AND SHOPS AND QUESTS
					For props.Prop = Each Prop
						If props\zx = WrapZone(XCount) And props\zy = WrapZone(YCount) Then
							If props\treasure Then
								exPs1# = Float(props\X) / 2560 * 40
								exPs2# = 40 - Float(props\Y) / 2560 * 40
								DrawImage imgTreasure, (WrapZone(XCount - offX)) * 50 + exPs1 - 2 + 5, (WrapZone(YCount - offY)) * 50 + exPs2 - 2 + 5
							End If
							If props\shop > 0 Then
								exPs1# = Float(props\X) / 2560 * 40
								exPs2# = 40 - Float(props\Y) / 2560 * 40
								DrawImage imgShops, (WrapZone(XCount - offX)) * 50 + exPs1 - 2 + 5, (WrapZone(YCount - offY)) * 50 + exPs2 - 2 + 5
							End If
							If props\quest <> 0 Then
								exPs1# = Float(props\X) / 2560 * 40
								exPs2# = 40 - Float(props\Y) / 2560 * 40
								DrawImage imgQuests, (WrapZone(XCount - offX)) * 50 + exPs1 - 2 + 5, (WrapZone(YCount - offY)) * 50 + exPs2 - 2 + 5
							End If
						End If
					Next	

; DRAW YOU-POINTER AT END
					If zx = WrapZone(XCount) And zy = WrapZone(YCount) Then
						exPs1# = EntityX(mdlKnight) / 2560 * 40
						exPs2# = 40 - EntityZ(mdlKnight) / 2560 * 40
						DrawImage imgYou(Wrap360(Int(EntityYaw(mdlKnight)+90))), (WrapZone(XCount - offX)) * 50 + exPs1 - 2 + 5, (WrapZone(YCount - offY)) * 50 + exPs2 - 2 + 5
					End If
				End If
			Next
		Next
		DrawImage imgMap, 0, 0
		Flip
; HANDLE MAP MOVEMENT		
		If KeyDown(200) Then
			offY = WrapZone(offY - 1)
		End If
		If KeyDown(208) Then
			offY = WrapZone(offY + 1)
		End If
		If KeyDown(203) Then
			offX = WrapZone(offX - 1)
		End If
		If KeyDown(205) Then
			offX = WrapZone(offX + 1)
		End If
	Wend
	FlushKeys
	Return
End If

.SwitchResting
If Not EndedOK Then
	If Rest
		NewMessage$ = "You stop resting."
		Rest = False
		TimeGoing = 1
		FullHealth = False
		AnimateMD2 mdlKnight, 1, AnimSpeed * timeGoing, 0, 40
		AnimateMD2 mdlWeapon, 1, AnimSpeed * timeGoing, 0, 40
	Else
		If NPC_Aggro > 0 Then
			NewMessage$ = "You can't rest while hostiles NPCs are near!"
		Else
			NewMessage$ = "You start resting."
			Rest = True
			TimeGoing = RestSpeed
			If HEA = HEAT And MOR = MORT Then
				FullHealth = True
			End If
			AnimateMD2 mdlKnight, 1, AnimSpeed * timeGoing, 0, 40
			AnimateMD2 mdlWeapon, 1, AnimSpeed * timeGoing, 0, 40
		End If
	End If
	FlushKeys
	For NPCs.NPC = Each NPC
		If NPCs\zx = zx And NPCs\zy = zy And (Not NPCs\Dead) Then
			NPCs\moving = False
			NPCs\turning = False
			NPCs\zoning = False
			AnimateMD2 NPCs\model, 0
			AnimateMD2 NPCs\wpnmodel, 0
		End If
	Next
	L_AddMessage(logMsg, NewMessage$, MsgColors(11))
	Return
End If

.CloseTarget
If Not EndedOK Then
	Target = 0
	LTarget = 0
	If Not Freed Then
		FreeEntity camTarget
		FreeEntity mdlTemp
		camTarget = 0
	End If
	Freed = True
	Return
End If

.EradicateAll
If Not EndedOK Then
	For NPCs.NPC = Each NPC
		Delete NPCs
	Next
	For XCount = 0 To 99
		For YCount = 0 To 99
			Delete Zones(XCount, YCount)
		Next
	Next
	For Count = 0 To GroupCount
		Delete Groups(Count)
	Next
	For Props.Prop = Each Prop
		Delete Props
	Next
	For items.Valuable = Each Valuable
		Delete Items
	Next
	For logs.LogData = Each logData
		Delete Logs
	Next
	NewMessage$ = "Welcome to Wandering Knights v" + versionNumber + "!"
	L_ClearLog(logMsg)
	L_AddMessage(logMsg, NewMessage$, MsgColors(1))
	GodMode = False
	FastMode = False
	Wire = False
	Return
End If

.FinishIt
	For NPCs.NPC = Each NPC
		Delete NPCs
	Next
	For XCount = 0 To 99
		For YCount = 0 To 99
			Delete Zones(XCount, YCount)
		Next
	Next
	For Count = 0 To GroupCount
		Delete Groups(Count)
	Next
	For Props.Prop = Each Prop
		Delete Props
	Next
	For items.Valuable = Each Valuable
		Delete Items
	Next
	For logs.LogData = Each logData
		Delete Logs
	Next
	NewMessage$ = "Welcome to Wandering Knights v" + versionNumber + "!"
	L_AddMessage(logMsg, NewMessage$, MsgColors(1))
	GodMode = False
	FastMode = False
	Wire = False
	